package androidx.camera.core.internal;

import androidx.camera.core.impl.Config;
import androidx.camera.core.impl.ReadableConfig;
import com.android.tools.r8.annotations.SynthesizedClassV2;
/* loaded from: classes.dex */
public interface TargetConfig<T> extends ReadableConfig {
    public static final Config.Option<String> OPTION_TARGET_NAME = Config.Option.create("camerax.core.target.name", String.class);
    public static final Config.Option<Class<?>> OPTION_TARGET_CLASS = Config.Option.create("camerax.core.target.class", Class.class);

    /* loaded from: classes.dex */
    public interface Builder<T, B> {
        B setTargetClass(Class<T> cls);

        B setTargetName(String str);
    }

    Class<T> getTargetClass();

    Class<T> getTargetClass(Class<T> cls);

    String getTargetName();

    String getTargetName(String str);

    @SynthesizedClassV2(kind = 8, versionHash = "ea87655719898b9807d7a88878e9de051d12af172d2fab563c9881b5e404e7d4")
    /* renamed from: androidx.camera.core.internal.TargetConfig$-CC  reason: invalid class name */
    /* loaded from: classes.dex */
    public final /* synthetic */ class CC<T> {
        public static Class $default$getTargetClass(TargetConfig _this, Class cls) {
            return (Class) _this.retrieveOption(TargetConfig.OPTION_TARGET_CLASS, cls);
        }

        public static Class $default$getTargetClass(TargetConfig _this) {
            return (Class) _this.retrieveOption(TargetConfig.OPTION_TARGET_CLASS);
        }

        public static String $default$getTargetName(TargetConfig _this, String str) {
            return (String) _this.retrieveOption(TargetConfig.OPTION_TARGET_NAME, str);
        }

        public static String $default$getTargetName(TargetConfig _this) {
            return (String) _this.retrieveOption(TargetConfig.OPTION_TARGET_NAME);
        }
    }
}
