package com.canhub.cropper.utils;

import android.content.Context;
import android.net.Uri;
import android.util.Log;
import androidx.core.content.FileProvider;
import com.canhub.cropper.common.CommonValues;
import com.canhub.cropper.common.CommonVersionCheck;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.attribute.FileAttribute;
import kotlin.Metadata;
import kotlin.io.ByteStreamsKt;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: GetUriForFile.kt */
@Metadata(d1 = {"\u0000\u0014\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\u001a\u0018\u0010\u0000\u001a\u00020\u00012\u0006\u0010\u0002\u001a\u00020\u00032\u0006\u0010\u0004\u001a\u00020\u0005H\u0000¨\u0006\u0006"}, d2 = {"getUriForFile", "Landroid/net/Uri;", "context", "Landroid/content/Context;", "file", "Ljava/io/File;", "cropper_release"}, k = 2, mv = {1, 5, 1}, xi = 48)
/* loaded from: classes.dex */
public final class GetUriForFileKt {
    /* JADX WARN: Removed duplicated region for block: B:44:0x0101  */
    /* JADX WARN: Removed duplicated region for block: B:45:0x0102 A[Catch: Exception -> 0x010c, TryCatch #3 {Exception -> 0x010c, blocks: (B:6:0x0033, B:12:0x0079, B:49:0x010b, B:48:0x0108, B:45:0x0102, B:37:0x00f4, B:40:0x00fa), top: B:62:0x0033 }] */
    /* JADX WARN: Removed duplicated region for block: B:47:0x0107  */
    /* JADX WARN: Removed duplicated region for block: B:48:0x0108 A[Catch: Exception -> 0x010c, TryCatch #3 {Exception -> 0x010c, blocks: (B:6:0x0033, B:12:0x0079, B:49:0x010b, B:48:0x0108, B:45:0x0102, B:37:0x00f4, B:40:0x00fa), top: B:62:0x0033 }] */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static final Uri getUriForFile(Context context, File file) {
        File externalCacheDir;
        FileOutputStream fileOutputStream;
        Intrinsics.checkNotNullParameter(context, "context");
        Intrinsics.checkNotNullParameter(file, "file");
        String str = context.getPackageName() + CommonValues.authority;
        try {
            Log.i("AIC", "Try get URI for scope storage - content://");
            Uri uriForFile = FileProvider.getUriForFile(context, str, file);
            Intrinsics.checkNotNullExpressionValue(uriForFile, "getUriForFile(context, authority, file)");
            return uriForFile;
        } catch (Exception e) {
            try {
                Log.e("AIC", String.valueOf(e.getMessage()));
                Log.w("AIC", "ANR Risk -- Copying the file the location cache to avoid 'external-files-path' bug for N+ devices");
                File file2 = new File(new File(context.getCacheDir(), CommonValues.CROP_LIB_CACHE), file.getName());
                FileInputStream fileInputStream = null;
                try {
                    FileInputStream fileInputStream2 = new FileInputStream(file);
                    try {
                        fileOutputStream = new FileOutputStream(file2);
                        try {
                            ByteStreamsKt.copyTo$default(fileInputStream2, fileOutputStream, 0, 2, null);
                            Log.i("AIC", "Completed Android N+ file copy. Attempting to return the cached file");
                            Uri uriForFile2 = FileProvider.getUriForFile(context, str, file2);
                            Intrinsics.checkNotNullExpressionValue(uriForFile2, "getUriForFile(context, authority, cacheLocation)");
                            fileInputStream2.close();
                            fileOutputStream.close();
                            return uriForFile2;
                        } catch (Exception e2) {
                            e = e2;
                            fileInputStream = fileInputStream2;
                            try {
                                Log.e("AIC", String.valueOf(e.getMessage()));
                                Log.i("AIC", "Trying to provide URI manually");
                                String str2 = "content://" + str + "/files/my_images/";
                                if (CommonVersionCheck.INSTANCE.isAtLeastO26()) {
                                    Files.createDirectories(Paths.get(str2, new String[0]), new FileAttribute[0]);
                                } else {
                                    File file3 = new File(str2);
                                    if (!file3.exists()) {
                                        file3.mkdirs();
                                    }
                                }
                                Uri parse = Uri.parse(str2 + file.getName());
                                Intrinsics.checkNotNullExpressionValue(parse, "parse(\"$path${file.name}\")");
                                if (fileInputStream != null) {
                                    fileInputStream.close();
                                }
                                if (fileOutputStream != null) {
                                    fileOutputStream.close();
                                }
                                return parse;
                            } catch (Throwable th) {
                                th = th;
                                if (fileInputStream == null) {
                                    fileInputStream.close();
                                }
                                if (fileOutputStream == null) {
                                    fileOutputStream.close();
                                }
                                throw th;
                            }
                        } catch (Throwable th2) {
                            th = th2;
                            fileInputStream = fileInputStream2;
                            if (fileInputStream == null) {
                            }
                            if (fileOutputStream == null) {
                            }
                            throw th;
                        }
                    } catch (Exception e3) {
                        e = e3;
                        fileOutputStream = null;
                    } catch (Throwable th3) {
                        th = th3;
                        fileOutputStream = null;
                    }
                } catch (Exception e4) {
                    e = e4;
                    fileOutputStream = null;
                } catch (Throwable th4) {
                    th = th4;
                    fileOutputStream = null;
                }
            } catch (Exception e5) {
                Log.e("AIC", String.valueOf(e5.getMessage()));
                if (!CommonVersionCheck.INSTANCE.isAtLeastQ29() && (externalCacheDir = context.getExternalCacheDir()) != null) {
                    try {
                        Log.i("AIC", "Use External storage, do not work for OS 29 and above");
                        Uri fromFile = Uri.fromFile(new File(externalCacheDir.getPath(), file.getAbsolutePath()));
                        Intrinsics.checkNotNullExpressionValue(fromFile, "fromFile(File(cacheDir.path, file.absolutePath))");
                        return fromFile;
                    } catch (Exception e6) {
                        Log.e("AIC", String.valueOf(e6.getMessage()));
                        Log.i("AIC", "Try get URI using file://");
                        Uri fromFile2 = Uri.fromFile(file);
                        Intrinsics.checkNotNullExpressionValue(fromFile2, "fromFile(file)");
                        return fromFile2;
                    }
                }
                Log.i("AIC", "Try get URI using file://");
                Uri fromFile22 = Uri.fromFile(file);
                Intrinsics.checkNotNullExpressionValue(fromFile22, "fromFile(file)");
                return fromFile22;
            }
        }
    }
}
