package com.google.android.gms.internal.vision;

import com.google.android.gms.internal.vision.zzgs;
import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
/* compiled from: com.google.android.gms:play-services-vision-common@@19.0.0 */
/* loaded from: classes2.dex */
final class zzii<T> implements zzir<T> {
    private final zzic zzyy;
    private final boolean zzyz;
    private final zzjj<?, ?> zzzi;
    private final zzgf<?> zzzj;

    private zzii(zzjj<?, ?> zzjjVar, zzgf<?> zzgfVar, zzic zzicVar) {
        this.zzzi = zzjjVar;
        this.zzyz = zzgfVar.zze(zzicVar);
        this.zzzj = zzgfVar;
        this.zzyy = zzicVar;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public static <T> zzii<T> zza(zzjj<?, ?> zzjjVar, zzgf<?> zzgfVar, zzic zzicVar) {
        return new zzii<>(zzjjVar, zzgfVar, zzicVar);
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final T newInstance() {
        return (T) this.zzyy.zzgj().zzgb();
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final boolean equals(T t, T t2) {
        if (this.zzzi.zzv(t).equals(this.zzzi.zzv(t2))) {
            if (this.zzyz) {
                return this.zzzj.zze(t).equals(this.zzzj.zze(t2));
            }
            return true;
        }
        return false;
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final int hashCode(T t) {
        int hashCode = this.zzzi.zzv(t).hashCode();
        return this.zzyz ? (hashCode * 53) + this.zzzj.zze(t).hashCode() : hashCode;
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final void zzd(T t, T t2) {
        zzit.zza(this.zzzi, t, t2);
        if (this.zzyz) {
            zzit.zza(this.zzzj, t, t2);
        }
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final void zza(T t, zzkg zzkgVar) throws IOException {
        Iterator<Map.Entry<?, Object>> it = this.zzzj.zze(t).iterator();
        while (it.hasNext()) {
            Map.Entry<?, Object> next = it.next();
            zzgk zzgkVar = (zzgk) next.getKey();
            if (zzgkVar.zzft() != zzkd.MESSAGE || zzgkVar.zzfu() || zzgkVar.zzfv()) {
                throw new IllegalStateException("Found invalid MessageSet item.");
            }
            if (next instanceof zzhf) {
                zzkgVar.zza(zzgkVar.zzag(), (Object) ((zzhf) next).zzgw().zzdk());
            } else {
                zzkgVar.zza(zzgkVar.zzag(), next.getValue());
            }
        }
        zzjj<?, ?> zzjjVar = this.zzzi;
        zzjjVar.zzc(zzjjVar.zzv(t), zzkgVar);
    }

    /* JADX WARN: Removed duplicated region for block: B:32:0x00b9  */
    /* JADX WARN: Removed duplicated region for block: B:57:0x00be A[EDGE_INSN: B:57:0x00be->B:33:0x00be ?: BREAK  , SYNTHETIC] */
    @Override // com.google.android.gms.internal.vision.zzir
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final void zza(T t, byte[] bArr, int i, int i2, zzfb zzfbVar) throws IOException {
        zzgs zzgsVar = (zzgs) t;
        zzjm zzjmVar = zzgsVar.zzwd;
        if (zzjmVar == zzjm.zzig()) {
            zzjmVar = zzjm.zzih();
            zzgsVar.zzwd = zzjmVar;
        }
        zzgi<zzgs.zzd> zzgk = ((zzgs.zze) t).zzgk();
        zzgs.zzg zzgVar = null;
        while (i < i2) {
            int zza = zzez.zza(bArr, i, zzfbVar);
            int i3 = zzfbVar.zzro;
            if (i3 == 11) {
                int i4 = 0;
                zzfh zzfhVar = null;
                while (zza < i2) {
                    zza = zzez.zza(bArr, zza, zzfbVar);
                    int i5 = zzfbVar.zzro;
                    int i6 = i5 >>> 3;
                    int i7 = i5 & 7;
                    if (i6 != 2) {
                        if (i6 == 3) {
                            if (zzgVar != null) {
                                zza = zzez.zza(zzin.zzho().zzf(zzgVar.zzxa.getClass()), bArr, zza, i2, zzfbVar);
                                zzgk.zza((zzgi<zzgs.zzd>) zzgVar.zzxb, zzfbVar.zzrq);
                            } else if (i7 == 2) {
                                zza = zzez.zze(bArr, zza, zzfbVar);
                                zzfhVar = (zzfh) zzfbVar.zzrq;
                            }
                        }
                        if (i5 != 12) {
                            break;
                        }
                        zza = zzez.zza(i5, bArr, zza, i2, zzfbVar);
                    } else if (i7 == 0) {
                        zza = zzez.zza(bArr, zza, zzfbVar);
                        i4 = zzfbVar.zzro;
                        zzgVar = (zzgs.zzg) this.zzzj.zza(zzfbVar.zzcm, this.zzyy, i4);
                    } else if (i5 != 12) {
                    }
                }
                if (zzfhVar != null) {
                    zzjmVar.zzb((i4 << 3) | 2, zzfhVar);
                }
                i = zza;
            } else if ((i3 & 7) == 2) {
                zzgs.zzg zzgVar2 = (zzgs.zzg) this.zzzj.zza(zzfbVar.zzcm, this.zzyy, i3 >>> 3);
                if (zzgVar2 != null) {
                    i = zzez.zza(zzin.zzho().zzf(zzgVar2.zzxa.getClass()), bArr, zza, i2, zzfbVar);
                    zzgk.zza((zzgi<zzgs.zzd>) zzgVar2.zzxb, zzfbVar.zzrq);
                } else {
                    i = zzez.zza(i3, bArr, zza, i2, zzjmVar, zzfbVar);
                }
                zzgVar = zzgVar2;
            } else {
                i = zzez.zza(i3, bArr, zza, i2, zzfbVar);
            }
        }
        if (i != i2) {
            throw zzhc.zzgs();
        }
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final void zza(T t, zzis zzisVar, zzgd zzgdVar) throws IOException {
        boolean z;
        zzjj<?, ?> zzjjVar = this.zzzi;
        zzgf<?> zzgfVar = this.zzzj;
        Object zzw = zzjjVar.zzw(t);
        zzgi<?> zzf = zzgfVar.zzf(t);
        do {
            try {
                if (zzisVar.zzdu() == Integer.MAX_VALUE) {
                    return;
                }
                int tag = zzisVar.getTag();
                if (tag == 11) {
                    Object obj = null;
                    zzfh zzfhVar = null;
                    int i = 0;
                    while (zzisVar.zzdu() != Integer.MAX_VALUE) {
                        int tag2 = zzisVar.getTag();
                        if (tag2 == 16) {
                            i = zzisVar.zzee();
                            obj = zzgfVar.zza(zzgdVar, this.zzyy, i);
                        } else if (tag2 == 26) {
                            if (obj != null) {
                                zzgfVar.zza(zzisVar, obj, zzgdVar, zzf);
                            } else {
                                zzfhVar = zzisVar.zzed();
                            }
                        } else if (!zzisVar.zzdv()) {
                            break;
                        }
                    }
                    if (zzisVar.getTag() != 12) {
                        throw zzhc.zzgq();
                    } else if (zzfhVar != null) {
                        if (obj != null) {
                            zzgfVar.zza(zzfhVar, obj, zzgdVar, zzf);
                        } else {
                            zzjjVar.zza((zzjj<?, ?>) zzw, i, zzfhVar);
                        }
                    }
                } else if ((tag & 7) == 2) {
                    Object zza = zzgfVar.zza(zzgdVar, this.zzyy, tag >>> 3);
                    if (zza != null) {
                        zzgfVar.zza(zzisVar, zza, zzgdVar, zzf);
                    } else {
                        z = zzjjVar.zza((zzjj<?, ?>) zzw, zzisVar);
                        continue;
                    }
                } else {
                    z = zzisVar.zzdv();
                    continue;
                }
                z = true;
                continue;
            } finally {
                zzjjVar.zzg(t, zzw);
            }
        } while (z);
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final void zzg(T t) {
        this.zzzi.zzg(t);
        this.zzzj.zzg(t);
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final boolean zzt(T t) {
        return this.zzzj.zze(t).isInitialized();
    }

    @Override // com.google.android.gms.internal.vision.zzir
    public final int zzr(T t) {
        zzjj<?, ?> zzjjVar = this.zzzi;
        int zzx = zzjjVar.zzx(zzjjVar.zzv(t)) + 0;
        return this.zzyz ? zzx + this.zzzj.zze(t).zzfo() : zzx;
    }
}
