package com.google.android.gms.measurement.internal;

import android.content.Context;
import expo.modules.updates.errorrecovery.ErrorRecoveryHandler;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.apache.commons.lang3.time.DateUtils;
/* compiled from: com.google.android.gms:play-services-measurement-impl@@21.2.0 */
/* loaded from: classes2.dex */
public final class zzdu {
    public static final zzdt zzA;
    public static final zzdt zzB;
    public static final zzdt zzC;
    public static final zzdt zzD;
    public static final zzdt zzE;
    public static final zzdt zzF;
    public static final zzdt zzG;
    public static final zzdt zzH;
    public static final zzdt zzI;
    public static final zzdt zzJ;
    public static final zzdt zzK;
    public static final zzdt zzL;
    public static final zzdt zzM;
    public static final zzdt zzN;
    public static final zzdt zzO;
    public static final zzdt zzP;
    public static final zzdt zzQ;
    public static final zzdt zzR;
    public static final zzdt zzS;
    public static final zzdt zzT;
    public static final zzdt zzU;
    public static final zzdt zzV;
    public static final zzdt zzW;
    public static final zzdt zzX;
    public static final zzdt zzY;
    public static final zzdt zzZ;
    public static final zzdt zzaa;
    public static final zzdt zzab;
    public static final zzdt zzac;
    public static final zzdt zzad;
    public static final zzdt zzae;
    public static final zzdt zzaf;
    public static final zzdt zzag;
    public static final zzdt zzah;
    public static final zzdt zzai;
    public static final zzdt zzaj;
    public static final zzdt zzak;
    public static final zzdt zzal;
    public static final zzdt zzam;
    public static final zzdt zzan;
    public static final zzdt zzao;
    public static final zzdt zzap;
    public static final zzdt zzaq;
    public static final zzdt zzar;
    public static final zzdt zzas;
    public static final zzdt zzat;
    public static final zzdt zzau;
    public static final zzdt zzb;
    public static final zzdt zzc;
    public static final zzdt zzd;
    public static final zzdt zze;
    public static final zzdt zzf;
    public static final zzdt zzg;
    public static final zzdt zzh;
    public static final zzdt zzi;
    public static final zzdt zzj;
    public static final zzdt zzk;
    public static final zzdt zzl;
    public static final zzdt zzm;
    public static final zzdt zzn;
    public static final zzdt zzo;
    public static final zzdt zzp;
    public static final zzdt zzq;
    public static final zzdt zzr;
    public static final zzdt zzs;
    public static final zzdt zzt;
    public static final zzdt zzu;
    public static final zzdt zzv;
    public static final zzdt zzw;
    public static final zzdt zzx;
    public static final zzdt zzy;
    public static final zzdt zzz;
    private static final List zzav = Collections.synchronizedList(new ArrayList());
    private static final Set zzaw = Collections.synchronizedSet(new HashSet());
    public static final zzdt zza = zza("measurement.ad_id_cache_time", 10000L, 10000L, zzbj.zza);

    static {
        Long valueOf = Long.valueOf((long) DateUtils.MILLIS_PER_DAY);
        zzb = zza("measurement.monitoring.sample_period_millis", valueOf, valueOf, zzbb.zza);
        Long valueOf2 = Long.valueOf((long) DateUtils.MILLIS_PER_HOUR);
        zzc = zza("measurement.config.cache_time", valueOf, valueOf2, zzbn.zza);
        zzd = zza("measurement.config.url_scheme", "https", "https", zzbz.zza);
        zze = zza("measurement.config.url_authority", "app-measurement.com", "app-measurement.com", zzcl.zza);
        zzf = zza("measurement.upload.max_bundles", 100, 100, zzcx.zza);
        zzg = zza("measurement.upload.max_batch_size", 65536, 65536, zzdi.zza);
        zzh = zza("measurement.upload.max_bundle_size", 65536, 65536, zzdj.zza);
        zzi = zza("measurement.upload.max_events_per_bundle", 1000, 1000, zzdk.zza);
        zzj = zza("measurement.upload.max_events_per_day", 100000, 100000, zzdl.zza);
        zzk = zza("measurement.upload.max_error_events_per_day", 1000, 1000, zzbu.zza);
        zzl = zza("measurement.upload.max_public_events_per_day", 50000, 50000, zzcf.zza);
        zzm = zza("measurement.upload.max_conversions_per_day", 10000, 10000, zzcq.zza);
        zzn = zza("measurement.upload.max_realtime_events_per_day", 10, 10, zzdb.zza);
        zzo = zza("measurement.store.max_stored_events_per_app", 100000, 100000, zzdm.zza);
        zzp = zza("measurement.upload.url", "https://app-measurement.com/a", "https://app-measurement.com/a", zzdn.zza);
        zzq = zza("measurement.upload.backoff_period", 43200000L, 43200000L, zzdo.zza);
        zzr = zza("measurement.upload.window_interval", valueOf2, valueOf2, zzdp.zza);
        zzs = zza("measurement.upload.interval", valueOf2, valueOf2, zzaz.zza);
        zzt = zza("measurement.upload.realtime_upload_interval", 10000L, 10000L, zzba.zza);
        zzu = zza("measurement.upload.debug_upload_interval", 1000L, 1000L, zzbc.zza);
        zzv = zza("measurement.upload.minimum_delay", 500L, 500L, zzbd.zza);
        Long valueOf3 = Long.valueOf((long) DateUtils.MILLIS_PER_MINUTE);
        zzw = zza("measurement.alarm_manager.minimum_interval", valueOf3, valueOf3, zzbe.zza);
        zzx = zza("measurement.upload.stale_data_deletion_interval", valueOf, valueOf, zzbf.zza);
        zzy = zza("measurement.upload.refresh_blacklisted_config_interval", 604800000L, 604800000L, zzbg.zza);
        zzz = zza("measurement.upload.initial_upload_delay_time", 15000L, 15000L, zzbh.zza);
        zzA = zza("measurement.upload.retry_time", 1800000L, 1800000L, zzbi.zza);
        zzB = zza("measurement.upload.retry_count", 6, 6, zzbk.zza);
        zzC = zza("measurement.upload.max_queue_time", 2419200000L, 2419200000L, zzbl.zza);
        zzD = zza("measurement.lifetimevalue.max_currency_tracked", 4, 4, zzbm.zza);
        zzE = zza("measurement.audience.filter_result_max_count", 200, 200, zzbo.zza);
        zzF = zza("measurement.upload.max_public_user_properties", 25, 25, null);
        zzG = zza("measurement.upload.max_event_name_cardinality", 500, 500, null);
        zzH = zza("measurement.upload.max_public_event_params", 25, 25, null);
        Long valueOf4 = Long.valueOf((long) ErrorRecoveryHandler.REMOTE_LOAD_TIMEOUT_MS);
        zzI = zza("measurement.service_client.idle_disconnect_millis", valueOf4, valueOf4, zzbp.zza);
        zzJ = zza("measurement.test.boolean_flag", false, false, zzbq.zza);
        zzK = zza("measurement.test.string_flag", "---", "---", zzbr.zza);
        zzL = zza("measurement.test.long_flag", -1L, -1L, zzbs.zza);
        zzM = zza("measurement.test.int_flag", -2, -2, zzbt.zza);
        Double valueOf5 = Double.valueOf(-3.0d);
        zzN = zza("measurement.test.double_flag", valueOf5, valueOf5, zzbv.zza);
        zzO = zza("measurement.experiment.max_ids", 50, 50, zzbw.zza);
        zzP = zza("measurement.max_bundles_per_iteration", 100, 100, zzbx.zza);
        zzQ = zza("measurement.sdk.attribution.cache.ttl", 604800000L, 604800000L, zzby.zza);
        zzR = zza("measurement.redaction.app_instance_id.ttl", 7200000L, 7200000L, zzca.zza);
        zzS = zza("measurement.collection.log_event_and_bundle_v2", true, true, zzcb.zza);
        zzT = zza("measurement.quality.checksum", false, false, null);
        zzU = zza("measurement.audience.use_bundle_end_timestamp_for_non_sequence_property_filters", false, false, zzcc.zza);
        zzV = zza("measurement.audience.refresh_event_count_filters_timestamp", false, false, zzcd.zza);
        zzW = zza("measurement.audience.use_bundle_timestamp_for_event_count_filters", false, false, zzce.zza);
        zzX = zza("measurement.sdk.collection.retrieve_deeplink_from_bow_2", true, true, zzcg.zza);
        zzY = zza("measurement.sdk.collection.last_deep_link_referrer_campaign2", false, false, zzch.zza);
        zzZ = zza("measurement.lifecycle.app_in_background_parameter", false, false, zzci.zza);
        zzaa = zza("measurement.integration.disable_firebase_instance_id", false, false, zzcj.zza);
        zzab = zza("measurement.collection.service.update_with_analytics_fix", false, false, zzck.zza);
        zzac = zza("measurement.client.firebase_feature_rollout.v1.enable", true, true, zzcm.zza);
        zzad = zza("measurement.client.sessions.check_on_reset_and_enable2", true, true, zzcn.zza);
        zzae = zza("measurement.collection.synthetic_data_mitigation", false, false, zzco.zza);
        zzaf = zza("measurement.service.storage_consent_support_version", 203600, 203600, zzcp.zza);
        zzag = zza("measurement.client.click_identifier_control.dev", false, false, zzcr.zza);
        zzah = zza("measurement.service.click_identifier_control", false, false, zzcs.zza);
        zzai = zza("measurement.service.store_null_safelist", true, true, zzct.zza);
        zzaj = zza("measurement.service.store_safelist", true, true, zzcu.zza);
        zzak = zza("measurement.collection.enable_session_stitching_token.service", false, false, zzcv.zza);
        zzal = zza("measurement.collection.enable_session_stitching_token.service_new", true, true, zzcw.zza);
        zzam = zza("measurement.collection.enable_session_stitching_token.client.dev", true, true, zzcy.zza);
        zzan = zza("measurement.session_stitching_token_enabled", false, false, zzcz.zza);
        zzao = zza("measurement.redaction.e_tag", true, true, zzda.zza);
        zzap = zza("measurement.redaction.client_ephemeral_aiid_generation", true, true, zzdc.zza);
        zzaq = zza("measurement.redaction.retain_major_os_version", true, true, zzdd.zza);
        zzar = zza("measurement.redaction.scion_payload_generator", true, true, zzde.zza);
        zzas = zza("measurement.audience.dynamic_filters.oob_fix", true, true, zzdf.zza);
        zzat = zza("measurement.service.clear_global_params_on_uninstall", true, true, zzdg.zza);
        zzau = zza("measurement.sessionid.enable_client_session_id", true, true, zzdh.zza);
    }

    static zzdt zza(String str, Object obj, Object obj2, zzdq zzdqVar) {
        zzdt zzdtVar = new zzdt(str, obj, obj2, zzdqVar, null);
        zzav.add(zzdtVar);
        return zzdtVar;
    }

    public static Map zzc(Context context) {
        com.google.android.gms.internal.measurement.zzhf zza2 = com.google.android.gms.internal.measurement.zzhf.zza(context.getContentResolver(), com.google.android.gms.internal.measurement.zzhq.zza("com.google.android.gms.measurement"), zzay.zza);
        return zza2 == null ? Collections.emptyMap() : zza2.zzc();
    }
}
