package com.horcrux.svg;

import android.graphics.Path;
import android.graphics.PathMeasure;
import android.graphics.PointF;
import android.view.View;
import com.horcrux.svg.TextProperties;
import java.util.ArrayList;
/* loaded from: classes2.dex */
class TextLayoutAlgorithm {
    TextLayoutAlgorithm() {
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* loaded from: classes2.dex */
    public class CharacterInformation {
        double advance;
        char character;
        TextView element;
        int index;
        double x = 0.0d;
        double y = 0.0d;
        double rotate = 0.0d;
        boolean hidden = false;
        boolean middle = false;
        boolean resolved = false;
        boolean xSpecified = false;
        boolean ySpecified = false;
        boolean addressable = true;
        boolean anchoredChunk = false;
        boolean rotateSpecified = false;
        boolean firstCharacterInResolvedDescendant = false;

        CharacterInformation(int i, char c) {
            this.index = i;
            this.character = c;
        }
    }

    /* loaded from: classes2.dex */
    class LayoutInput {
        boolean horizontal;
        TextView text;

        LayoutInput() {
        }
    }

    private void getSubTreeTypographicCharacterPositions(ArrayList<TextPathView> arrayList, ArrayList<TextView> arrayList2, StringBuilder sb, View view, TextPathView textPathView) {
        int i = 0;
        if (view instanceof TSpanView) {
            TSpanView tSpanView = (TSpanView) view;
            String str = tSpanView.mContent;
            if (str == null) {
                while (i < tSpanView.getChildCount()) {
                    getSubTreeTypographicCharacterPositions(arrayList, arrayList2, sb, tSpanView.getChildAt(i), textPathView);
                    i++;
                }
                return;
            }
            while (i < str.length()) {
                arrayList2.add(tSpanView);
                arrayList.add(textPathView);
                i++;
            }
            sb.append(str);
            return;
        }
        if (view instanceof TextPathView) {
            textPathView = (TextPathView) view;
        }
        while (i < textPathView.getChildCount()) {
            getSubTreeTypographicCharacterPositions(arrayList, arrayList2, sb, textPathView.getChildAt(i), textPathView);
            i++;
        }
    }

    /* JADX WARN: Code restructure failed: missing block: B:66:0x0196, code lost:
        if (r18 == Double.POSITIVE_INFINITY) goto L105;
     */
    /* JADX WARN: Code restructure failed: missing block: B:70:0x019d, code lost:
        if (r4 == (r10 - 1)) goto L78;
     */
    /* JADX WARN: Code restructure failed: missing block: B:71:0x019f, code lost:
        r12 = com.horcrux.svg.TextProperties.TextAnchor.start;
        r13 = com.horcrux.svg.TextProperties.Direction.ltr;
        r14 = r10 - 1;
     */
    /* JADX WARN: Code restructure failed: missing block: B:72:0x01a5, code lost:
        if (r4 != r14) goto L81;
     */
    /* JADX WARN: Code restructure failed: missing block: B:73:0x01a7, code lost:
        r16 = r0;
        r18 = r5;
     */
    /* JADX WARN: Code restructure failed: missing block: B:74:0x01ab, code lost:
        r2 = r11[r8].x;
        r12 = com.horcrux.svg.TextLayoutAlgorithm.AnonymousClass1.$SwitchMap$com$horcrux$svg$TextProperties$TextAnchor[r12.ordinal()];
     */
    /* JADX WARN: Code restructure failed: missing block: B:75:0x01b8, code lost:
        if (r12 == 1) goto L103;
     */
    /* JADX WARN: Code restructure failed: missing block: B:77:0x01bb, code lost:
        if (r12 == 2) goto L102;
     */
    /* JADX WARN: Code restructure failed: missing block: B:79:0x01be, code lost:
        if (r12 == 3) goto L87;
     */
    /* JADX WARN: Code restructure failed: missing block: B:82:0x01c3, code lost:
        if (r13 != com.horcrux.svg.TextProperties.Direction.ltr) goto L89;
     */
    /* JADX WARN: Code restructure failed: missing block: B:84:0x01c6, code lost:
        r12 = com.horcrux.svg.TextProperties.Direction.ltr;
        r2 = r2 - ((r18 + r16) / 2.0d);
     */
    /* JADX WARN: Code restructure failed: missing block: B:86:0x01d0, code lost:
        if (r13 != com.horcrux.svg.TextProperties.Direction.ltr) goto L90;
     */
    /* JADX WARN: Code restructure failed: missing block: B:87:0x01d2, code lost:
        r2 = r2 - r18;
     */
    /* JADX WARN: Code restructure failed: missing block: B:88:0x01d5, code lost:
        r2 = r2 - r16;
     */
    /* JADX WARN: Code restructure failed: missing block: B:89:0x01d7, code lost:
        if (r4 != r14) goto L101;
     */
    /* JADX WARN: Code restructure failed: missing block: B:90:0x01d9, code lost:
        r12 = r4;
     */
    /* JADX WARN: Code restructure failed: missing block: B:91:0x01db, code lost:
        r12 = r4 - 1;
     */
    /* JADX WARN: Code restructure failed: missing block: B:92:0x01dd, code lost:
        if (r8 > r12) goto L96;
     */
    /* JADX WARN: Code restructure failed: missing block: B:93:0x01df, code lost:
        r11[r8].x += r2;
        r8 = r8 + 1;
     */
    /* JADX WARN: Code restructure failed: missing block: B:94:0x01e9, code lost:
        r8 = r4;
     */
    /* JADX WARN: Code restructure failed: missing block: B:95:0x01ea, code lost:
        r20 = r16;
        r16 = r0;
     */
    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Removed duplicated region for block: B:153:0x02e3  */
    /* JADX WARN: Removed duplicated region for block: B:154:0x0314  */
    /* JADX WARN: Type inference failed for: r1v6, types: [com.horcrux.svg.TextLayoutAlgorithm$1TextLengthResolver] */
    /* JADX WARN: Type inference failed for: r3v3 */
    /* JADX WARN: Type inference failed for: r3v4, types: [android.graphics.Canvas, android.graphics.Paint] */
    /* JADX WARN: Type inference failed for: r3v5 */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    CharacterInformation[] layoutText(LayoutInput layoutInput) {
        PathMeasure pathMeasure;
        boolean z;
        ArrayList<TextPathView> arrayList;
        int i;
        Object obj;
        Path path;
        char c;
        float[] fArr;
        double d;
        TextView textView = layoutInput.text;
        StringBuilder sb = new StringBuilder();
        ArrayList<TextView> arrayList2 = new ArrayList<>();
        ArrayList<TextPathView> arrayList3 = new ArrayList<>();
        getSubTreeTypographicCharacterPositions(arrayList3, arrayList2, sb, textView, null);
        char[] charArray = sb.toString().toCharArray();
        int length = charArray.length;
        final CharacterInformation[] characterInformationArr = new CharacterInformation[length];
        for (int i2 = 0; i2 < length; i2++) {
            characterInformationArr[i2] = new CharacterInformation(i2, charArray[i2]);
        }
        if (length == 0) {
            return characterInformationArr;
        }
        PointF[] pointFArr = new PointF[length];
        for (int i3 = 0; i3 < length; i3++) {
            pointFArr[i3] = new PointF(0.0f, 0.0f);
        }
        int i4 = 0;
        while (true) {
            if (i4 >= length) {
                break;
            }
            characterInformationArr[i4].addressable = true;
            characterInformationArr[i4].middle = false;
            characterInformationArr[i4].anchoredChunk = i4 == 0;
            if (characterInformationArr[i4].addressable && !characterInformationArr[i4].middle) {
                pointFArr[i4].set(0.0f, 0.0f);
            } else if (i4 > 0) {
                pointFArr[i4].set(pointFArr[i4 - 1]);
            }
            i4++;
        }
        String[] strArr = new String[length];
        String[] strArr2 = new String[length];
        new Object(characterInformationArr, strArr, strArr2, new String[length], new String[length]) { // from class: com.horcrux.svg.TextLayoutAlgorithm.1CharacterPositioningResolver
            private int global = 0;
            private boolean horizontal = true;
            private boolean in_text_path = false;
            private String[] resolve_dx;
            private String[] resolve_dy;
            private String[] resolve_x;
            private String[] resolve_y;
            private CharacterInformation[] result;

            {
                this.result = characterInformationArr;
                this.resolve_x = strArr;
                this.resolve_y = strArr2;
                this.resolve_dx = r6;
                this.resolve_dy = r7;
            }

            private void resolveCharacterPositioning(TextView textView2) {
                if (textView2.getClass() == TextView.class || textView2.getClass() == TSpanView.class) {
                    int i5 = this.global;
                    String[] strArr3 = new String[0];
                    String[] strArr4 = new String[0];
                    String[] strArr5 = new String[0];
                    String[] strArr6 = new String[0];
                    double[] dArr = new double[0];
                    int max = !this.in_text_path ? Math.max(0, 0) : 0;
                    String str = ((TSpanView) textView2).mContent;
                    int length2 = str == null ? 0 : str.length();
                    int i6 = 0;
                    for (int i7 = 0; i7 < length2; i7++) {
                        int i8 = i5 + i7;
                        if (this.result[i8].addressable) {
                            this.result[i8].anchoredChunk = i6 < max;
                            if (i6 < 0) {
                                this.resolve_x[i8] = strArr3[i6];
                            }
                            boolean z2 = this.in_text_path;
                            if (z2 && !this.horizontal) {
                                this.resolve_x[i5] = "";
                            }
                            if (i6 < 0) {
                                this.resolve_y[i8] = strArr4[i6];
                            }
                            if (z2 && this.horizontal) {
                                this.resolve_y[i5] = "";
                            }
                            if (i6 < 0) {
                                this.resolve_dx[i8] = strArr5[i6];
                            }
                            if (i6 < 0) {
                                this.resolve_dy[i8] = strArr6[i6];
                            }
                            if (i6 < 0) {
                                this.result[i8].rotate = dArr[i6];
                            }
                        }
                        i6++;
                    }
                } else if (textView2.getClass() == TextPathView.class) {
                    this.result[this.global].anchoredChunk = true;
                    this.in_text_path = true;
                    for (int i9 = 0; i9 < textView2.getChildCount(); i9++) {
                        resolveCharacterPositioning((TextView) textView2.getChildAt(i9));
                    }
                    if (textView2 instanceof TextPathView) {
                        this.in_text_path = false;
                    }
                }
            }
        };
        PointF pointF = new PointF(0.0f, 0.0f);
        for (int i5 = 0; i5 < length; i5++) {
            if (strArr[i5].equals("")) {
                strArr[i5] = "0";
            }
            if (strArr2[i5].equals("")) {
                strArr2[i5] = "0";
            }
            pointF.x += Float.parseFloat(strArr[i5]);
            pointF.y += Float.parseFloat(strArr2[i5]);
            characterInformationArr[i5].x = pointFArr[i5].x + pointF.x;
            characterInformationArr[i5].y = pointFArr[i5].y + pointF.y;
        }
        new Object() { // from class: com.horcrux.svg.TextLayoutAlgorithm.1TextLengthResolver
            int global;

            /* JADX INFO: Access modifiers changed from: private */
            public void resolveTextLength(TextView textView2) {
                int i6;
                Class<?> cls = textView2.getClass();
                boolean z2 = textView2.mTextLength != null;
                if (cls == TSpanView.class && z2) {
                    TSpanView tSpanView = (TSpanView) textView2;
                    String str = tSpanView.mContent;
                    int i7 = this.global;
                    int length2 = (str == null ? 0 : str.length()) + i7;
                    double d2 = Double.NEGATIVE_INFINITY;
                    int i8 = i7;
                    double d3 = Double.POSITIVE_INFINITY;
                    while (i8 <= length2) {
                        if (characterInformationArr[i7].addressable) {
                            char c2 = characterInformationArr[i7].character;
                            if (c2 == '\n' || c2 == '\r') {
                                return;
                            }
                            double d4 = characterInformationArr[i8].x;
                            i6 = i7;
                            double d5 = characterInformationArr[i8].advance + d4;
                            d3 = Math.min(d3, Math.min(d4, d5));
                            d2 = Math.max(d2, Math.max(d4, d5));
                        } else {
                            i6 = i7;
                        }
                        i8++;
                        i7 = i6;
                    }
                    int i9 = i7;
                    if (d3 != Double.POSITIVE_INFINITY) {
                        double d6 = textView2.mTextLength.value - (d2 - d3);
                        int i10 = 0;
                        int i11 = 0;
                        for (int i12 = 0; i12 < textView2.getChildCount(); i12++) {
                            if (((TextPathView) textView2.getChildAt(i12)).mTextLength == null) {
                                String str2 = tSpanView.mContent;
                                i10 += str2 == null ? 0 : str2.length();
                            } else {
                                characterInformationArr[i10].firstCharacterInResolvedDescendant = true;
                                i11++;
                            }
                        }
                        double d7 = d6 / (i10 + (i11 - 1));
                        double d8 = 0.0d;
                        for (int i13 = i9; i13 <= length2; i13++) {
                            characterInformationArr[i13].x += d8;
                            if (!characterInformationArr[i13].middle && (!characterInformationArr[i13].resolved || characterInformationArr[i13].firstCharacterInResolvedDescendant)) {
                                d8 += d7;
                            }
                        }
                    }
                }
            }
        }.resolveTextLength(textView);
        pointF.set(0.0f, 0.0f);
        int i6 = 1;
        while (i6 < length) {
            String str = strArr[i6];
            if (str != null) {
                pointF.x = (float) (Double.parseDouble(str) - characterInformationArr[i6].x);
            }
            String str2 = strArr2[i6];
            if (str2 != null) {
                pointF.y = (float) (Double.parseDouble(str2) - characterInformationArr[i6].y);
            }
            characterInformationArr[i6].x += pointF.x;
            characterInformationArr[i6].y += pointF.y;
            if (characterInformationArr[i6].middle && characterInformationArr[i6].anchoredChunk) {
                characterInformationArr[i6].anchoredChunk = false;
            }
            i6++;
            if (i6 < length) {
                characterInformationArr[i6].anchoredChunk = true;
            }
        }
        int i7 = 0;
        double d2 = Double.POSITIVE_INFINITY;
        int i8 = 0;
        double d3 = Double.NEGATIVE_INFINITY;
        double d4 = Double.POSITIVE_INFINITY;
        double d5 = Double.NEGATIVE_INFINITY;
        while (i7 < length) {
            if (characterInformationArr[i7].addressable) {
                if (characterInformationArr[i7].anchoredChunk) {
                    d4 = d2;
                    d2 = Double.POSITIVE_INFINITY;
                    d = Double.NEGATIVE_INFINITY;
                } else {
                    d = d3;
                    d3 = d5;
                }
                double d6 = characterInformationArr[i7].x;
                double d7 = characterInformationArr[i7].advance + d6;
                d2 = Math.min(d2, Math.min(d6, d7));
                double max = Math.max(d, Math.max(d6, d7));
                if (i7 <= 0 || !characterInformationArr[i7].anchoredChunk) {
                }
            }
            i7++;
        }
        PointF pointF2 = new PointF(0.0f, 0.0f);
        PathMeasure pathMeasure2 = new PathMeasure();
        ?? r3 = 0;
        Path path2 = null;
        boolean z2 = false;
        int i9 = 0;
        boolean z3 = false;
        while (i9 < length) {
            TextPathView textPathView = arrayList3.get(i9);
            if (textPathView == 0 || !characterInformationArr[i9].addressable) {
                pathMeasure = pathMeasure2;
                z = z2;
                arrayList = arrayList3;
                i = length;
            } else {
                Path textPath = textPathView.getTextPath(r3, r3);
                if (!characterInformationArr[i9].middle) {
                    textPathView.getSide();
                    TextProperties.TextPathSide textPathSide = TextProperties.TextPathSide.right;
                    pathMeasure2.setPath(textPath, false);
                    double length2 = pathMeasure2.getLength();
                    z = z2;
                    double d8 = textPathView.getStartOffset().value;
                    PathMeasure pathMeasure3 = pathMeasure2;
                    double d9 = characterInformationArr[i9].advance;
                    path = textPath;
                    double d10 = characterInformationArr[i9].x;
                    arrayList = arrayList3;
                    i = length;
                    double d11 = characterInformationArr[i9].y;
                    double d12 = characterInformationArr[i9].rotate;
                    double d13 = d10 + (d9 / 2.0d) + d8;
                    if (!pathMeasure3.isClosed() && (d13 < 0.0d || d13 > length2)) {
                        characterInformationArr[i9].hidden = true;
                    }
                    if (pathMeasure3.isClosed()) {
                        TextProperties.TextAnchor textAnchor = TextProperties.TextAnchor.start;
                        TextProperties.Direction direction = TextProperties.Direction.ltr;
                        double d14 = characterInformationArr[i8].x;
                        int i10 = AnonymousClass1.$SwitchMap$com$horcrux$svg$TextProperties$TextAnchor[textAnchor.ordinal()];
                        if (i10 == 1) {
                            if (direction != TextProperties.Direction.ltr) {
                                c = 1;
                                if (d13 < (-length2) || d13 > 0.0d) {
                                    characterInformationArr[i9].hidden = true;
                                }
                            } else if (d13 < 0.0d || d13 > length2) {
                                c = 1;
                                characterInformationArr[i9].hidden = true;
                            }
                            double d15 = d13 % length2;
                            if (characterInformationArr[i9].hidden) {
                            }
                        } else if (i10 != 2) {
                            if (i10 == 3) {
                                if (direction != TextProperties.Direction.ltr) {
                                    c = 1;
                                    if (d13 < 0.0d || d13 > length2) {
                                        characterInformationArr[i9].hidden = true;
                                    }
                                } else if (d13 < (-length2) || d13 > 0.0d) {
                                    c = 1;
                                    characterInformationArr[i9].hidden = true;
                                }
                                double d152 = d13 % length2;
                                if (characterInformationArr[i9].hidden) {
                                    pathMeasure = pathMeasure3;
                                } else {
                                    pathMeasure = pathMeasure3;
                                    pathMeasure.getPosTan((float) d152, new float[2], new float[2]);
                                    double atan2 = Math.atan2(fArr[c], fArr[0]) * 57.29577951308232d;
                                    double d16 = 90.0d + atan2;
                                    Math.cos(d16);
                                    Math.sin(d16);
                                    characterInformationArr[i9].rotate += atan2;
                                }
                            }
                        } else if (d13 < (-length2) / 2.0d || d13 > length2 / 2.0d) {
                            characterInformationArr[i9].hidden = true;
                        }
                    }
                    c = 1;
                    double d1522 = d13 % length2;
                    if (characterInformationArr[i9].hidden) {
                    }
                } else {
                    pathMeasure = pathMeasure2;
                    z = z2;
                    path = textPath;
                    arrayList = arrayList3;
                    i = length;
                    int i11 = i9 - 1;
                    characterInformationArr[i9].x = characterInformationArr[i11].x;
                    characterInformationArr[i9].y = characterInformationArr[i11].y;
                    characterInformationArr[i9].rotate = characterInformationArr[i11].rotate;
                }
                path2 = path;
                z3 = true;
            }
            if (textPathView == 0 && characterInformationArr[i9].addressable) {
                if (z3) {
                    pathMeasure.setPath(path2, false);
                    float[] fArr2 = new float[2];
                    obj = null;
                    pathMeasure.getPosTan(pathMeasure.getLength(), fArr2, null);
                    pointF2.set(fArr2[0], fArr2[1]);
                    z3 = false;
                    z = true;
                } else {
                    obj = null;
                }
                if (z) {
                    if (characterInformationArr[i9].anchoredChunk) {
                        z = false;
                    } else {
                        characterInformationArr[i9].x += pointF2.x;
                        characterInformationArr[i9].y += pointF2.y;
                    }
                }
            } else {
                obj = null;
            }
            i9++;
            r3 = obj;
            pathMeasure2 = pathMeasure;
            z2 = z;
            arrayList3 = arrayList;
            length = i;
        }
        return characterInformationArr;
    }

    /* renamed from: com.horcrux.svg.TextLayoutAlgorithm$1  reason: invalid class name */
    /* loaded from: classes2.dex */
    static /* synthetic */ class AnonymousClass1 {
        static final /* synthetic */ int[] $SwitchMap$com$horcrux$svg$TextProperties$TextAnchor;

        static {
            int[] iArr = new int[TextProperties.TextAnchor.values().length];
            $SwitchMap$com$horcrux$svg$TextProperties$TextAnchor = iArr;
            try {
                iArr[TextProperties.TextAnchor.start.ordinal()] = 1;
            } catch (NoSuchFieldError unused) {
            }
            try {
                $SwitchMap$com$horcrux$svg$TextProperties$TextAnchor[TextProperties.TextAnchor.middle.ordinal()] = 2;
            } catch (NoSuchFieldError unused2) {
            }
            try {
                $SwitchMap$com$horcrux$svg$TextProperties$TextAnchor[TextProperties.TextAnchor.end.ordinal()] = 3;
            } catch (NoSuchFieldError unused3) {
            }
        }
    }
}
