package com.mrousavy.camera;

import android.hardware.camera2.CameraCharacteristics;
import android.hardware.camera2.CameraManager;
import android.hardware.camera2.params.StreamConfigurationMap;
import android.os.Build;
import android.util.Log;
import android.util.Range;
import android.util.Size;
import androidx.camera.core.CameraInfo;
import androidx.camera.core.CameraSelector;
import androidx.camera.extensions.ExtensionsManager;
import androidx.camera.lifecycle.ProcessCameraProvider;
import androidx.camera.video.Quality;
import androidx.camera.video.QualitySelector;
import com.facebook.hermes.intl.Constants;
import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.bridge.WritableArray;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.uimanager.ViewProps;
import com.google.common.util.concurrent.ListenableFuture;
import com.mrousavy.camera.parsers.ImageFormat_StringKt;
import com.mrousavy.camera.parsers.LenseFacing_StringKt;
import com.mrousavy.camera.parsers.Size_easyKt;
import com.mrousavy.camera.utils.CameraCharacteristicsUtilsKt;
import com.mrousavy.camera.utils.CameraSelector_byIDKt;
import com.mrousavy.camera.utils.WritableMap_NullablesKt;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import kotlin.Metadata;
import kotlin.ResultKt;
import kotlin.Unit;
import kotlin.collections.ArraysKt;
import kotlin.collections.CollectionsKt;
import kotlin.coroutines.Continuation;
import kotlin.coroutines.intrinsics.IntrinsicsKt;
import kotlin.coroutines.jvm.internal.Boxing;
import kotlin.coroutines.jvm.internal.DebugMetadata;
import kotlin.coroutines.jvm.internal.SuspendLambda;
import kotlin.jvm.functions.Function2;
import kotlin.jvm.internal.Intrinsics;
import kotlin.text.StringsKt;
import kotlinx.coroutines.CoroutineScope;
import kotlinx.coroutines.DebugKt;
import kotlinx.coroutines.guava.ListenableFutureKt;
import org.apache.commons.io.IOUtils;
/* compiled from: CameraViewModule.kt */
@Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\u008a@"}, d2 = {"<anonymous>", "", "Lkotlinx/coroutines/CoroutineScope;"}, k = 3, mv = {1, 7, 1}, xi = 48)
@DebugMetadata(c = "com.mrousavy.camera.CameraViewModule$getAvailableCameraDevices$1", f = "CameraViewModule.kt", i = {0, 1, 1, 2, 2, 2}, l = {175, 176, 177}, m = "invokeSuspend", n = {"promise$iv", "promise$iv", "cameraProvider", "promise$iv", "extensionsManager", "cameraProvider"}, s = {"L$0", "L$0", "L$2", "L$0", "L$2", "L$3"})
/* loaded from: classes2.dex */
final class CameraViewModule$getAvailableCameraDevices$1 extends SuspendLambda implements Function2<CoroutineScope, Continuation<? super Unit>, Object> {
    final /* synthetic */ Promise $promise;
    final /* synthetic */ long $startTime;
    long J$0;
    Object L$0;
    Object L$1;
    Object L$2;
    Object L$3;
    int label;
    final /* synthetic */ CameraViewModule this$0;

    /* JADX INFO: Access modifiers changed from: package-private */
    /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
    public CameraViewModule$getAvailableCameraDevices$1(Promise promise, CameraViewModule cameraViewModule, long j, Continuation<? super CameraViewModule$getAvailableCameraDevices$1> continuation) {
        super(2, continuation);
        this.$promise = promise;
        this.this$0 = cameraViewModule;
        this.$startTime = j;
    }

    @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
    public final Continuation<Unit> create(Object obj, Continuation<?> continuation) {
        return new CameraViewModule$getAvailableCameraDevices$1(this.$promise, this.this$0, this.$startTime, continuation);
    }

    @Override // kotlin.jvm.functions.Function2
    public final Object invoke(CoroutineScope coroutineScope, Continuation<? super Unit> continuation) {
        return ((CameraViewModule$getAvailableCameraDevices$1) create(coroutineScope, continuation)).invokeSuspend(Unit.INSTANCE);
    }

    /* JADX WARN: Removed duplicated region for block: B:225:0x06bf A[Catch: all -> 0x06c5, TryCatch #5 {all -> 0x06c5, blocks: (B:8:0x0029, B:32:0x00d5, B:34:0x00e3, B:37:0x00e9, B:41:0x010a, B:46:0x011d, B:47:0x0120, B:48:0x0125, B:49:0x012d, B:56:0x017f, B:222:0x06b7, B:225:0x06bf, B:226:0x06c4, B:18:0x0058, B:24:0x0083, B:21:0x0067), top: B:241:0x000f }] */
    /* JADX WARN: Removed duplicated region for block: B:230:0x06cd  */
    /* JADX WARN: Removed duplicated region for block: B:231:0x06d0  */
    /* JADX WARN: Removed duplicated region for block: B:30:0x00cf A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:31:0x00d0  */
    /* JADX WARN: Removed duplicated region for block: B:34:0x00e3 A[Catch: all -> 0x06c5, TryCatch #5 {all -> 0x06c5, blocks: (B:8:0x0029, B:32:0x00d5, B:34:0x00e3, B:37:0x00e9, B:41:0x010a, B:46:0x011d, B:47:0x0120, B:48:0x0125, B:49:0x012d, B:56:0x017f, B:222:0x06b7, B:225:0x06bf, B:226:0x06c4, B:18:0x0058, B:24:0x0083, B:21:0x0067), top: B:241:0x000f }] */
    /* JADX WARN: Removed duplicated region for block: B:35:0x00e6  */
    /* JADX WARN: Removed duplicated region for block: B:37:0x00e9 A[Catch: all -> 0x06c5, TRY_LEAVE, TryCatch #5 {all -> 0x06c5, blocks: (B:8:0x0029, B:32:0x00d5, B:34:0x00e3, B:37:0x00e9, B:41:0x010a, B:46:0x011d, B:47:0x0120, B:48:0x0125, B:49:0x012d, B:56:0x017f, B:222:0x06b7, B:225:0x06bf, B:226:0x06c4, B:18:0x0058, B:24:0x0083, B:21:0x0067), top: B:241:0x000f }] */
    @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object invokeSuspend(Object obj) {
        Promise promise;
        Promise promise2;
        CameraViewModule cameraViewModule;
        long j;
        ReactApplicationContext reactApplicationContext;
        Object await;
        ReactApplicationContext reactApplicationContext2;
        Object await2;
        CameraViewModule cameraViewModule2;
        ProcessCameraProvider processCameraProvider;
        Promise promise3;
        ReactApplicationContext reactApplicationContext3;
        ListenableFuture<ProcessCameraProvider> processCameraProvider2;
        ProcessCameraProvider processCameraProvider3;
        long j2;
        CameraViewModule cameraViewModule3;
        ExtensionsManager extensionsManager;
        ReactApplicationContext reactApplicationContext4;
        CameraManager cameraManager;
        String str;
        Promise promise4;
        String str2;
        CameraSelector build;
        CameraCharacteristics cameraCharacteristics;
        int intValue;
        int[] iArr;
        Iterator it;
        CameraManager cameraManager2;
        boolean z;
        ReadableArray deviceTypes;
        CameraSelector cameraSelector;
        boolean z2;
        ArrayList emptyList;
        Object next;
        float f;
        WritableMap writableMap;
        int i;
        int[] iArr2;
        int[] iArr3;
        Object obj2;
        Float f2;
        String str3 = "cameraConfig.outputFormats";
        Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        int i2 = this.label;
        try {
        } catch (Throwable th) {
            th = th;
        }
        if (i2 == 0) {
            ResultKt.throwOnFailure(obj);
            promise2 = this.$promise;
            cameraViewModule = this.this$0;
            j = this.$startTime;
            reactApplicationContext = cameraViewModule.getReactApplicationContext();
            ListenableFuture<ProcessCameraProvider> processCameraProvider4 = ProcessCameraProvider.getInstance(reactApplicationContext);
            Intrinsics.checkNotNullExpressionValue(processCameraProvider4, "getInstance(reactApplicationContext)");
            this.L$0 = promise2;
            this.L$1 = cameraViewModule;
            this.J$0 = j;
            this.label = 1;
            await = ListenableFutureKt.await(processCameraProvider4, this);
            if (await == coroutine_suspended) {
                return coroutine_suspended;
            }
        } else if (i2 == 1) {
            j = this.J$0;
            cameraViewModule = (CameraViewModule) this.L$1;
            promise2 = (Promise) this.L$0;
            ResultKt.throwOnFailure(obj);
            await = obj;
        } else if (i2 != 2) {
            if (i2 == 3) {
                j2 = this.J$0;
                processCameraProvider3 = (ProcessCameraProvider) this.L$3;
                extensionsManager = (ExtensionsManager) this.L$2;
                cameraViewModule3 = (CameraViewModule) this.L$1;
                promise = (Promise) this.L$0;
                ResultKt.throwOnFailure(obj);
                reactApplicationContext4 = cameraViewModule3.getReactApplicationContext();
                Object systemService = reactApplicationContext4.getSystemService("camera");
                cameraManager = !(systemService instanceof CameraManager) ? (CameraManager) systemService : null;
                if (cameraManager == null) {
                    WritableArray createArray = Arguments.createArray();
                    Intrinsics.checkNotNullExpressionValue(createArray, "createArray()");
                    String[] cameraIdList = cameraManager.getCameraIdList();
                    Intrinsics.checkNotNullExpressionValue(cameraIdList, "manager.cameraIdList");
                    String[] strArr = cameraIdList;
                    ArrayList arrayList = new ArrayList();
                    int length = strArr.length;
                    int i3 = 0;
                    while (true) {
                        str = "id";
                        if (i3 >= length) {
                            break;
                        }
                        String str4 = strArr[i3];
                        String id = str4;
                        Intrinsics.checkNotNullExpressionValue(id, "id");
                        if (StringsKt.toIntOrNull(id) != null) {
                            arrayList.add(str4);
                        }
                        i3++;
                    }
                    Iterator it2 = arrayList.iterator();
                    while (it2.hasNext()) {
                        try {
                            str2 = (String) it2.next();
                            CameraSelector.Builder builder = new CameraSelector.Builder();
                            Intrinsics.checkNotNullExpressionValue(str2, str);
                            build = CameraSelector_byIDKt.byID(builder, str2).build();
                            Intrinsics.checkNotNullExpressionValue(build, "Builder().byID(id).build()");
                            cameraCharacteristics = cameraManager.getCameraCharacteristics(str2);
                            Intrinsics.checkNotNullExpressionValue(cameraCharacteristics, "manager.getCameraCharacteristics(id)");
                            Object obj3 = cameraCharacteristics.get(CameraCharacteristics.INFO_SUPPORTED_HARDWARE_LEVEL);
                            Intrinsics.checkNotNull(obj3);
                            intValue = ((Number) obj3).intValue();
                            Object obj4 = cameraCharacteristics.get(CameraCharacteristics.REQUEST_AVAILABLE_CAPABILITIES);
                            Intrinsics.checkNotNull(obj4);
                            iArr = (int[]) obj4;
                            it = it2;
                            cameraManager2 = cameraManager;
                            z = Build.VERSION.SDK_INT >= 28 && ArraysKt.contains(iArr, 11);
                            deviceTypes = CameraCharacteristicsUtilsKt.getDeviceTypes(cameraCharacteristics);
                            promise4 = promise;
                        } catch (Throwable th2) {
                            th = th2;
                            th.printStackTrace();
                            UnknownCameraError unknownCameraError = th instanceof CameraError ? th : new UnknownCameraError(th);
                            promise.reject(unknownCameraError.getDomain() + IOUtils.DIR_SEPARATOR_UNIX + unknownCameraError.getId(), unknownCameraError.getMessage(), unknownCameraError.getCause());
                            return Unit.INSTANCE;
                        }
                        try {
                            Object obj5 = cameraCharacteristics.get(CameraCharacteristics.SCALER_STREAM_CONFIGURATION_MAP);
                            Intrinsics.checkNotNull(obj5);
                            StreamConfigurationMap streamConfigurationMap = (StreamConfigurationMap) obj5;
                            long j3 = j2;
                            Object obj6 = cameraCharacteristics.get(CameraCharacteristics.LENS_FACING);
                            Intrinsics.checkNotNull(obj6);
                            int intValue2 = ((Number) obj6).intValue();
                            Object obj7 = cameraCharacteristics.get(CameraCharacteristics.FLASH_INFO_AVAILABLE);
                            Intrinsics.checkNotNull(obj7);
                            boolean booleanValue = ((Boolean) obj7).booleanValue();
                            WritableArray writableArray = createArray;
                            Object obj8 = cameraCharacteristics.get(CameraCharacteristics.SCALER_AVAILABLE_MAX_DIGITAL_ZOOM);
                            Intrinsics.checkNotNull(obj8);
                            float floatValue = ((Number) obj8).floatValue();
                            Object obj9 = "CameraView";
                            String str5 = str3;
                            boolean z3 = Build.VERSION.SDK_INT >= 23 && ArraysKt.contains(iArr, 8);
                            boolean contains = ArraysKt.contains(iArr, 3);
                            Range range = (Range) cameraCharacteristics.get(CameraCharacteristics.SENSOR_INFO_SENSITIVITY_RANGE);
                            int[] iArr4 = (int[]) cameraCharacteristics.get(CameraCharacteristics.CONTROL_AVAILABLE_VIDEO_STABILIZATION_MODES);
                            int[] iArr5 = (int[]) cameraCharacteristics.get(CameraCharacteristics.LENS_INFO_AVAILABLE_OPTICAL_STABILIZATION);
                            StreamConfigurationMap streamConfigurationMap2 = streamConfigurationMap;
                            Range range2 = Build.VERSION.SDK_INT >= 30 ? (Range) cameraCharacteristics.get(CameraCharacteristics.CONTROL_ZOOM_RATIO_RANGE) : null;
                            ProcessCameraProvider processCameraProvider5 = processCameraProvider3;
                            String str6 = Build.VERSION.SDK_INT >= 28 ? (String) cameraCharacteristics.get(CameraCharacteristics.INFO_VERSION) : null;
                            Object obj10 = cameraCharacteristics.get(CameraCharacteristics.CONTROL_AE_AVAILABLE_TARGET_FPS_RANGES);
                            Intrinsics.checkNotNull(obj10);
                            Range[] rangeArr = (Range[]) obj10;
                            boolean isExtensionAvailable = extensionsManager.isExtensionAvailable(build, 2);
                            boolean isExtensionAvailable2 = extensionsManager.isExtensionAvailable(build, 3);
                            if (intValue == 2 || intValue == 0) {
                                cameraSelector = build;
                                z2 = false;
                            } else {
                                cameraSelector = build;
                                z2 = true;
                            }
                            double fieldOfView = CameraCharacteristicsUtilsKt.getFieldOfView(cameraCharacteristics);
                            WritableMap createMap = Arguments.createMap();
                            createMap.putString(str, str2);
                            String str7 = str;
                            createMap.putArray("devices", deviceTypes);
                            createMap.putString(ViewProps.POSITION, LenseFacing_StringKt.parseLensFacing(Boxing.boxInt(intValue2)));
                            if (str6 == null) {
                                str6 = LenseFacing_StringKt.parseLensFacing(Boxing.boxInt(intValue2)) + " (" + str2 + ')';
                            }
                            createMap.putString("name", str6);
                            createMap.putBoolean("hasFlash", booleanValue);
                            createMap.putBoolean("hasTorch", booleanValue);
                            createMap.putBoolean("isMultiCam", z);
                            createMap.putBoolean("supportsParallelVideoProcessing", z2);
                            createMap.putBoolean("supportsRawCapture", contains);
                            createMap.putBoolean("supportsDepthCapture", z3);
                            createMap.putBoolean("supportsLowLightBoost", isExtensionAvailable2);
                            createMap.putBoolean("supportsFocus", true);
                            if (range2 != null) {
                                createMap.putDouble("minZoom", ((Number) range2.getLower()).floatValue());
                                createMap.putDouble("maxZoom", ((Number) range2.getUpper()).floatValue());
                            } else {
                                createMap.putDouble("minZoom", 1.0d);
                                createMap.putDouble("maxZoom", floatValue);
                            }
                            createMap.putDouble("neutralZoom", 1.0d);
                            List<CameraInfo> filter = cameraSelector.filter(processCameraProvider5.getAvailableCameraInfos());
                            Intrinsics.checkNotNullExpressionValue(filter, "cameraSelector.filter(ca…der.availableCameraInfos)");
                            if (filter.size() > 0) {
                                List<Quality> supportedQualities = QualitySelector.getSupportedQualities(filter.get(0));
                                Intrinsics.checkNotNullExpressionValue(supportedQualities, "getSupportedQualities(cameraInfos[0])");
                                List<Quality> list = supportedQualities;
                                ArrayList arrayList2 = new ArrayList(CollectionsKt.collectionSizeOrDefault(list, 10));
                                for (Quality quality : list) {
                                    Size resolution = QualitySelector.getResolution(filter.get(0), quality);
                                    Intrinsics.checkNotNull(resolution);
                                    arrayList2.add(resolution);
                                }
                                emptyList = arrayList2;
                            } else {
                                emptyList = CollectionsKt.emptyList();
                            }
                            int[] outputFormats = streamConfigurationMap2.getOutputFormats();
                            String str8 = str5;
                            Intrinsics.checkNotNullExpressionValue(outputFormats, str8);
                            ArrayList arrayList3 = new ArrayList();
                            int length2 = outputFormats.length;
                            int i4 = 0;
                            while (i4 < length2) {
                                StreamConfigurationMap streamConfigurationMap3 = streamConfigurationMap2;
                                Size[] outputSizes = streamConfigurationMap3.getOutputSizes(outputFormats[i4]);
                                Intrinsics.checkNotNullExpressionValue(outputSizes, "cameraConfig.getOutputSizes(it)");
                                CollectionsKt.addAll(arrayList3, ArraysKt.toList(outputSizes));
                                i4++;
                                streamConfigurationMap2 = streamConfigurationMap3;
                            }
                            StreamConfigurationMap streamConfigurationMap4 = streamConfigurationMap2;
                            Iterator it3 = arrayList3.iterator();
                            if (it3.hasNext()) {
                                next = it3.next();
                                if (it3.hasNext()) {
                                    Size size = (Size) next;
                                    int width = size.getWidth() * size.getHeight();
                                    while (true) {
                                        Object next2 = it3.next();
                                        Size size2 = (Size) next2;
                                        int width2 = size2.getWidth() * size2.getHeight();
                                        if (width < width2) {
                                            next = next2;
                                            width = width2;
                                        }
                                        if (!it3.hasNext()) {
                                            break;
                                        }
                                    }
                                }
                            } else {
                                next = null;
                            }
                            Intrinsics.checkNotNull(next);
                            Size size3 = (Size) next;
                            WritableArray createArray2 = Arguments.createArray();
                            int[] outputFormats2 = streamConfigurationMap4.getOutputFormats();
                            Intrinsics.checkNotNullExpressionValue(outputFormats2, str8);
                            int length3 = outputFormats2.length;
                            int i5 = 0;
                            while (i5 < length3) {
                                int i6 = outputFormats2[i5];
                                String str9 = str8;
                                String parseImageFormat = ImageFormat_StringKt.parseImageFormat(i6);
                                int[] iArr6 = outputFormats2;
                                Size[] outputSizes2 = streamConfigurationMap4.getOutputSizes(i6);
                                int i7 = length3;
                                Intrinsics.checkNotNullExpressionValue(outputSizes2, "cameraConfig.getOutputSizes(formatId)");
                                Size[] sizeArr = outputSizes2;
                                int length4 = sizeArr.length;
                                ExtensionsManager extensionsManager2 = extensionsManager;
                                int i8 = 0;
                                while (i8 < length4) {
                                    Size[] sizeArr2 = sizeArr;
                                    Size size4 = sizeArr[i8];
                                    int i9 = length4;
                                    Intrinsics.checkNotNullExpressionValue(size4, "size");
                                    boolean areUltimatelyEqual = Size_easyKt.areUltimatelyEqual(size4, size3);
                                    int i10 = i8;
                                    int i11 = i5;
                                    Double boxDouble = Boxing.boxDouble(streamConfigurationMap4.getOutputMinFrameDuration(i6, size4) / 1.0E9d);
                                    Object obj11 = obj9;
                                    WritableArray createArray3 = Arguments.createArray();
                                    StreamConfigurationMap streamConfigurationMap5 = streamConfigurationMap4;
                                    Size size5 = size3;
                                    if (boxDouble == null || boxDouble.doubleValue() <= 0.0d) {
                                        f = floatValue;
                                        writableMap = createMap;
                                        i = i6;
                                    } else {
                                        writableMap = createMap;
                                        i = i6;
                                        WritableMap createMap2 = Arguments.createMap();
                                        f = floatValue;
                                        createMap2.putInt("minFrameRate", 1);
                                        createMap2.putInt("maxFrameRate", (int) (1.0d / boxDouble.doubleValue()));
                                        createArray3.pushMap(createMap2);
                                    }
                                    Range[] rangeArr2 = rangeArr;
                                    int length5 = rangeArr2.length;
                                    int i12 = 0;
                                    while (i12 < length5) {
                                        Range range3 = rangeArr2[i12];
                                        Range[] rangeArr3 = rangeArr2;
                                        WritableMap createMap3 = Arguments.createMap();
                                        int i13 = length5;
                                        Comparable lower = range3.getLower();
                                        Object obj12 = obj11;
                                        Intrinsics.checkNotNullExpressionValue(lower, "range.lower");
                                        createMap3.putInt("minFrameRate", ((Number) lower).intValue());
                                        Comparable upper = range3.getUpper();
                                        Intrinsics.checkNotNullExpressionValue(upper, "range.upper");
                                        createMap3.putInt("maxFrameRate", ((Number) upper).intValue());
                                        createArray3.pushMap(createMap3);
                                        i12++;
                                        rangeArr2 = rangeArr3;
                                        length5 = i13;
                                        obj11 = obj12;
                                    }
                                    Object obj13 = obj11;
                                    Range[] rangeArr4 = rangeArr2;
                                    WritableArray createArray4 = Arguments.createArray();
                                    createArray4.pushString(parseImageFormat);
                                    WritableArray createArray5 = Arguments.createArray();
                                    createArray5.pushString(DebugKt.DEBUG_PROPERTY_VALUE_OFF);
                                    if (iArr4 != null) {
                                        iArr2 = iArr4;
                                        if (ArraysKt.contains(iArr2, 1)) {
                                            createArray5.pushString("auto");
                                            createArray5.pushString(Constants.COLLATION_STANDARD);
                                        }
                                    } else {
                                        iArr2 = iArr4;
                                    }
                                    if (iArr5 != null) {
                                        iArr3 = iArr5;
                                        if (ArraysKt.contains(iArr3, 1)) {
                                            createArray5.pushString("cinematic");
                                        }
                                    } else {
                                        iArr3 = iArr5;
                                    }
                                    WritableMap format = Arguments.createMap();
                                    String str10 = parseImageFormat;
                                    iArr4 = iArr2;
                                    iArr5 = iArr3;
                                    format.putDouble("photoHeight", size4.getHeight());
                                    format.putDouble("photoWidth", size4.getWidth());
                                    Iterator it4 = emptyList.iterator();
                                    while (true) {
                                        if (!it4.hasNext()) {
                                            obj2 = null;
                                            break;
                                        }
                                        obj2 = it4.next();
                                        Size size6 = (Size) obj2;
                                        Iterator it5 = it4;
                                        if (size6.getWidth() <= size4.getWidth() && size6.getHeight() <= size4.getHeight()) {
                                            break;
                                        }
                                        it4 = it5;
                                    }
                                    Size size7 = (Size) obj2;
                                    Intrinsics.checkNotNullExpressionValue(format, "format");
                                    WritableMap_NullablesKt.putDouble(format, "videoHeight", size7 != null ? Boxing.boxDouble(size7.getHeight()) : null);
                                    WritableMap_NullablesKt.putDouble(format, "videoWidth", size7 != null ? Boxing.boxDouble(size7.getWidth()) : null);
                                    format.putBoolean("isHighestPhotoQualitySupported", areUltimatelyEqual);
                                    WritableMap_NullablesKt.putInt(format, "maxISO", range != null ? (Integer) range.getUpper() : null);
                                    WritableMap_NullablesKt.putInt(format, "minISO", range != null ? (Integer) range.getLower() : null);
                                    format.putDouble("fieldOfView", fieldOfView);
                                    format.putDouble("maxZoom", (range2 == null || (f2 = (Float) range2.getUpper()) == null) ? f : f2.floatValue());
                                    format.putArray("colorSpaces", createArray4);
                                    format.putBoolean("supportsVideoHDR", false);
                                    format.putBoolean("supportsPhotoHDR", isExtensionAvailable);
                                    format.putArray("frameRateRanges", createArray3);
                                    format.putString("autoFocusSystem", "none");
                                    format.putArray("videoStabilizationModes", createArray5);
                                    format.putString("pixelFormat", "420v");
                                    createArray2.pushMap(format);
                                    i8 = i10 + 1;
                                    parseImageFormat = str10;
                                    createMap = writableMap;
                                    length4 = i9;
                                    sizeArr = sizeArr2;
                                    i5 = i11;
                                    streamConfigurationMap4 = streamConfigurationMap5;
                                    size3 = size5;
                                    floatValue = f;
                                    rangeArr = rangeArr4;
                                    i6 = i;
                                    obj9 = obj13;
                                }
                                i5++;
                                outputFormats2 = iArr6;
                                str8 = str9;
                                length3 = i7;
                                extensionsManager = extensionsManager2;
                                obj9 = obj9;
                            }
                            WritableMap writableMap2 = createMap;
                            writableMap2.putArray("formats", createArray2);
                            writableArray.pushMap(writableMap2);
                            createArray = writableArray;
                            it2 = it;
                            cameraManager = cameraManager2;
                            promise = promise4;
                            j2 = j3;
                            str3 = str8;
                            processCameraProvider3 = processCameraProvider5;
                            extensionsManager = extensionsManager;
                            str = str7;
                        } catch (Throwable th3) {
                            th = th3;
                            promise = promise4;
                            th.printStackTrace();
                            if (th instanceof CameraError) {
                            }
                            promise.reject(unknownCameraError.getDomain() + IOUtils.DIR_SEPARATOR_UNIX + unknownCameraError.getId(), unknownCameraError.getMessage(), unknownCameraError.getCause());
                            return Unit.INSTANCE;
                        }
                    }
                    promise4 = promise;
                    WritableArray writableArray2 = createArray;
                    long currentTimeMillis = System.currentTimeMillis();
                    Log.w("CameraView", "CameraViewModule::getAvailableCameraDevices took: " + (currentTimeMillis - j2) + " ms");
                    promise4.resolve(writableArray2);
                    return Unit.INSTANCE;
                }
                throw new CameraManagerUnavailableError();
            }
            throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
        } else {
            j = this.J$0;
            processCameraProvider = (ProcessCameraProvider) this.L$2;
            cameraViewModule2 = (CameraViewModule) this.L$1;
            promise3 = (Promise) this.L$0;
            try {
                ResultKt.throwOnFailure(obj);
                await2 = obj;
                ExtensionsManager extensionsManager3 = (ExtensionsManager) await2;
                reactApplicationContext3 = cameraViewModule2.getReactApplicationContext();
                processCameraProvider2 = ProcessCameraProvider.getInstance(reactApplicationContext3);
                Intrinsics.checkNotNullExpressionValue(processCameraProvider2, "getInstance(reactApplicationContext)");
                this.L$0 = promise3;
                this.L$1 = cameraViewModule2;
                this.L$2 = extensionsManager3;
                this.L$3 = processCameraProvider;
                this.J$0 = j;
                this.label = 3;
                if (ListenableFutureKt.await(processCameraProvider2, this) != coroutine_suspended) {
                    return coroutine_suspended;
                }
                processCameraProvider3 = processCameraProvider;
                j2 = j;
                cameraViewModule3 = cameraViewModule2;
                promise = promise3;
                extensionsManager = extensionsManager3;
                reactApplicationContext4 = cameraViewModule3.getReactApplicationContext();
                Object systemService2 = reactApplicationContext4.getSystemService("camera");
                if (!(systemService2 instanceof CameraManager)) {
                }
                if (cameraManager == null) {
                }
            } catch (Throwable th4) {
                th = th4;
                promise = promise3;
                th.printStackTrace();
                if (th instanceof CameraError) {
                }
                promise.reject(unknownCameraError.getDomain() + IOUtils.DIR_SEPARATOR_UNIX + unknownCameraError.getId(), unknownCameraError.getMessage(), unknownCameraError.getCause());
                return Unit.INSTANCE;
            }
        }
        ProcessCameraProvider processCameraProvider6 = (ProcessCameraProvider) await;
        reactApplicationContext2 = cameraViewModule.getReactApplicationContext();
        ListenableFuture<ExtensionsManager> instanceAsync = ExtensionsManager.getInstanceAsync(reactApplicationContext2, processCameraProvider6);
        Intrinsics.checkNotNullExpressionValue(instanceAsync, "getInstanceAsync(reactAp…nContext, cameraProvider)");
        this.L$0 = promise2;
        this.L$1 = cameraViewModule;
        this.L$2 = processCameraProvider6;
        this.J$0 = j;
        this.label = 2;
        await2 = ListenableFutureKt.await(instanceAsync, this);
        if (await2 == coroutine_suspended) {
            return coroutine_suspended;
        }
        Promise promise5 = promise2;
        cameraViewModule2 = cameraViewModule;
        processCameraProvider = processCameraProvider6;
        promise3 = promise5;
        ExtensionsManager extensionsManager32 = (ExtensionsManager) await2;
        reactApplicationContext3 = cameraViewModule2.getReactApplicationContext();
        processCameraProvider2 = ProcessCameraProvider.getInstance(reactApplicationContext3);
        Intrinsics.checkNotNullExpressionValue(processCameraProvider2, "getInstance(reactApplicationContext)");
        this.L$0 = promise3;
        this.L$1 = cameraViewModule2;
        this.L$2 = extensionsManager32;
        this.L$3 = processCameraProvider;
        this.J$0 = j;
        this.label = 3;
        if (ListenableFutureKt.await(processCameraProvider2, this) != coroutine_suspended) {
        }
    }
}
