package com.mrousavy.camera;

import android.hardware.camera2.CameraCharacteristics;
import android.util.Log;
import androidx.camera.camera2.interop.Camera2CameraInfo;
import androidx.camera.core.Camera;
import androidx.camera.core.ImageCapture;
import androidx.camera.core.ImageProxy;
import androidx.exifinterface.media.ExifInterface;
import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.WritableMap;
import com.mrousavy.camera.utils.ExifInterface_buildMetadataMapKt;
import com.mrousavy.camera.utils.ImageProxy_isRawKt;
import com.mrousavy.camera.utils.ImageProxy_saveKt;
import java.io.File;
import java.util.List;
import java.util.NoSuchElementException;
import kotlin.Metadata;
import kotlin.ResultKt;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlin.coroutines.intrinsics.IntrinsicsKt;
import kotlin.coroutines.jvm.internal.Boxing;
import kotlin.coroutines.jvm.internal.DebugMetadata;
import kotlin.coroutines.jvm.internal.SuspendLambda;
import kotlin.jvm.functions.Function2;
import kotlin.jvm.internal.Intrinsics;
import kotlin.jvm.internal.Ref;
import kotlin.time.DurationKt;
import kotlinx.coroutines.AwaitKt;
import kotlinx.coroutines.BuildersKt;
import kotlinx.coroutines.BuildersKt__Builders_commonKt;
import kotlinx.coroutines.CoroutineDispatcher;
import kotlinx.coroutines.CoroutineScope;
import kotlinx.coroutines.DebugKt;
import kotlinx.coroutines.Deferred;
import kotlinx.coroutines.Dispatchers;
/* compiled from: CameraView+TakePhoto.kt */
@Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0018\u0002\n\u0002\u0018\u0002\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\u008a@"}, d2 = {"<anonymous>", "Lcom/facebook/react/bridge/WritableMap;", "Lkotlinx/coroutines/CoroutineScope;"}, k = 3, mv = {1, 7, 1}, xi = 48)
@DebugMetadata(c = "com.mrousavy.camera.CameraView_TakePhotoKt$takePhoto$2", f = "CameraView+TakePhoto.kt", i = {1, 1, 1, 2, 2, 2, 2}, l = {22, 68, 87}, m = "invokeSuspend", n = {"lensFacing", "startFunc", "skipMetadata", "photo", "file", "exif", "startFunc"}, s = {"L$0", "J$0", "I$0", "L$0", "L$1", "L$2", "J$0"})
/* loaded from: classes2.dex */
final class CameraView_TakePhotoKt$takePhoto$2 extends SuspendLambda implements Function2<CoroutineScope, Continuation<? super WritableMap>, Object> {
    final /* synthetic */ ReadableMap $options;
    final /* synthetic */ CameraView $this_takePhoto;
    int I$0;
    long J$0;
    private /* synthetic */ Object L$0;
    Object L$1;
    Object L$2;
    int label;

    /* JADX INFO: Access modifiers changed from: package-private */
    /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
    public CameraView_TakePhotoKt$takePhoto$2(CameraView cameraView, ReadableMap readableMap, Continuation<? super CameraView_TakePhotoKt$takePhoto$2> continuation) {
        super(2, continuation);
        this.$this_takePhoto = cameraView;
        this.$options = readableMap;
    }

    @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
    public final Continuation<Unit> create(Object obj, Continuation<?> continuation) {
        CameraView_TakePhotoKt$takePhoto$2 cameraView_TakePhotoKt$takePhoto$2 = new CameraView_TakePhotoKt$takePhoto$2(this.$this_takePhoto, this.$options, continuation);
        cameraView_TakePhotoKt$takePhoto$2.L$0 = obj;
        return cameraView_TakePhotoKt$takePhoto$2;
    }

    @Override // kotlin.jvm.functions.Function2
    public final Object invoke(CoroutineScope coroutineScope, Continuation<? super WritableMap> continuation) {
        return ((CameraView_TakePhotoKt$takePhoto$2) create(coroutineScope, continuation)).invokeSuspend(Unit.INSTANCE);
    }

    /* JADX WARN: Removed duplicated region for block: B:82:0x0255  */
    @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object invokeSuspend(Object obj) {
        int i;
        Deferred async$default;
        Deferred async$default2;
        Object awaitAll;
        Integer num;
        long j;
        int i2;
        ImageProxy imageProxy;
        File file;
        long j2;
        Ref.ObjectRef objectRef;
        Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        int i3 = this.label;
        if (i3 == 0) {
            ResultKt.throwOnFailure(obj);
            CoroutineScope coroutineScope = (CoroutineScope) this.L$0;
            if (this.$this_takePhoto.getFallbackToSnapshot$react_native_vision_camera_release()) {
                Log.i("CameraView", "takePhoto() called, but falling back to Snapshot because 1 use-case is already occupied.");
                this.label = 1;
                Object takeSnapshot = CameraView_TakeSnapshotKt.takeSnapshot(this.$this_takePhoto, this.$options, this);
                return takeSnapshot == coroutine_suspended ? coroutine_suspended : takeSnapshot;
            }
            long nanoTime = System.nanoTime();
            Log.i("CameraView", "takePhoto() called");
            if (this.$this_takePhoto.getImageCapture$react_native_vision_camera_release() == null) {
                if (Intrinsics.areEqual(this.$this_takePhoto.getPhoto(), Boxing.boxBoolean(true))) {
                    throw new CameraNotReadyError();
                }
                throw new PhotoNotEnabledError();
            }
            if (this.$options.hasKey("flash")) {
                String string = this.$options.getString("flash");
                ImageCapture imageCapture$react_native_vision_camera_release = this.$this_takePhoto.getImageCapture$react_native_vision_camera_release();
                Intrinsics.checkNotNull(imageCapture$react_native_vision_camera_release);
                if (string != null) {
                    int hashCode = string.hashCode();
                    if (hashCode != 3551) {
                        if (hashCode != 109935) {
                            if (hashCode == 3005871 && string.equals("auto")) {
                                i2 = 0;
                                imageCapture$react_native_vision_camera_release.setFlashMode(i2);
                            }
                        } else if (string.equals(DebugKt.DEBUG_PROPERTY_VALUE_OFF)) {
                            i2 = 2;
                            imageCapture$react_native_vision_camera_release.setFlashMode(i2);
                        }
                    } else if (string.equals("on")) {
                        i2 = 1;
                        imageCapture$react_native_vision_camera_release.setFlashMode(i2);
                    }
                }
                if (string == null) {
                    string = "(null)";
                }
                throw new InvalidTypeScriptUnionError("flash", string);
            }
            this.$options.hasKey("photoCodec");
            this.$options.hasKey("qualityPrioritization");
            this.$options.hasKey("enableAutoRedEyeReduction");
            this.$options.hasKey("enableDualCameraFusion");
            this.$options.hasKey("enableAutoStabilization");
            this.$options.hasKey("enableAutoDistortionCorrection");
            boolean z = this.$options.hasKey("skipMetadata") ? this.$options.getBoolean("skipMetadata") : 0;
            Camera camera$react_native_vision_camera_release = this.$this_takePhoto.getCamera$react_native_vision_camera_release();
            Intrinsics.checkNotNull(camera$react_native_vision_camera_release);
            Camera2CameraInfo from = Camera2CameraInfo.from(camera$react_native_vision_camera_release.getCameraInfo());
            Intrinsics.checkNotNullExpressionValue(from, "from(camera!!.cameraInfo)");
            Integer num2 = (Integer) from.getCameraCharacteristic(CameraCharacteristics.LENS_FACING);
            i = z;
            async$default = BuildersKt__Builders_commonKt.async$default(coroutineScope, coroutineScope.getCoroutineContext(), null, new CameraView_TakePhotoKt$takePhoto$2$results$1(this.$this_takePhoto, null), 2, null);
            async$default2 = BuildersKt__Builders_commonKt.async$default(coroutineScope, Dispatchers.getIO(), null, new CameraView_TakePhotoKt$takePhoto$2$results$2(this.$this_takePhoto, null), 2, null);
            this.L$0 = num2;
            this.J$0 = nanoTime;
            this.I$0 = i;
            this.label = 2;
            awaitAll = AwaitKt.awaitAll(new Deferred[]{async$default, async$default2}, this);
            if (awaitAll == coroutine_suspended) {
                return coroutine_suspended;
            }
            num = num2;
            j = nanoTime;
        } else if (i3 == 1) {
            ResultKt.throwOnFailure(obj);
            return obj;
        } else if (i3 == 2) {
            int i4 = this.I$0;
            j = this.J$0;
            ResultKt.throwOnFailure(obj);
            i = i4;
            num = (Integer) this.L$0;
            awaitAll = obj;
        } else {
            if (i3 == 3) {
                j2 = this.J$0;
                objectRef = (Ref.ObjectRef) this.L$2;
                file = (File) this.L$1;
                imageProxy = (ImageProxy) this.L$0;
                ResultKt.throwOnFailure(obj);
                WritableMap map = Arguments.createMap();
                map.putString("path", file.getAbsolutePath());
                map.putInt("width", imageProxy.getWidth());
                map.putInt("height", imageProxy.getHeight());
                map.putBoolean("isRawPhoto", ImageProxy_isRawKt.isRaw(imageProxy));
                ExifInterface exifInterface = (ExifInterface) objectRef.element;
                map.putMap("metadata", exifInterface != null ? ExifInterface_buildMetadataMapKt.buildMetadataMap(exifInterface) : null);
                imageProxy.close();
                Log.d("CameraView", "Finished taking photo!");
                long nanoTime2 = System.nanoTime();
                Log.i(CameraView.TAG_PERF, "Finished function execution in " + ((nanoTime2 - j2) / ((long) DurationKt.NANOS_IN_MILLIS)) + "ms");
                Intrinsics.checkNotNullExpressionValue(map, "map");
                return map;
            }
            throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
        }
        List list = (List) awaitAll;
        for (Object obj2 : list) {
            if (obj2 instanceof ImageProxy) {
                Intrinsics.checkNotNull(obj2, "null cannot be cast to non-null type androidx.camera.core.ImageProxy");
                imageProxy = (ImageProxy) obj2;
                for (Object obj3 : list) {
                    if (obj3 instanceof File) {
                        Intrinsics.checkNotNull(obj3, "null cannot be cast to non-null type java.io.File");
                        File file2 = (File) obj3;
                        Ref.ObjectRef objectRef2 = new Ref.ObjectRef();
                        CoroutineDispatcher io2 = Dispatchers.getIO();
                        boolean z2 = i != 0;
                        this.L$0 = imageProxy;
                        this.L$1 = file2;
                        this.L$2 = objectRef2;
                        this.J$0 = j;
                        this.label = 3;
                        if (BuildersKt.withContext(io2, new AnonymousClass1(file2, objectRef2, z2, num, imageProxy, null), this) == coroutine_suspended) {
                            return coroutine_suspended;
                        }
                        file = file2;
                        j2 = j;
                        objectRef = objectRef2;
                        WritableMap map2 = Arguments.createMap();
                        map2.putString("path", file.getAbsolutePath());
                        map2.putInt("width", imageProxy.getWidth());
                        map2.putInt("height", imageProxy.getHeight());
                        map2.putBoolean("isRawPhoto", ImageProxy_isRawKt.isRaw(imageProxy));
                        ExifInterface exifInterface2 = (ExifInterface) objectRef.element;
                        map2.putMap("metadata", exifInterface2 != null ? ExifInterface_buildMetadataMapKt.buildMetadataMap(exifInterface2) : null);
                        imageProxy.close();
                        Log.d("CameraView", "Finished taking photo!");
                        long nanoTime22 = System.nanoTime();
                        Log.i(CameraView.TAG_PERF, "Finished function execution in " + ((nanoTime22 - j2) / ((long) DurationKt.NANOS_IN_MILLIS)) + "ms");
                        Intrinsics.checkNotNullExpressionValue(map2, "map");
                        return map2;
                    }
                }
                throw new NoSuchElementException("Collection contains no element matching the predicate.");
            }
        }
        throw new NoSuchElementException("Collection contains no element matching the predicate.");
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: CameraView+TakePhoto.kt */
    @Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\u008a@"}, d2 = {"<anonymous>", "", "Lkotlinx/coroutines/CoroutineScope;"}, k = 3, mv = {1, 7, 1}, xi = 48)
    @DebugMetadata(c = "com.mrousavy.camera.CameraView_TakePhotoKt$takePhoto$2$1", f = "CameraView+TakePhoto.kt", i = {}, l = {}, m = "invokeSuspend", n = {}, s = {})
    /* renamed from: com.mrousavy.camera.CameraView_TakePhotoKt$takePhoto$2$1  reason: invalid class name */
    /* loaded from: classes2.dex */
    public static final class AnonymousClass1 extends SuspendLambda implements Function2<CoroutineScope, Continuation<? super Unit>, Object> {
        final /* synthetic */ Ref.ObjectRef<ExifInterface> $exif;
        final /* synthetic */ File $file;
        final /* synthetic */ Integer $lensFacing;
        final /* synthetic */ ImageProxy $photo;
        final /* synthetic */ boolean $skipMetadata;
        int label;

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass1(File file, Ref.ObjectRef<ExifInterface> objectRef, boolean z, Integer num, ImageProxy imageProxy, Continuation<? super AnonymousClass1> continuation) {
            super(2, continuation);
            this.$file = file;
            this.$exif = objectRef;
            this.$skipMetadata = z;
            this.$lensFacing = num;
            this.$photo = imageProxy;
        }

        @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
        public final Continuation<Unit> create(Object obj, Continuation<?> continuation) {
            return new AnonymousClass1(this.$file, this.$exif, this.$skipMetadata, this.$lensFacing, this.$photo, continuation);
        }

        @Override // kotlin.jvm.functions.Function2
        public final Object invoke(CoroutineScope coroutineScope, Continuation<? super Unit> continuation) {
            return ((AnonymousClass1) create(coroutineScope, continuation)).invokeSuspend(Unit.INSTANCE);
        }

        /* JADX WARN: Multi-variable type inference failed */
        @Override // kotlin.coroutines.jvm.internal.BaseContinuationImpl
        public final Object invokeSuspend(Object obj) {
            IntrinsicsKt.getCOROUTINE_SUSPENDED();
            if (this.label == 0) {
                ResultKt.throwOnFailure(obj);
                Log.d("CameraView", "Saving picture to " + this.$file.getAbsolutePath() + "...");
                Integer num = this.$lensFacing;
                ImageProxy imageProxy = this.$photo;
                File file = this.$file;
                long currentTimeMillis = System.currentTimeMillis();
                ImageProxy_saveKt.save(imageProxy, file, num != null && num.intValue() == 0);
                Log.i(CameraView.TAG_PERF, "Finished image saving in " + (System.currentTimeMillis() - currentTimeMillis) + "ms");
                this.$exif.element = this.$skipMetadata ? 0 : new ExifInterface(this.$file);
                return Unit.INSTANCE;
            }
            throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
        }
    }
}
