package com.reactcommunity.rndatetimepicker;

import android.os.Bundle;
import android.widget.DatePicker;
import java.util.Calendar;
/* loaded from: classes2.dex */
public class KeepDateInRangeListener implements DatePicker.OnDateChangedListener {
    private final Bundle args;

    public KeepDateInRangeListener(Bundle bundle) {
        this.args = bundle;
    }

    @Override // android.widget.DatePicker.OnDateChangedListener
    public void onDateChanged(DatePicker datePicker, int i, int i2, int i3) {
        fixPotentialMaxDateBug(datePicker, i, i2, i3);
        fixPotentialMinDateBug(datePicker, i, i2, i3);
    }

    private void fixPotentialMaxDateBug(DatePicker datePicker, int i, int i2, int i3) {
        if (isDateAfterMaxDate(this.args, i, i2, i3)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTimeInMillis(this.args.getLong(RNConstants.ARG_MAXDATE));
            datePicker.updateDate(calendar.get(1), calendar.get(2), calendar.get(5));
        }
    }

    private void fixPotentialMinDateBug(DatePicker datePicker, int i, int i2, int i3) {
        if (isDateBeforeMinDate(this.args, i, i2, i3)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTimeInMillis(this.args.getLong(RNConstants.ARG_MINDATE));
            datePicker.updateDate(calendar.get(1), calendar.get(2), calendar.get(5));
        }
    }

    public static boolean isDateAfterMaxDate(Bundle bundle, int i, int i2, int i3) {
        if (bundle.containsKey(RNConstants.ARG_MAXDATE)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTimeInMillis(bundle.getLong(RNConstants.ARG_MAXDATE));
            return i > calendar.get(1) || (i == calendar.get(1) && i2 > calendar.get(2)) || (i == calendar.get(1) && i2 == calendar.get(2) && i3 > calendar.get(5));
        }
        return false;
    }

    public static boolean isDateBeforeMinDate(Bundle bundle, int i, int i2, int i3) {
        if (bundle.containsKey(RNConstants.ARG_MINDATE)) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTimeInMillis(bundle.getLong(RNConstants.ARG_MINDATE));
            return i < calendar.get(1) || (i == calendar.get(1) && i2 < calendar.get(2)) || (i == calendar.get(1) && i2 == calendar.get(2) && i3 < calendar.get(5));
        }
        return false;
    }
}
