package expo.modules;

import expo.modules.adapters.react.ReactAdapterPackage;
import expo.modules.application.ApplicationPackage;
import expo.modules.barcodescanner.BarCodeScannerModule;
import expo.modules.barcodescanner.BarCodeScannerPackage;
import expo.modules.camera.CameraViewModule;
import expo.modules.clipboard.ClipboardModule;
import expo.modules.constants.ConstantsModule;
import expo.modules.constants.ConstantsPackage;
import expo.modules.core.BasePackage;
import expo.modules.core.interfaces.Package;
import expo.modules.device.DeviceModule;
import expo.modules.devlauncher.DevLauncherPackage;
import expo.modules.devmenu.DevMenuPackage;
import expo.modules.easclient.EASClientModule;
import expo.modules.filesystem.FileSystemPackage;
import expo.modules.font.FontLoaderPackage;
import expo.modules.image.ExpoImageModule;
import expo.modules.imageloader.ImageLoaderPackage;
import expo.modules.imagemanipulator.ImageManipulatorModule;
import expo.modules.imagepicker.ImagePickerModule;
import expo.modules.intentlauncher.IntentLauncherModule;
import expo.modules.keepawake.KeepAwakePackage;
import expo.modules.kotlin.ModulesProvider;
import expo.modules.kotlin.modules.Module;
import expo.modules.localauthentication.LocalAuthenticationPackage;
import expo.modules.localization.LocalizationModule;
import expo.modules.notifications.NotificationsPackage;
import expo.modules.screenorientation.ScreenOrientationPackage;
import expo.modules.securestore.SecureStorePackage;
import expo.modules.splashscreen.SplashScreenPackage;
import expo.modules.systemui.SystemUIModule;
import expo.modules.systemui.SystemUIPackage;
import expo.modules.updates.UpdatesPackage;
import java.util.Arrays;
import java.util.List;
/* loaded from: classes3.dex */
public class ExpoModulesPackageList implements ModulesProvider {

    /* loaded from: classes3.dex */
    private static class LazyHolder {
        static final List<Package> packagesList = Arrays.asList(new ReactAdapterPackage(), new ApplicationPackage(), new BarCodeScannerPackage(), new ConstantsPackage(), new BasePackage(), new DevLauncherPackage(), new DevMenuPackage(), new FileSystemPackage(), new FontLoaderPackage(), new ImageLoaderPackage(), new KeepAwakePackage(), new LocalAuthenticationPackage(), new NotificationsPackage(), new ScreenOrientationPackage(), new SecureStorePackage(), new SplashScreenPackage(), new SystemUIPackage(), new UpdatesPackage());
        static final List<Class<? extends Module>> modulesList = Arrays.asList(BarCodeScannerModule.class, CameraViewModule.class, ClipboardModule.class, ConstantsModule.class, DeviceModule.class, EASClientModule.class, ExpoImageModule.class, ImageManipulatorModule.class, ImagePickerModule.class, IntentLauncherModule.class, LocalizationModule.class, SystemUIModule.class);

        private LazyHolder() {
        }
    }

    public static List<Package> getPackageList() {
        return LazyHolder.packagesList;
    }

    @Override // expo.modules.kotlin.ModulesProvider
    public List<Class<? extends Module>> getModulesList() {
        return LazyHolder.modulesList;
    }
}
