package expo.modules.barcodescanner;

import android.content.Context;
import expo.modules.interfaces.permissions.Permissions;
import expo.modules.kotlin.Promise;
import expo.modules.kotlin.exception.Exceptions;
import expo.modules.kotlin.functions.AsyncFunctionComponent;
import expo.modules.kotlin.functions.AsyncFunctionWithPromiseComponent;
import expo.modules.kotlin.modules.Module;
import expo.modules.kotlin.modules.ModuleDefinitionBuilder;
import expo.modules.kotlin.modules.ModuleDefinitionData;
import expo.modules.kotlin.types.AnyType;
import expo.modules.kotlin.types.AnyTypeKt;
import expo.modules.kotlin.views.ConcreteViewProp;
import expo.modules.kotlin.views.ViewDefinitionBuilder;
import java.util.ArrayList;
import java.util.List;
import kotlin.Metadata;
import kotlin.TuplesKt;
import kotlin.collections.MapsKt;
import kotlin.jvm.internal.Intrinsics;
import kotlin.jvm.internal.Reflection;
import kotlin.reflect.KClass;
import kotlin.reflect.KTypeProjection;
/* compiled from: BarCodeScannerModule.kt */
@Metadata(d1 = {"\u0000(\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0003\n\u0002\u0018\u0002\n\u0002\b\u0003\n\u0002\u0018\u0002\n\u0000\u0018\u00002\u00020\u0001B\u0005¢\u0006\u0002\u0010\u0002J\b\u0010\r\u001a\u00020\u000eH\u0016R\u000e\u0010\u0003\u001a\u00020\u0004X\u0082\u0004¢\u0006\u0002\n\u0000R\u0014\u0010\u0005\u001a\u00020\u00068BX\u0082\u0004¢\u0006\u0006\u001a\u0004\b\u0007\u0010\bR\u0014\u0010\t\u001a\u00020\n8BX\u0082\u0004¢\u0006\u0006\u001a\u0004\b\u000b\u0010\f¨\u0006\u000f"}, d2 = {"Lexpo/modules/barcodescanner/BarCodeScannerModule;", "Lexpo/modules/kotlin/modules/Module;", "()V", "barCodeScannerProvider", "Lexpo/modules/barcodescanner/BarCodeScannerProvider;", "context", "Landroid/content/Context;", "getContext", "()Landroid/content/Context;", "permissionsManager", "Lexpo/modules/interfaces/permissions/Permissions;", "getPermissionsManager", "()Lexpo/modules/interfaces/permissions/Permissions;", "definition", "Lexpo/modules/kotlin/modules/ModuleDefinitionData;", "expo-barcode-scanner_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class BarCodeScannerModule extends Module {
    private final BarCodeScannerProvider barCodeScannerProvider = new BarCodeScannerProvider();

    /* JADX INFO: Access modifiers changed from: private */
    public final Context getContext() {
        Context reactContext = getAppContext().getReactContext();
        if (reactContext != null) {
            return reactContext;
        }
        throw new Exceptions.ReactContextLost();
    }

    /* JADX INFO: Access modifiers changed from: private */
    public final Permissions getPermissionsManager() {
        Permissions permissions = getAppContext().getPermissions();
        if (permissions != null) {
            return permissions;
        }
        throw new Exceptions.PermissionsModuleNotFound();
    }

    @Override // expo.modules.kotlin.modules.Module
    public ModuleDefinitionData definition() {
        AsyncFunctionComponent asyncFunctionComponent;
        AsyncFunctionComponent asyncFunctionComponent2;
        AsyncFunctionComponent asyncFunctionComponent3;
        ModuleDefinitionBuilder moduleDefinitionBuilder = new ModuleDefinitionBuilder(this);
        moduleDefinitionBuilder.Name("ExpoBarCodeScanner");
        moduleDefinitionBuilder.Constants(TuplesKt.to("BarCodeType", MapsKt.mapOf(TuplesKt.to("aztec", 4096), TuplesKt.to("ean13", 32), TuplesKt.to("ean8", 64), TuplesKt.to("qr", 256), TuplesKt.to("pdf417", 2048), TuplesKt.to("upc_e", 1024), TuplesKt.to("datamatrix", 16), TuplesKt.to("code39", 2), TuplesKt.to("code93", 4), TuplesKt.to("itf14", 128), TuplesKt.to("codabar", 8), TuplesKt.to("code128", 1), TuplesKt.to("upc_a", 512))), TuplesKt.to("Type", MapsKt.mapOf(TuplesKt.to("front", 1), TuplesKt.to("back", 2))));
        ModuleDefinitionBuilder moduleDefinitionBuilder2 = moduleDefinitionBuilder;
        if (Intrinsics.areEqual(Reflection.getOrCreateKotlinClass(Promise.class), Reflection.getOrCreateKotlinClass(Promise.class))) {
            asyncFunctionComponent = new AsyncFunctionWithPromiseComponent("requestPermissionsAsync", new AnyType[0], new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$1(this));
        } else {
            asyncFunctionComponent = new AsyncFunctionComponent("requestPermissionsAsync", new AnyType[]{AnyTypeKt.toAnyType(Reflection.typeOf(Promise.class))}, new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$2(this));
        }
        moduleDefinitionBuilder2.getAsyncFunctions().put("requestPermissionsAsync", asyncFunctionComponent);
        if (Intrinsics.areEqual(Reflection.getOrCreateKotlinClass(Promise.class), Reflection.getOrCreateKotlinClass(Promise.class))) {
            asyncFunctionComponent2 = new AsyncFunctionWithPromiseComponent("getPermissionsAsync", new AnyType[0], new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$3(this));
        } else {
            asyncFunctionComponent2 = new AsyncFunctionComponent("getPermissionsAsync", new AnyType[]{AnyTypeKt.toAnyType(Reflection.typeOf(Promise.class))}, new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$4(this));
        }
        moduleDefinitionBuilder2.getAsyncFunctions().put("getPermissionsAsync", asyncFunctionComponent2);
        if (Intrinsics.areEqual(Reflection.getOrCreateKotlinClass(Promise.class), Reflection.getOrCreateKotlinClass(Promise.class))) {
            asyncFunctionComponent3 = new AsyncFunctionWithPromiseComponent("scanFromURLAsync", new AnyType[]{AnyTypeKt.toAnyType(Reflection.typeOf(String.class)), AnyTypeKt.toAnyType(Reflection.typeOf(List.class, KTypeProjection.Companion.invariant(Reflection.typeOf(Integer.TYPE))))}, new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$5(this));
        } else {
            asyncFunctionComponent3 = new AsyncFunctionComponent("scanFromURLAsync", new AnyType[]{AnyTypeKt.toAnyType(Reflection.typeOf(String.class)), AnyTypeKt.toAnyType(Reflection.typeOf(List.class, KTypeProjection.Companion.invariant(Reflection.typeOf(Integer.TYPE)))), AnyTypeKt.toAnyType(Reflection.typeOf(Promise.class))}, new BarCodeScannerModule$definition$lambda4$$inlined$AsyncFunction$6(this));
        }
        moduleDefinitionBuilder2.getAsyncFunctions().put("scanFromURLAsync", asyncFunctionComponent3);
        KClass orCreateKotlinClass = Reflection.getOrCreateKotlinClass(BarCodeScannerView.class);
        if (!(moduleDefinitionBuilder.getViewManagerDefinition() == null)) {
            throw new IllegalArgumentException("The module definition may have exported only one view manager.".toString());
        }
        ViewDefinitionBuilder viewDefinitionBuilder = new ViewDefinitionBuilder(orCreateKotlinClass);
        viewDefinitionBuilder.Events("onBarCodeScanned");
        viewDefinitionBuilder.getProps().put("type", new ConcreteViewProp("type", AnyTypeKt.toAnyType(Reflection.typeOf(Integer.TYPE)), BarCodeScannerModule$definition$1$4$1.INSTANCE));
        viewDefinitionBuilder.getProps().put("barCodeTypes", new ConcreteViewProp("barCodeTypes", AnyTypeKt.toAnyType(Reflection.nullableTypeOf(ArrayList.class, KTypeProjection.Companion.invariant(Reflection.nullableTypeOf(Double.class)))), BarCodeScannerModule$definition$1$4$2.INSTANCE));
        moduleDefinitionBuilder.setViewManagerDefinition(viewDefinitionBuilder.build());
        return moduleDefinitionBuilder.buildModule();
    }
}
