package expo.modules.clipboard;

import android.content.ClipData;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.util.Base64;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.Closeable;
import java.io.File;
import java.io.FileOutputStream;
import kotlin.Metadata;
import kotlin.ResultKt;
import kotlin.Unit;
import kotlin.coroutines.Continuation;
import kotlin.coroutines.intrinsics.IntrinsicsKt;
import kotlin.io.CloseableKt;
import kotlin.jvm.internal.Intrinsics;
import kotlinx.coroutines.Dispatchers;
import kotlinx.coroutines.InterruptibleKt;
import kotlinx.coroutines.YieldKt;
/* compiled from: ClipboardImage.kt */
@Metadata(d1 = {"\u0000B\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010\u000e\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0010\u000b\n\u0002\b\u0002\u001a\u0010\u0010\u0000\u001a\u00020\u00012\u0006\u0010\u0002\u001a\u00020\u0003H\u0000\u001a!\u0010\u0004\u001a\u00020\u00012\u0006\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0007\u001a\u00020\bH\u0080@ø\u0001\u0000¢\u0006\u0002\u0010\t\u001a)\u0010\n\u001a\u00020\u000b2\u0006\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0002\u001a\u00020\u00032\u0006\u0010\f\u001a\u00020\rH\u0080@ø\u0001\u0000¢\u0006\u0002\u0010\u000e\u001a)\u0010\u000f\u001a\u00020\u00102\u0006\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0007\u001a\u00020\b2\u0006\u0010\u0011\u001a\u00020\u0012H\u0080@ø\u0001\u0000¢\u0006\u0002\u0010\u0013\u001a\u0015\u0010\u0014\u001a\u00020\u0015*\u00020\rH\u0082@ø\u0001\u0000¢\u0006\u0002\u0010\u0016\u0082\u0002\u0004\n\u0002\b\u0019¨\u0006\u0017"}, d2 = {"bitmapFromBase64String", "Landroid/graphics/Bitmap;", "base64Image", "", "bitmapFromContentUriAsync", "context", "Landroid/content/Context;", "imageUri", "Landroid/net/Uri;", "(Landroid/content/Context;Landroid/net/Uri;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "clipDataFromBase64Image", "Landroid/content/ClipData;", "clipboardCacheDir", "Ljava/io/File;", "(Landroid/content/Context;Ljava/lang/String;Ljava/io/File;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "imageFromContentUri", "Lexpo/modules/clipboard/ImageResult;", "options", "Lexpo/modules/clipboard/GetImageOptions;", "(Landroid/content/Context;Landroid/net/Uri;Lexpo/modules/clipboard/GetImageOptions;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "ensureExists", "", "(Ljava/io/File;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "expo-clipboard_release"}, k = 2, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class ClipboardImageKt {
    /* JADX WARN: Removed duplicated region for block: B:10:0x0025  */
    /* JADX WARN: Removed duplicated region for block: B:16:0x004a  */
    /* JADX WARN: Removed duplicated region for block: B:21:0x0086 A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:22:0x0087  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static final Object imageFromContentUri(Context context, Uri uri, GetImageOptions getImageOptions, Continuation<? super ImageResult> continuation) {
        ClipboardImageKt$imageFromContentUri$1 clipboardImageKt$imageFromContentUri$1;
        Object coroutine_suspended;
        int i;
        ImageFormat imageFormat;
        Bitmap bitmap;
        ByteArrayOutputStream byteArrayOutputStream;
        if (continuation instanceof ClipboardImageKt$imageFromContentUri$1) {
            clipboardImageKt$imageFromContentUri$1 = (ClipboardImageKt$imageFromContentUri$1) continuation;
            if ((clipboardImageKt$imageFromContentUri$1.label & Integer.MIN_VALUE) != 0) {
                clipboardImageKt$imageFromContentUri$1.label -= Integer.MIN_VALUE;
                Object obj = clipboardImageKt$imageFromContentUri$1.result;
                coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = clipboardImageKt$imageFromContentUri$1.label;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    clipboardImageKt$imageFromContentUri$1.L$0 = getImageOptions;
                    clipboardImageKt$imageFromContentUri$1.label = 1;
                    obj = bitmapFromContentUriAsync(context, uri, clipboardImageKt$imageFromContentUri$1);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                } else if (i != 1) {
                    if (i == 2) {
                        byteArrayOutputStream = (ByteArrayOutputStream) clipboardImageKt$imageFromContentUri$1.L$2;
                        imageFormat = (ImageFormat) clipboardImageKt$imageFromContentUri$1.L$1;
                        bitmap = (Bitmap) clipboardImageKt$imageFromContentUri$1.L$0;
                        ResultKt.throwOnFailure(obj);
                        String encodeToString = Base64.encodeToString(byteArrayOutputStream.toByteArray(), 0);
                        StringBuilder sb = new StringBuilder("data:" + imageFormat.getMimeType() + ";base64,");
                        sb.append(encodeToString);
                        String sb2 = sb.toString();
                        Intrinsics.checkNotNullExpressionValue(sb2, "builder.toString()");
                        return new ImageResult(sb2, bitmap.getWidth(), bitmap.getHeight());
                    }
                    throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                } else {
                    getImageOptions = (GetImageOptions) clipboardImageKt$imageFromContentUri$1.L$0;
                    ResultKt.throwOnFailure(obj);
                }
                Bitmap bitmap2 = (Bitmap) obj;
                imageFormat = getImageOptions.getImageFormat();
                ByteArrayOutputStream byteArrayOutputStream2 = new ByteArrayOutputStream();
                bitmap2.compress(imageFormat.getCompressFormat(), (int) (getImageOptions.getJpegQuality() * 100), byteArrayOutputStream2);
                clipboardImageKt$imageFromContentUri$1.L$0 = bitmap2;
                clipboardImageKt$imageFromContentUri$1.L$1 = imageFormat;
                clipboardImageKt$imageFromContentUri$1.L$2 = byteArrayOutputStream2;
                clipboardImageKt$imageFromContentUri$1.label = 2;
                if (YieldKt.yield(clipboardImageKt$imageFromContentUri$1) != coroutine_suspended) {
                    return coroutine_suspended;
                }
                bitmap = bitmap2;
                byteArrayOutputStream = byteArrayOutputStream2;
                String encodeToString2 = Base64.encodeToString(byteArrayOutputStream.toByteArray(), 0);
                StringBuilder sb3 = new StringBuilder("data:" + imageFormat.getMimeType() + ";base64,");
                sb3.append(encodeToString2);
                String sb22 = sb3.toString();
                Intrinsics.checkNotNullExpressionValue(sb22, "builder.toString()");
                return new ImageResult(sb22, bitmap.getWidth(), bitmap.getHeight());
            }
        }
        clipboardImageKt$imageFromContentUri$1 = new ClipboardImageKt$imageFromContentUri$1(continuation);
        Object obj2 = clipboardImageKt$imageFromContentUri$1.result;
        coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = clipboardImageKt$imageFromContentUri$1.label;
        if (i != 0) {
        }
        Bitmap bitmap22 = (Bitmap) obj2;
        imageFormat = getImageOptions.getImageFormat();
        ByteArrayOutputStream byteArrayOutputStream22 = new ByteArrayOutputStream();
        bitmap22.compress(imageFormat.getCompressFormat(), (int) (getImageOptions.getJpegQuality() * 100), byteArrayOutputStream22);
        clipboardImageKt$imageFromContentUri$1.L$0 = bitmap22;
        clipboardImageKt$imageFromContentUri$1.L$1 = imageFormat;
        clipboardImageKt$imageFromContentUri$1.L$2 = byteArrayOutputStream22;
        clipboardImageKt$imageFromContentUri$1.label = 2;
        if (YieldKt.yield(clipboardImageKt$imageFromContentUri$1) != coroutine_suspended) {
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Removed duplicated region for block: B:10:0x0027  */
    /* JADX WARN: Removed duplicated region for block: B:22:0x0069  */
    /* JADX WARN: Removed duplicated region for block: B:28:0x009d A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:32:0x00cc A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:33:0x00cd  */
    /* JADX WARN: Type inference failed for: r9v18, types: [java.io.Closeable] */
    /* JADX WARN: Type inference failed for: r9v19 */
    /* JADX WARN: Type inference failed for: r9v6, types: [java.io.Closeable] */
    /* JADX WARN: Type inference failed for: r9v7 */
    /* JADX WARN: Type inference failed for: r9v8, types: [java.io.Closeable] */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static final Object clipDataFromBase64Image(Context context, String str, File file, Continuation<? super ClipData> continuation) {
        ClipboardImageKt$clipDataFromBase64Image$1 clipboardImageKt$clipDataFromBase64Image$1;
        Object obj;
        Object coroutine_suspended;
        int i;
        Bitmap bitmapFromBase64String;
        Context context2;
        File file2;
        BufferedOutputStream bufferedOutputStream;
        BufferedOutputStream bufferedOutputStream2;
        BufferedOutputStream bufferedOutputStream3;
        File file3;
        try {
            if (continuation instanceof ClipboardImageKt$clipDataFromBase64Image$1) {
                clipboardImageKt$clipDataFromBase64Image$1 = (ClipboardImageKt$clipDataFromBase64Image$1) continuation;
                if ((clipboardImageKt$clipDataFromBase64Image$1.label & Integer.MIN_VALUE) != 0) {
                    clipboardImageKt$clipDataFromBase64Image$1.label -= Integer.MIN_VALUE;
                    obj = clipboardImageKt$clipDataFromBase64Image$1.result;
                    coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                    i = clipboardImageKt$clipDataFromBase64Image$1.label;
                    if (i != 0) {
                        ResultKt.throwOnFailure(obj);
                        bitmapFromBase64String = bitmapFromBase64String(str);
                        File file4 = new File(file, "copied_image.jpeg");
                        clipboardImageKt$clipDataFromBase64Image$1.L$0 = context;
                        clipboardImageKt$clipDataFromBase64Image$1.L$1 = bitmapFromBase64String;
                        clipboardImageKt$clipDataFromBase64Image$1.L$2 = file4;
                        clipboardImageKt$clipDataFromBase64Image$1.label = 1;
                        if (ensureExists(file4, clipboardImageKt$clipDataFromBase64Image$1) == coroutine_suspended) {
                            return coroutine_suspended;
                        }
                        context2 = context;
                        file2 = file4;
                    } else if (i != 1) {
                        if (i != 2) {
                            if (i == 3) {
                                bufferedOutputStream2 = (Closeable) clipboardImageKt$clipDataFromBase64Image$1.L$2;
                                file3 = (File) clipboardImageKt$clipDataFromBase64Image$1.L$1;
                                context2 = (Context) clipboardImageKt$clipDataFromBase64Image$1.L$0;
                                try {
                                    ResultKt.throwOnFailure(obj);
                                    bufferedOutputStream2 = bufferedOutputStream2;
                                    Unit unit = Unit.INSTANCE;
                                    CloseableKt.closeFinally(bufferedOutputStream2, null);
                                    ClipData newUri = ClipData.newUri(context2.getContentResolver(), "image", ClipboardFileProvider.Companion.getUriForFile(context2, context2.getApplicationInfo().packageName + ".ClipboardFileProvider", file3));
                                    Intrinsics.checkNotNullExpressionValue(newUri, "newUri(context.contentResolver, \"image\", imageUri)");
                                    return newUri;
                                } catch (Throwable th) {
                                    th = th;
                                    try {
                                        throw th;
                                    } catch (Throwable th2) {
                                        CloseableKt.closeFinally(bufferedOutputStream2, th);
                                        throw th2;
                                    }
                                }
                            }
                            throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                        }
                        file2 = (File) clipboardImageKt$clipDataFromBase64Image$1.L$2;
                        bitmapFromBase64String = (Bitmap) clipboardImageKt$clipDataFromBase64Image$1.L$1;
                        context2 = (Context) clipboardImageKt$clipDataFromBase64Image$1.L$0;
                        ResultKt.throwOnFailure(obj);
                        bufferedOutputStream = new BufferedOutputStream((FileOutputStream) obj);
                        bufferedOutputStream3 = bufferedOutputStream;
                        bitmapFromBase64String.compress(Bitmap.CompressFormat.JPEG, 100, bufferedOutputStream3);
                        clipboardImageKt$clipDataFromBase64Image$1.L$0 = context2;
                        clipboardImageKt$clipDataFromBase64Image$1.L$1 = file2;
                        clipboardImageKt$clipDataFromBase64Image$1.L$2 = bufferedOutputStream;
                        clipboardImageKt$clipDataFromBase64Image$1.label = 3;
                        if (InterruptibleKt.runInterruptible$default(null, new ClipboardImageKt$clipDataFromBase64Image$2$1(bufferedOutputStream3), clipboardImageKt$clipDataFromBase64Image$1, 1, null) == coroutine_suspended) {
                            return coroutine_suspended;
                        }
                        file3 = file2;
                        bufferedOutputStream2 = bufferedOutputStream;
                        Unit unit2 = Unit.INSTANCE;
                        CloseableKt.closeFinally(bufferedOutputStream2, null);
                        ClipData newUri2 = ClipData.newUri(context2.getContentResolver(), "image", ClipboardFileProvider.Companion.getUriForFile(context2, context2.getApplicationInfo().packageName + ".ClipboardFileProvider", file3));
                        Intrinsics.checkNotNullExpressionValue(newUri2, "newUri(context.contentResolver, \"image\", imageUri)");
                        return newUri2;
                    } else {
                        file2 = (File) clipboardImageKt$clipDataFromBase64Image$1.L$2;
                        bitmapFromBase64String = (Bitmap) clipboardImageKt$clipDataFromBase64Image$1.L$1;
                        context2 = (Context) clipboardImageKt$clipDataFromBase64Image$1.L$0;
                        ResultKt.throwOnFailure(obj);
                    }
                    clipboardImageKt$clipDataFromBase64Image$1.L$0 = context2;
                    clipboardImageKt$clipDataFromBase64Image$1.L$1 = bitmapFromBase64String;
                    clipboardImageKt$clipDataFromBase64Image$1.L$2 = file2;
                    clipboardImageKt$clipDataFromBase64Image$1.label = 2;
                    obj = InterruptibleKt.runInterruptible$default(null, new ClipboardImageKt$clipDataFromBase64Image$fileStream$1(file2), clipboardImageKt$clipDataFromBase64Image$1, 1, null);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                    bufferedOutputStream = new BufferedOutputStream((FileOutputStream) obj);
                    bufferedOutputStream3 = bufferedOutputStream;
                    bitmapFromBase64String.compress(Bitmap.CompressFormat.JPEG, 100, bufferedOutputStream3);
                    clipboardImageKt$clipDataFromBase64Image$1.L$0 = context2;
                    clipboardImageKt$clipDataFromBase64Image$1.L$1 = file2;
                    clipboardImageKt$clipDataFromBase64Image$1.L$2 = bufferedOutputStream;
                    clipboardImageKt$clipDataFromBase64Image$1.label = 3;
                    if (InterruptibleKt.runInterruptible$default(null, new ClipboardImageKt$clipDataFromBase64Image$2$1(bufferedOutputStream3), clipboardImageKt$clipDataFromBase64Image$1, 1, null) == coroutine_suspended) {
                    }
                }
            }
            bufferedOutputStream3 = bufferedOutputStream;
            bitmapFromBase64String.compress(Bitmap.CompressFormat.JPEG, 100, bufferedOutputStream3);
            clipboardImageKt$clipDataFromBase64Image$1.L$0 = context2;
            clipboardImageKt$clipDataFromBase64Image$1.L$1 = file2;
            clipboardImageKt$clipDataFromBase64Image$1.L$2 = bufferedOutputStream;
            clipboardImageKt$clipDataFromBase64Image$1.label = 3;
            if (InterruptibleKt.runInterruptible$default(null, new ClipboardImageKt$clipDataFromBase64Image$2$1(bufferedOutputStream3), clipboardImageKt$clipDataFromBase64Image$1, 1, null) == coroutine_suspended) {
            }
        } catch (Throwable th3) {
            th = th3;
            bufferedOutputStream2 = bufferedOutputStream;
            throw th;
        }
        clipboardImageKt$clipDataFromBase64Image$1 = new ClipboardImageKt$clipDataFromBase64Image$1(continuation);
        obj = clipboardImageKt$clipDataFromBase64Image$1.result;
        coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = clipboardImageKt$clipDataFromBase64Image$1.label;
        if (i != 0) {
        }
        clipboardImageKt$clipDataFromBase64Image$1.L$0 = context2;
        clipboardImageKt$clipDataFromBase64Image$1.L$1 = bitmapFromBase64String;
        clipboardImageKt$clipDataFromBase64Image$1.L$2 = file2;
        clipboardImageKt$clipDataFromBase64Image$1.label = 2;
        obj = InterruptibleKt.runInterruptible$default(null, new ClipboardImageKt$clipDataFromBase64Image$fileStream$1(file2), clipboardImageKt$clipDataFromBase64Image$1, 1, null);
        if (obj == coroutine_suspended) {
        }
        bufferedOutputStream = new BufferedOutputStream((FileOutputStream) obj);
    }

    /* JADX WARN: Removed duplicated region for block: B:10:0x0024  */
    /* JADX WARN: Removed duplicated region for block: B:14:0x0032  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static final Object bitmapFromContentUriAsync(Context context, Uri uri, Continuation<? super Bitmap> continuation) {
        ClipboardImageKt$bitmapFromContentUriAsync$1 clipboardImageKt$bitmapFromContentUriAsync$1;
        int i;
        if (continuation instanceof ClipboardImageKt$bitmapFromContentUriAsync$1) {
            clipboardImageKt$bitmapFromContentUriAsync$1 = (ClipboardImageKt$bitmapFromContentUriAsync$1) continuation;
            if ((clipboardImageKt$bitmapFromContentUriAsync$1.label & Integer.MIN_VALUE) != 0) {
                clipboardImageKt$bitmapFromContentUriAsync$1.label -= Integer.MIN_VALUE;
                Object obj = clipboardImageKt$bitmapFromContentUriAsync$1.result;
                Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = clipboardImageKt$bitmapFromContentUriAsync$1.label;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    clipboardImageKt$bitmapFromContentUriAsync$1.label = 1;
                    obj = InterruptibleKt.runInterruptible(Dispatchers.getIO(), new ClipboardImageKt$bitmapFromContentUriAsync$2(context, uri), clipboardImageKt$bitmapFromContentUriAsync$1);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                } else if (i != 1) {
                    throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                } else {
                    ResultKt.throwOnFailure(obj);
                }
                Intrinsics.checkNotNullExpressionValue(obj, "context: Context, imageU…source)\n      }\n    }\n  }");
                return obj;
            }
        }
        clipboardImageKt$bitmapFromContentUriAsync$1 = new ClipboardImageKt$bitmapFromContentUriAsync$1(continuation);
        Object obj2 = clipboardImageKt$bitmapFromContentUriAsync$1.result;
        Object coroutine_suspended2 = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = clipboardImageKt$bitmapFromContentUriAsync$1.label;
        if (i != 0) {
        }
        Intrinsics.checkNotNullExpressionValue(obj2, "context: Context, imageU…source)\n      }\n    }\n  }");
        return obj2;
    }

    public static final Bitmap bitmapFromBase64String(String base64Image) {
        Intrinsics.checkNotNullParameter(base64Image, "base64Image");
        try {
            byte[] decode = Base64.decode(base64Image, 0);
            Bitmap decodeByteArray = BitmapFactory.decodeByteArray(decode, 0, decode.length);
            if (decodeByteArray != null) {
                return decodeByteArray;
            }
            throw new RuntimeException("Failed to convert base64 into Bitmap");
        } catch (RuntimeException e) {
            throw new InvalidImageException(base64Image, e);
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    public static final Object ensureExists(File file, Continuation<? super Boolean> continuation) {
        return InterruptibleKt.runInterruptible(Dispatchers.getIO(), new ClipboardImageKt$ensureExists$2(file), continuation);
    }
}
