package expo.modules.devlauncher.network;

import kotlin.Metadata;
import kotlin.jvm.internal.Intrinsics;
import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;
/* compiled from: DevLauncherOkHttpInterceptors.kt */
@Metadata(d1 = {"\u0000\u0018\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\u0018\u00002\u00020\u0001B\u0005¢\u0006\u0002\u0010\u0002J\u0010\u0010\u0003\u001a\u00020\u00042\u0006\u0010\u0005\u001a\u00020\u0006H\u0016¨\u0006\u0007"}, d2 = {"Lexpo/modules/devlauncher/network/DevLauncherOkHttpNetworkInterceptor;", "Lokhttp3/Interceptor;", "()V", "intercept", "Lokhttp3/Response;", "chain", "Lokhttp3/Interceptor$Chain;", "expo-dev-launcher_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class DevLauncherOkHttpNetworkInterceptor implements Interceptor {
    @Override // okhttp3.Interceptor
    public Response intercept(Interceptor.Chain chain) {
        String valueOf;
        Intrinsics.checkNotNullParameter(chain, "chain");
        if (!DevLauncherNetworkLogger.Companion.getInstance().shouldEmitEvents()) {
            Response proceed = chain.proceed(chain.request());
            Intrinsics.checkNotNullExpressionValue(proceed, "chain.proceed(chain.request())");
            return proceed;
        }
        Request request = chain.request();
        RedirectResponse redirectResponse = (RedirectResponse) request.tag(RedirectResponse.class);
        if (redirectResponse == null || (valueOf = redirectResponse.getRequestId()) == null) {
            valueOf = String.valueOf(request.hashCode());
        }
        DevLauncherNetworkLogger companion = DevLauncherNetworkLogger.Companion.getInstance();
        Intrinsics.checkNotNullExpressionValue(request, "request");
        companion.emitNetworkWillBeSent(request, valueOf, redirectResponse != null ? redirectResponse.getPriorResponse() : null);
        Response response = chain.proceed(request);
        if (response.isRedirect()) {
            RedirectResponse redirectResponse2 = (RedirectResponse) response.request().tag(RedirectResponse.class);
            if (redirectResponse2 != null) {
                redirectResponse2.setRequestId(valueOf);
                redirectResponse2.setPriorResponse(response);
            }
        } else {
            DevLauncherNetworkLogger companion2 = DevLauncherNetworkLogger.Companion.getInstance();
            Intrinsics.checkNotNullExpressionValue(response, "response");
            companion2.emitNetworkResponse(request, valueOf, response);
            DevLauncherNetworkLogger.Companion.getInstance().emitNetworkDidReceiveBody(valueOf, response);
        }
        Intrinsics.checkNotNullExpressionValue(response, "response");
        return response;
    }
}
