package expo.modules.devmenu.extensions;

import android.app.Activity;
import android.util.Log;
import com.facebook.react.ReactInstanceManager;
import com.facebook.react.devsupport.DevInternalSettings;
import com.facebook.react.devsupport.interfaces.DevSupportManager;
import com.facebook.react.modules.debug.interfaces.DeveloperSettings;
import expo.interfaces.devmenu.DevMenuExtensionSettingsInterface;
import expo.interfaces.devmenu.items.DevMenuAction;
import expo.interfaces.devmenu.items.DevMenuDSLItemsContainerInterface;
import expo.interfaces.devmenu.items.DevMenuItemImportance;
import expo.interfaces.devmenu.items.KeyCommand;
import expo.modules.devmenu.DevMenuManager;
import expo.modules.devmenu.DevMenuUtilsKt;
import expo.modules.devmenu.devtools.DevMenuDevToolsDelegate;
import kotlin.Metadata;
import kotlin.Unit;
import kotlin.jvm.functions.Function0;
import kotlin.jvm.functions.Function1;
import kotlin.jvm.internal.FunctionReferenceImpl;
import kotlin.jvm.internal.Intrinsics;
import kotlin.jvm.internal.Lambda;
/* JADX INFO: Access modifiers changed from: package-private */
/* compiled from: DevMenuExtension.kt */
@Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuDSLItemsContainerInterface;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class DevMenuExtension$devMenuItems$1 extends Lambda implements Function1<DevMenuDSLItemsContainerInterface, Unit> {
    final /* synthetic */ DevMenuExtensionSettingsInterface $settings;
    final /* synthetic */ DevMenuExtension this$0;

    /* JADX INFO: Access modifiers changed from: package-private */
    /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
    public DevMenuExtension$devMenuItems$1(DevMenuExtensionSettingsInterface devMenuExtensionSettingsInterface, DevMenuExtension devMenuExtension) {
        super(1);
        this.$settings = devMenuExtensionSettingsInterface;
        this.this$0 = devMenuExtension;
    }

    @Override // kotlin.jvm.functions.Function1
    public /* bridge */ /* synthetic */ Unit invoke(DevMenuDSLItemsContainerInterface devMenuDSLItemsContainerInterface) {
        invoke2(devMenuDSLItemsContainerInterface);
        return Unit.INSTANCE;
    }

    /* renamed from: invoke  reason: avoid collision after fix types in other method */
    public final void invoke2(DevMenuDSLItemsContainerInterface export) {
        Intrinsics.checkNotNullParameter(export, "$this$export");
        if (this.$settings.wasRunOnDevelopmentBridge()) {
            ReactInstanceManager reactInstanceManager = DevMenuManager.INSTANCE.getReactInstanceManager();
            if (reactInstanceManager == null) {
                Log.w(DevMenuUtilsKt.DEV_MENU_TAG, "Couldn't export dev-menu items, because the react instance manager isn't present.");
                return;
            }
            DevMenuDevToolsDelegate devMenuDevToolsDelegate = new DevMenuDevToolsDelegate(this.$settings.getManager(), reactInstanceManager);
            DevSupportManager reactDevManager = devMenuDevToolsDelegate.getReactDevManager();
            DeveloperSettings devSettings = devMenuDevToolsDelegate.getDevSettings();
            if (reactDevManager == null || devSettings == null) {
                Log.w(DevMenuUtilsKt.DEV_MENU_TAG, "Couldn't export dev-menu items, because react-native bridge doesn't contain the dev support manager.");
                return;
            }
            export.action("reload", new AnonymousClass1(devMenuDevToolsDelegate), AnonymousClass2.INSTANCE);
            export.action("performance-monitor", new AnonymousClass3(this.this$0, devMenuDevToolsDelegate), new AnonymousClass4(devSettings));
            export.action("inspector", new AnonymousClass5(devMenuDevToolsDelegate), new AnonymousClass6(devSettings));
            export.action("remote-debug", new AnonymousClass7(devMenuDevToolsDelegate), new AnonymousClass8(devSettings));
            if (devSettings instanceof DevInternalSettings) {
                export.action("js-inspector", new AnonymousClass9(devMenuDevToolsDelegate), AnonymousClass10.INSTANCE);
                export.action("fast-refresh", new DevMenuExtension$devMenuItems$1$fastRefreshAction$1(devSettings), new AnonymousClass11(devSettings));
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$1  reason: invalid class name */
    /* loaded from: classes3.dex */
    public /* synthetic */ class AnonymousClass1 extends FunctionReferenceImpl implements Function0<Unit> {
        AnonymousClass1(Object obj) {
            super(0, obj, DevMenuDevToolsDelegate.class, "reload", "reload()V", 0);
        }

        @Override // kotlin.jvm.functions.Function0
        public /* bridge */ /* synthetic */ Unit invoke() {
            invoke2();
            return Unit.INSTANCE;
        }

        @Override // kotlin.jvm.functions.Function0
        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2() {
            ((DevMenuDevToolsDelegate) this.receiver).reload();
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$2  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass2 extends Lambda implements Function1<DevMenuAction, Unit> {
        public static final AnonymousClass2 INSTANCE = new AnonymousClass2();

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$2$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<String> {
            public static final AnonymousClass1 INSTANCE = new AnonymousClass1();

            AnonymousClass1() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "Reload";
            }
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$2$2  reason: invalid class name and collision with other inner class name */
        /* loaded from: classes3.dex */
        public static final class C00582 extends Lambda implements Function0<String> {
            public static final C00582 INSTANCE = new C00582();

            C00582() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "reload";
            }
        }

        AnonymousClass2() {
            super(1);
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setLabel(AnonymousClass1.INSTANCE);
            action.setGlyphName(C00582.INSTANCE);
            action.setKeyCommand(new KeyCommand(46, false, 2, null));
            action.setImportance(DevMenuItemImportance.HIGHEST.getValue());
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$3  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass3 extends Lambda implements Function0<Unit> {
        final /* synthetic */ DevMenuDevToolsDelegate $devDelegate;
        final /* synthetic */ DevMenuExtension this$0;

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass3(DevMenuExtension devMenuExtension, DevMenuDevToolsDelegate devMenuDevToolsDelegate) {
            super(0);
            this.this$0 = devMenuExtension;
            this.$devDelegate = devMenuDevToolsDelegate;
        }

        @Override // kotlin.jvm.functions.Function0
        public /* bridge */ /* synthetic */ Unit invoke() {
            invoke2();
            return Unit.INSTANCE;
        }

        @Override // kotlin.jvm.functions.Function0
        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2() {
            Activity currentActivity;
            currentActivity = this.this$0.getCurrentActivity();
            if (currentActivity != null) {
                this.$devDelegate.togglePerformanceMonitor(currentActivity);
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$4  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass4 extends Lambda implements Function1<DevMenuAction, Unit> {
        final /* synthetic */ DeveloperSettings $devSettings;

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$4$3  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass3 extends Lambda implements Function0<String> {
            public static final AnonymousClass3 INSTANCE = new AnonymousClass3();

            AnonymousClass3() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "speedometer";
            }
        }

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass4(DeveloperSettings developerSettings) {
            super(1);
            this.$devSettings = developerSettings;
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u000b\n\u0002\b\u0002\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0004\b\u0002\u0010\u0003"}, d2 = {"<anonymous>", "", "invoke", "()Ljava/lang/Boolean;"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$4$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<Boolean> {
            final /* synthetic */ DeveloperSettings $devSettings;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass1(DeveloperSettings developerSettings) {
                super(0);
                this.$devSettings = developerSettings;
            }

            /* JADX WARN: Can't rename method to resolve collision */
            @Override // kotlin.jvm.functions.Function0
            public final Boolean invoke() {
                return Boolean.valueOf(this.$devSettings.isFpsDebugEnabled());
            }
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$4$2  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass2 extends Lambda implements Function0<String> {
            final /* synthetic */ DevMenuAction $this_action;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass2(DevMenuAction devMenuAction) {
                super(0);
                this.$this_action = devMenuAction;
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return this.$this_action.isEnabled().invoke().booleanValue() ? "Hide Performance Monitor" : "Show Performance Monitor";
            }
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setEnabled(new AnonymousClass1(this.$devSettings));
            action.setLabel(new AnonymousClass2(action));
            action.setGlyphName(AnonymousClass3.INSTANCE);
            action.setKeyCommand(new KeyCommand(44, false, 2, null));
            action.setImportance(DevMenuItemImportance.HIGH.getValue());
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$5  reason: invalid class name */
    /* loaded from: classes3.dex */
    public /* synthetic */ class AnonymousClass5 extends FunctionReferenceImpl implements Function0<Unit> {
        AnonymousClass5(Object obj) {
            super(0, obj, DevMenuDevToolsDelegate.class, "toggleElementInspector", "toggleElementInspector()V", 0);
        }

        @Override // kotlin.jvm.functions.Function0
        public /* bridge */ /* synthetic */ Unit invoke() {
            invoke2();
            return Unit.INSTANCE;
        }

        @Override // kotlin.jvm.functions.Function0
        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2() {
            ((DevMenuDevToolsDelegate) this.receiver).toggleElementInspector();
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$6  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass6 extends Lambda implements Function1<DevMenuAction, Unit> {
        final /* synthetic */ DeveloperSettings $devSettings;

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$6$3  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass3 extends Lambda implements Function0<String> {
            public static final AnonymousClass3 INSTANCE = new AnonymousClass3();

            AnonymousClass3() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "border-style";
            }
        }

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass6(DeveloperSettings developerSettings) {
            super(1);
            this.$devSettings = developerSettings;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u000b\n\u0002\b\u0002\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0004\b\u0002\u0010\u0003"}, d2 = {"<anonymous>", "", "invoke", "()Ljava/lang/Boolean;"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$6$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<Boolean> {
            final /* synthetic */ DeveloperSettings $devSettings;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass1(DeveloperSettings developerSettings) {
                super(0);
                this.$devSettings = developerSettings;
            }

            /* JADX WARN: Can't rename method to resolve collision */
            @Override // kotlin.jvm.functions.Function0
            public final Boolean invoke() {
                return Boolean.valueOf(this.$devSettings.isElementInspectorEnabled());
            }
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$6$2  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass2 extends Lambda implements Function0<String> {
            final /* synthetic */ DevMenuAction $this_action;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass2(DevMenuAction devMenuAction) {
                super(0);
                this.$this_action = devMenuAction;
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return this.$this_action.isEnabled().invoke().booleanValue() ? "Hide Element Inspector" : "Show Element Inspector";
            }
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setEnabled(new AnonymousClass1(this.$devSettings));
            action.setLabel(new AnonymousClass2(action));
            action.setGlyphName(AnonymousClass3.INSTANCE);
            action.setKeyCommand(new KeyCommand(37, false, 2, null));
            action.setImportance(DevMenuItemImportance.HIGH.getValue());
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$7  reason: invalid class name */
    /* loaded from: classes3.dex */
    public /* synthetic */ class AnonymousClass7 extends FunctionReferenceImpl implements Function0<Unit> {
        AnonymousClass7(Object obj) {
            super(0, obj, DevMenuDevToolsDelegate.class, "toggleRemoteDebugging", "toggleRemoteDebugging()V", 0);
        }

        @Override // kotlin.jvm.functions.Function0
        public /* bridge */ /* synthetic */ Unit invoke() {
            invoke2();
            return Unit.INSTANCE;
        }

        @Override // kotlin.jvm.functions.Function0
        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2() {
            ((DevMenuDevToolsDelegate) this.receiver).toggleRemoteDebugging();
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$8  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass8 extends Lambda implements Function1<DevMenuAction, Unit> {
        final /* synthetic */ DeveloperSettings $devSettings;

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$8$3  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass3 extends Lambda implements Function0<String> {
            public static final AnonymousClass3 INSTANCE = new AnonymousClass3();

            AnonymousClass3() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "remote-desktop";
            }
        }

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass8(DeveloperSettings developerSettings) {
            super(1);
            this.$devSettings = developerSettings;
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u000b\n\u0002\b\u0002\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0004\b\u0002\u0010\u0003"}, d2 = {"<anonymous>", "", "invoke", "()Ljava/lang/Boolean;"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$8$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<Boolean> {
            final /* synthetic */ DeveloperSettings $devSettings;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass1(DeveloperSettings developerSettings) {
                super(0);
                this.$devSettings = developerSettings;
            }

            /* JADX WARN: Can't rename method to resolve collision */
            @Override // kotlin.jvm.functions.Function0
            public final Boolean invoke() {
                return Boolean.valueOf(this.$devSettings.isRemoteJSDebugEnabled());
            }
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setEnabled(new AnonymousClass1(this.$devSettings));
            action.setLabel(new AnonymousClass2(action));
            action.setGlyphName(AnonymousClass3.INSTANCE);
            action.setImportance(DevMenuItemImportance.LOW.getValue());
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$8$2  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass2 extends Lambda implements Function0<String> {
            final /* synthetic */ DevMenuAction $this_action;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass2(DevMenuAction devMenuAction) {
                super(0);
                this.$this_action = devMenuAction;
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return this.$this_action.isEnabled().invoke().booleanValue() ? "Stop Remote Debugging" : "Debug Remote JS";
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$10  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass10 extends Lambda implements Function1<DevMenuAction, Unit> {
        public static final AnonymousClass10 INSTANCE = new AnonymousClass10();

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$10$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<String> {
            public static final AnonymousClass1 INSTANCE = new AnonymousClass1();

            AnonymousClass1() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "Open JavaScript debugger";
            }
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$10$2  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass2 extends Lambda implements Function0<String> {
            public static final AnonymousClass2 INSTANCE = new AnonymousClass2();

            AnonymousClass2() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "language-javascript";
            }
        }

        AnonymousClass10() {
            super(1);
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setLabel(AnonymousClass1.INSTANCE);
            action.setGlyphName(AnonymousClass2.INSTANCE);
            action.setImportance(DevMenuItemImportance.LOW.getValue());
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$9  reason: invalid class name */
    /* loaded from: classes3.dex */
    public /* synthetic */ class AnonymousClass9 extends FunctionReferenceImpl implements Function0<Unit> {
        AnonymousClass9(Object obj) {
            super(0, obj, DevMenuDevToolsDelegate.class, "openJSInspector", "openJSInspector()V", 0);
        }

        @Override // kotlin.jvm.functions.Function0
        public /* bridge */ /* synthetic */ Unit invoke() {
            invoke2();
            return Unit.INSTANCE;
        }

        @Override // kotlin.jvm.functions.Function0
        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2() {
            ((DevMenuDevToolsDelegate) this.receiver).openJSInspector();
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* compiled from: DevMenuExtension.kt */
    @Metadata(d1 = {"\u0000\f\n\u0000\n\u0002\u0010\u0002\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001*\u00020\u0002H\n¢\u0006\u0002\b\u0003"}, d2 = {"<anonymous>", "", "Lexpo/interfaces/devmenu/items/DevMenuAction;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
    /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$11  reason: invalid class name */
    /* loaded from: classes3.dex */
    public static final class AnonymousClass11 extends Lambda implements Function1<DevMenuAction, Unit> {
        final /* synthetic */ DeveloperSettings $devSettings;

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$11$3  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass3 extends Lambda implements Function0<String> {
            public static final AnonymousClass3 INSTANCE = new AnonymousClass3();

            AnonymousClass3() {
                super(0);
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return "run-fast";
            }
        }

        /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
        AnonymousClass11(DeveloperSettings developerSettings) {
            super(1);
            this.$devSettings = developerSettings;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\n\n\u0000\n\u0002\u0010\u000b\n\u0002\b\u0002\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0004\b\u0002\u0010\u0003"}, d2 = {"<anonymous>", "", "invoke", "()Ljava/lang/Boolean;"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$11$1  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass1 extends Lambda implements Function0<Boolean> {
            final /* synthetic */ DeveloperSettings $devSettings;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass1(DeveloperSettings developerSettings) {
                super(0);
                this.$devSettings = developerSettings;
            }

            /* JADX WARN: Can't rename method to resolve collision */
            @Override // kotlin.jvm.functions.Function0
            public final Boolean invoke() {
                return Boolean.valueOf(((DevInternalSettings) this.$devSettings).isHotModuleReplacementEnabled());
            }
        }

        @Override // kotlin.jvm.functions.Function1
        public /* bridge */ /* synthetic */ Unit invoke(DevMenuAction devMenuAction) {
            invoke2(devMenuAction);
            return Unit.INSTANCE;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        /* compiled from: DevMenuExtension.kt */
        @Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0010\u000e\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
        /* renamed from: expo.modules.devmenu.extensions.DevMenuExtension$devMenuItems$1$11$2  reason: invalid class name */
        /* loaded from: classes3.dex */
        public static final class AnonymousClass2 extends Lambda implements Function0<String> {
            final /* synthetic */ DevMenuAction $this_action;

            /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
            AnonymousClass2(DevMenuAction devMenuAction) {
                super(0);
                this.$this_action = devMenuAction;
            }

            @Override // kotlin.jvm.functions.Function0
            public final String invoke() {
                return this.$this_action.isEnabled().invoke().booleanValue() ? "Disable Fast Refresh" : "Enable Fast Refresh";
            }
        }

        /* renamed from: invoke  reason: avoid collision after fix types in other method */
        public final void invoke2(DevMenuAction action) {
            Intrinsics.checkNotNullParameter(action, "$this$action");
            action.setEnabled(new AnonymousClass1(this.$devSettings));
            action.setLabel(new AnonymousClass2(action));
            action.setGlyphName(AnonymousClass3.INSTANCE);
            action.setImportance(DevMenuItemImportance.LOW.getValue());
        }
    }
}
