package expo.modules.devmenu.modules;

import com.facebook.react.bridge.BaseJavaModule;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import expo.modules.core.utilities.EmulatorUtilities;
import expo.modules.devmenu.modules.internals.DevMenuInternalFontManagerModule;
import expo.modules.devmenu.modules.internals.DevMenuInternalMenuControllerModule;
import java.util.Map;
import kotlin.Metadata;
import kotlin.TuplesKt;
import kotlin.collections.MapsKt;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: DevMenuInternalModule.kt */
@Metadata(d1 = {"\u0000J\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0010\u000b\n\u0002\b\u0003\n\u0002\u0010\u0002\n\u0000\n\u0002\u0010\u000e\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0003\n\u0002\u0018\u0002\n\u0002\b\u0005\n\u0002\u0010$\n\u0002\u0010\u0000\n\u0002\b\t\u0018\u00002\u00020\u00012\u00020\u00022\u00020\u0003B\r\u0012\u0006\u0010\u0004\u001a\u00020\u0005¢\u0006\u0002\u0010\u0006J\u0019\u0010\u000b\u001a\u00020\f2\u0006\u0010\r\u001a\u00020\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J%\u0010\u0011\u001a\u00020\f2\b\u0010\u0012\u001a\u0004\u0018\u00010\u000e2\b\u0010\u0013\u001a\u0004\u0018\u00010\u00142\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J\u001b\u0010\u0015\u001a\u00020\f2\b\u0010\u0016\u001a\u0004\u0018\u00010\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J\u0019\u0010\u0017\u001a\u00020\f2\u0006\u0010\u0018\u001a\u00020\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J\u0014\u0010\u0019\u001a\u000e\u0012\u0004\u0012\u00020\u000e\u0012\u0004\u0012\u00020\u001b0\u001aH\u0016J\b\u0010\u001c\u001a\u00020\u000eH\u0016J\t\u0010\u001d\u001a\u00020\fH\u0097\u0001J\u0011\u0010\u001e\u001a\u00020\f2\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J\u001b\u0010\u001f\u001a\u00020\f2\b\u0010 \u001a\u0004\u0018\u00010\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0097\u0001J\t\u0010!\u001a\u00020\fH\u0097\u0001J\u0011\u0010\"\u001a\u00020\f2\u0006\u0010#\u001a\u00020\bH\u0097\u0001R\u0014\u0010\u0007\u001a\u00020\b8BX\u0082\u0004¢\u0006\u0006\u001a\u0004\b\t\u0010\n¨\u0006$"}, d2 = {"Lexpo/modules/devmenu/modules/DevMenuInternalModule;", "Lcom/facebook/react/bridge/ReactContextBaseJavaModule;", "Lexpo/modules/devmenu/modules/DevMenuInternalFontManagerModuleInterface;", "Lexpo/modules/devmenu/modules/DevMenuInternalMenuControllerModuleInterface;", "reactContext", "Lcom/facebook/react/bridge/ReactApplicationContext;", "(Lcom/facebook/react/bridge/ReactApplicationContext;)V", "doesDeviceSupportKeyCommands", "", "getDoesDeviceSupportKeyCommands", "()Z", "copyToClipboardAsync", "", "content", "", BaseJavaModule.METHOD_TYPE_PROMISE, "Lcom/facebook/react/bridge/Promise;", "dispatchCallableAsync", "callableId", "args", "Lcom/facebook/react/bridge/ReadableMap;", "fetchDataSourceAsync", "id", "fireCallback", "name", "getConstants", "", "", "getName", "hideMenu", "loadFontsAsync", "onScreenChangeAsync", "currentScreen", "openDevMenuFromReactNative", "setOnboardingFinished", "finished", "expo-dev-menu_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class DevMenuInternalModule extends ReactContextBaseJavaModule implements DevMenuInternalFontManagerModuleInterface, DevMenuInternalMenuControllerModuleInterface {
    private final /* synthetic */ DevMenuInternalFontManagerModule $$delegate_0;
    private final /* synthetic */ DevMenuInternalMenuControllerModule $$delegate_1;

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void copyToClipboardAsync(String content, Promise promise) {
        Intrinsics.checkNotNullParameter(content, "content");
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_1.copyToClipboardAsync(content, promise);
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void dispatchCallableAsync(String str, ReadableMap readableMap, Promise promise) {
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_1.dispatchCallableAsync(str, readableMap, promise);
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void fetchDataSourceAsync(String str, Promise promise) {
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_1.fetchDataSourceAsync(str, promise);
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void fireCallback(String name, Promise promise) {
        Intrinsics.checkNotNullParameter(name, "name");
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_1.fireCallback(name, promise);
    }

    @Override // com.facebook.react.bridge.NativeModule
    public String getName() {
        return "ExpoDevMenuInternal";
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void hideMenu() {
        this.$$delegate_1.hideMenu();
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalFontManagerModuleInterface
    @ReactMethod
    public void loadFontsAsync(Promise promise) {
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_0.loadFontsAsync(promise);
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void onScreenChangeAsync(String str, Promise promise) {
        Intrinsics.checkNotNullParameter(promise, "promise");
        this.$$delegate_1.onScreenChangeAsync(str, promise);
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void openDevMenuFromReactNative() {
        this.$$delegate_1.openDevMenuFromReactNative();
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalMenuControllerModuleInterface
    @ReactMethod
    public void setOnboardingFinished(boolean z) {
        this.$$delegate_1.setOnboardingFinished(z);
    }

    /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
    public DevMenuInternalModule(ReactApplicationContext reactContext) {
        super(reactContext);
        Intrinsics.checkNotNullParameter(reactContext, "reactContext");
        this.$$delegate_0 = new DevMenuInternalFontManagerModule(reactContext);
        this.$$delegate_1 = new DevMenuInternalMenuControllerModule(reactContext);
    }

    private final boolean getDoesDeviceSupportKeyCommands() {
        return EmulatorUtilities.INSTANCE.isRunningOnEmulator();
    }

    @Override // com.facebook.react.bridge.BaseJavaModule
    public Map<String, Object> getConstants() {
        return MapsKt.mapOf(TuplesKt.to("doesDeviceSupportKeyCommands", Boolean.valueOf(getDoesDeviceSupportKeyCommands())));
    }
}
