package expo.modules.devmenu.modules.internals;

import com.facebook.react.bridge.BaseJavaModule;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import expo.modules.devmenu.DevMenuManager;
import expo.modules.devmenu.modules.DevMenuInternalFontManagerModuleInterface;
import kotlin.Metadata;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: DevMenuInternalFontManagerModule.kt */
@Metadata(d1 = {"\u0000\u001e\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0010\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\u0018\u00002\u00020\u0001B\r\u0012\u0006\u0010\u0002\u001a\u00020\u0003¢\u0006\u0002\u0010\u0004J\u0010\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0007\u001a\u00020\bH\u0016R\u000e\u0010\u0002\u001a\u00020\u0003X\u0082\u0004¢\u0006\u0002\n\u0000¨\u0006\t"}, d2 = {"Lexpo/modules/devmenu/modules/internals/DevMenuInternalFontManagerModule;", "Lexpo/modules/devmenu/modules/DevMenuInternalFontManagerModuleInterface;", "reactContext", "Lcom/facebook/react/bridge/ReactApplicationContext;", "(Lcom/facebook/react/bridge/ReactApplicationContext;)V", "loadFontsAsync", "", BaseJavaModule.METHOD_TYPE_PROMISE, "Lcom/facebook/react/bridge/Promise;", "expo-dev-menu_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class DevMenuInternalFontManagerModule implements DevMenuInternalFontManagerModuleInterface {
    private final ReactApplicationContext reactContext;

    public DevMenuInternalFontManagerModule(ReactApplicationContext reactContext) {
        Intrinsics.checkNotNullParameter(reactContext, "reactContext");
        this.reactContext = reactContext;
    }

    @Override // expo.modules.devmenu.modules.DevMenuInternalFontManagerModuleInterface
    public void loadFontsAsync(Promise promise) {
        Intrinsics.checkNotNullParameter(promise, "promise");
        DevMenuManager.INSTANCE.loadFonts(this.reactContext);
        promise.resolve(null);
    }
}
