package expo.modules.devmenu.react;

import android.util.Log;
import com.facebook.react.ReactInstanceManager;
import com.facebook.react.devsupport.DevSupportManagerBase;
import com.facebook.react.devsupport.interfaces.DevSupportManager;
import com.facebook.react.packagerconnection.RequestHandler;
import expo.modules.devmenu.DevMenuManager;
import expo.modules.devmenu.helpers.DevMenuReflectionExtensionsKt;
import java.util.LinkedHashMap;
import java.util.Map;
import kotlin.Metadata;
import kotlin.collections.MapsKt;
import kotlin.jvm.internal.Intrinsics;
import kotlinx.coroutines.BuildersKt__Builders_commonKt;
/* compiled from: DevMenuPackagerCommandHandlersSwapper.kt */
@Metadata(d1 = {"\u0000(\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0002\b\u0002\n\u0002\u0010\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010$\n\u0002\u0010\u000e\n\u0002\u0018\u0002\n\u0002\b\u0002\u0018\u00002\u00020\u0001B\u0005¢\u0006\u0002\u0010\u0002J$\u0010\u0003\u001a\u00020\u00042\u0006\u0010\u0005\u001a\u00020\u00062\u0012\u0010\u0007\u001a\u000e\u0012\u0004\u0012\u00020\t\u0012\u0004\u0012\u00020\n0\bH\u0002J\"\u0010\u000b\u001a\u00020\u00042\u0006\u0010\u0005\u001a\u00020\u00062\u0012\u0010\u0007\u001a\u000e\u0012\u0004\u0012\u00020\t\u0012\u0004\u0012\u00020\n0\b¨\u0006\f"}, d2 = {"Lexpo/modules/devmenu/react/DevMenuPackagerCommandHandlersSwapper;", "", "()V", "swapCurrentCommandHandlers", "", "reactInstanceManager", "Lcom/facebook/react/ReactInstanceManager;", "handlers", "", "", "Lcom/facebook/react/packagerconnection/RequestHandler;", "swapPackagerCommandHandlers", "expo-dev-menu_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class DevMenuPackagerCommandHandlersSwapper {
    public final void swapPackagerCommandHandlers(ReactInstanceManager reactInstanceManager, Map<String, ? extends RequestHandler> handlers) {
        LinkedHashMap linkedHashMap;
        Intrinsics.checkNotNullParameter(reactInstanceManager, "reactInstanceManager");
        Intrinsics.checkNotNullParameter(handlers, "handlers");
        try {
            DevSupportManager devSupportManager = (DevSupportManager) DevMenuReflectionExtensionsKt.getPrivateDeclaredFieldValue(ReactInstanceManager.class, "mDevSupportManager", reactInstanceManager);
            if (devSupportManager instanceof DevSupportManagerBase) {
                Map map = (Map) DevMenuReflectionExtensionsKt.getPrivateDeclaredFieldValue(DevSupportManagerBase.class, "mCustomPackagerCommandHandlers", devSupportManager);
                if (map == null || (linkedHashMap = MapsKt.toMutableMap(map)) == null) {
                    linkedHashMap = new LinkedHashMap();
                }
                linkedHashMap.putAll(handlers);
                DevMenuReflectionExtensionsKt.setPrivateDeclaredFieldValue(DevSupportManagerBase.class, "mCustomPackagerCommandHandlers", devSupportManager, linkedHashMap);
                swapCurrentCommandHandlers(reactInstanceManager, handlers);
            }
        } catch (Exception e) {
            String message = e.getMessage();
            Log.w("DevMenu", "Couldn't add packager command handlers to current client: " + message, e);
        }
    }

    private final void swapCurrentCommandHandlers(ReactInstanceManager reactInstanceManager, Map<String, ? extends RequestHandler> map) {
        BuildersKt__Builders_commonKt.launch$default(DevMenuManager.INSTANCE.getCoroutineScope(), null, null, new DevMenuPackagerCommandHandlersSwapper$swapCurrentCommandHandlers$1(reactInstanceManager, map, null), 3, null);
    }
}
