package expo.modules.image.enums;

import android.graphics.Matrix;
import android.graphics.RectF;
import expo.modules.kotlin.types.Enumerable;
import kotlin.Metadata;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: ContentFit.kt */
@Metadata(d1 = {"\u0000$\n\u0002\u0018\u0002\n\u0002\u0010\u0010\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010\u000e\n\u0002\b\u0004\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\b\b\u0086\u0001\u0018\u00002\b\u0012\u0004\u0012\u00020\u00000\u00012\u00020\u0002B\u000f\b\u0002\u0012\u0006\u0010\u0003\u001a\u00020\u0004¢\u0006\u0002\u0010\u0005J\u001d\u0010\b\u001a\u00020\t2\u0006\u0010\n\u001a\u00020\u000b2\u0006\u0010\f\u001a\u00020\u000bH\u0000¢\u0006\u0002\b\rR\u0011\u0010\u0003\u001a\u00020\u0004¢\u0006\b\n\u0000\u001a\u0004\b\u0006\u0010\u0007j\u0002\b\u000ej\u0002\b\u000fj\u0002\b\u0010j\u0002\b\u0011j\u0002\b\u0012¨\u0006\u0013"}, d2 = {"Lexpo/modules/image/enums/ContentFit;", "", "Lexpo/modules/kotlin/types/Enumerable;", "value", "", "(Ljava/lang/String;ILjava/lang/String;)V", "getValue", "()Ljava/lang/String;", "toMatrix", "Landroid/graphics/Matrix;", "imageRect", "Landroid/graphics/RectF;", "viewRect", "toMatrix$expo_image_release", "Contain", "Cover", "Fill", "None", "ScaleDown", "expo-image_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public enum ContentFit implements Enumerable {
    Contain("contain"),
    Cover("cover"),
    Fill("fill"),
    None("none"),
    ScaleDown("scale-down");
    
    private final String value;

    /* compiled from: ContentFit.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* loaded from: classes3.dex */
    public /* synthetic */ class WhenMappings {
        public static final /* synthetic */ int[] $EnumSwitchMapping$0;

        static {
            int[] iArr = new int[ContentFit.values().length];
            iArr[ContentFit.Contain.ordinal()] = 1;
            iArr[ContentFit.Cover.ordinal()] = 2;
            iArr[ContentFit.Fill.ordinal()] = 3;
            iArr[ContentFit.None.ordinal()] = 4;
            iArr[ContentFit.ScaleDown.ordinal()] = 5;
            $EnumSwitchMapping$0 = iArr;
        }
    }

    ContentFit(String str) {
        this.value = str;
    }

    public final String getValue() {
        return this.value;
    }

    public final Matrix toMatrix$expo_image_release(RectF imageRect, RectF viewRect) {
        Intrinsics.checkNotNullParameter(imageRect, "imageRect");
        Intrinsics.checkNotNullParameter(viewRect, "viewRect");
        Matrix matrix = new Matrix();
        int i = WhenMappings.$EnumSwitchMapping$0[ordinal()];
        if (i == 1) {
            matrix.setRectToRect(imageRect, viewRect, Matrix.ScaleToFit.START);
        } else if (i == 2) {
            float width = imageRect.width();
            float height = imageRect.height();
            float max = Math.max(viewRect.width() / width, viewRect.height() / height);
            matrix.setScale(max, max);
        } else if (i == 3) {
            matrix.setRectToRect(imageRect, viewRect, Matrix.ScaleToFit.FILL);
        } else if (i == 5 && (imageRect.width() >= viewRect.width() || imageRect.height() >= viewRect.height())) {
            matrix.setRectToRect(imageRect, viewRect, Matrix.ScaleToFit.START);
        }
        return matrix;
    }
}
