package expo.modules.image.svg;

import android.widget.ImageView;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.ImageViewTarget;
import com.bumptech.glide.request.target.Target;
import com.facebook.react.uimanager.events.TouchesHelper;
import io.sentry.protocol.Device;
import kotlin.Metadata;
import kotlin.jvm.internal.DefaultConstructorMarker;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: SVGSoftwareLayerSetter.kt */
@Metadata(d1 = {"\u00006\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0000\n\u0002\u0010\b\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010\u000b\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0005\n\u0002\u0018\u0002\n\u0000\u0018\u00002\b\u0012\u0004\u0012\u00020\u00020\u0001B\u0011\b\u0007\u0012\b\b\u0002\u0010\u0003\u001a\u00020\u0004¢\u0006\u0002\u0010\u0005J\u0018\u0010\u0006\u001a\u0004\u0018\u00010\u00072\f\u0010\b\u001a\b\u0012\u0004\u0012\u00020\u00020\tH\u0002J2\u0010\n\u001a\u00020\u000b2\b\u0010\f\u001a\u0004\u0018\u00010\r2\b\u0010\u000e\u001a\u0004\u0018\u00010\u00022\f\u0010\b\u001a\b\u0012\u0004\u0012\u00020\u00020\t2\u0006\u0010\u000f\u001a\u00020\u000bH\u0016J6\u0010\u0010\u001a\u00020\u000b2\u0006\u0010\u0011\u001a\u00020\u00022\u0006\u0010\u000e\u001a\u00020\u00022\f\u0010\b\u001a\b\u0012\u0004\u0012\u00020\u00020\t2\u0006\u0010\u0012\u001a\u00020\u00132\u0006\u0010\u000f\u001a\u00020\u000bH\u0016R\u000e\u0010\u0003\u001a\u00020\u0004X\u0082\u0004¢\u0006\u0002\n\u0000¨\u0006\u0014"}, d2 = {"Lexpo/modules/image/svg/SVGSoftwareLayerSetter;", "Lcom/bumptech/glide/request/RequestListener;", "", "mDefaultLayerType", "", "(I)V", "getViewOfTarget", "Landroid/widget/ImageView;", TouchesHelper.TARGET_KEY, "Lcom/bumptech/glide/request/target/Target;", "onLoadFailed", "", "e", "Lcom/bumptech/glide/load/engine/GlideException;", Device.JsonKeys.MODEL, "isFirstResource", "onResourceReady", "resource", "dataSource", "Lcom/bumptech/glide/load/DataSource;", "expo-image_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class SVGSoftwareLayerSetter implements RequestListener<Object> {
    private final int mDefaultLayerType;

    public SVGSoftwareLayerSetter() {
        this(0, 1, null);
    }

    public SVGSoftwareLayerSetter(int i) {
        this.mDefaultLayerType = i;
    }

    public /* synthetic */ SVGSoftwareLayerSetter(int i, int i2, DefaultConstructorMarker defaultConstructorMarker) {
        this((i2 & 1) != 0 ? 0 : i);
    }

    @Override // com.bumptech.glide.request.RequestListener
    public boolean onLoadFailed(GlideException glideException, Object obj, Target<Object> target, boolean z) {
        Intrinsics.checkNotNullParameter(target, "target");
        ImageView viewOfTarget = getViewOfTarget(target);
        if (viewOfTarget != null) {
            viewOfTarget.setLayerType(this.mDefaultLayerType, null);
            return false;
        }
        return false;
    }

    @Override // com.bumptech.glide.request.RequestListener
    public boolean onResourceReady(Object resource, Object model, Target<Object> target, DataSource dataSource, boolean z) {
        Intrinsics.checkNotNullParameter(resource, "resource");
        Intrinsics.checkNotNullParameter(model, "model");
        Intrinsics.checkNotNullParameter(target, "target");
        Intrinsics.checkNotNullParameter(dataSource, "dataSource");
        ImageView viewOfTarget = getViewOfTarget(target);
        if (viewOfTarget == null || !(resource instanceof SVGDrawable)) {
            return false;
        }
        viewOfTarget.setLayerType(1, null);
        return false;
    }

    private final ImageView getViewOfTarget(Target<Object> target) {
        if (target instanceof ImageViewTarget) {
            return ((ImageViewTarget) target).getView();
        }
        return null;
    }
}
