package expo.modules.imagepicker;

import android.content.ContentResolver;
import android.content.Context;
import android.media.MediaMetadataRetriever;
import android.net.Uri;
import android.os.Bundle;
import android.util.Base64;
import com.facebook.imagepipeline.memory.BitmapCounterConfig;
import expo.modules.imagepicker.exporters.CompressionImageExporter;
import expo.modules.imagepicker.exporters.ImageExportResult;
import expo.modules.imagepicker.exporters.RawImageExporter;
import expo.modules.kotlin.providers.AppContextProvider;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import kotlin.Metadata;
import kotlin.NoWhenBranchMatchedException;
import kotlin.Pair;
import kotlin.ResultKt;
import kotlin.collections.CollectionsKt;
import kotlin.coroutines.Continuation;
import kotlin.coroutines.intrinsics.IntrinsicsKt;
import kotlin.coroutines.jvm.internal.Boxing;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: MediaHandler.kt */
@Metadata(d1 = {"\u0000L\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0002\b\u0003\n\u0002\u0018\u0002\n\u0002\b\u0003\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0004\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010 \n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0003\b\u0000\u0018\u00002\u00020\u0001B\r\u0012\u0006\u0010\u0002\u001a\u00020\u0003¢\u0006\u0002\u0010\u0004J!\u0010\r\u001a\u00020\u000e2\u0006\u0010\u000f\u001a\u00020\u00102\u0006\u0010\u0011\u001a\u00020\u0012H\u0082@ø\u0001\u0000¢\u0006\u0002\u0010\u0013J\u0019\u0010\u0014\u001a\u00020\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0082@ø\u0001\u0000¢\u0006\u0002\u0010\u0015J5\u0010\u0016\u001a\u00020\u00172\u0018\u0010\u0018\u001a\u0014\u0012\u0010\u0012\u000e\u0012\u0004\u0012\u00020\u001b\u0012\u0004\u0012\u00020\u00100\u001a0\u00192\u0006\u0010\u0011\u001a\u00020\u0012H\u0080@ø\u0001\u0000¢\u0006\u0004\b\u001c\u0010\u001dR\u000e\u0010\u0002\u001a\u00020\u0003X\u0082\u0004¢\u0006\u0002\n\u0000R\u0014\u0010\u0005\u001a\u00020\u00068BX\u0082\u0004¢\u0006\u0006\u001a\u0004\b\u0007\u0010\bR\u0014\u0010\t\u001a\u00020\n8BX\u0082\u0004¢\u0006\u0006\u001a\u0004\b\u000b\u0010\f\u0082\u0002\u0004\n\u0002\b\u0019¨\u0006\u001e"}, d2 = {"Lexpo/modules/imagepicker/MediaHandler;", "", "appContextProvider", "Lexpo/modules/kotlin/providers/AppContextProvider;", "(Lexpo/modules/kotlin/providers/AppContextProvider;)V", "cacheDirectory", "Ljava/io/File;", "getCacheDirectory", "()Ljava/io/File;", "context", "Landroid/content/Context;", "getContext", "()Landroid/content/Context;", "handleImage", "Lexpo/modules/imagepicker/ImagePickerAsset;", "sourceUri", "Landroid/net/Uri;", "options", "Lexpo/modules/imagepicker/ImagePickerOptions;", "(Landroid/net/Uri;Lexpo/modules/imagepicker/ImagePickerOptions;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "handleVideo", "(Landroid/net/Uri;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "readExtras", "Lexpo/modules/imagepicker/ImagePickerResponse;", "bareResult", "", "Lkotlin/Pair;", "Lexpo/modules/imagepicker/MediaType;", "readExtras$expo_image_picker_release", "(Ljava/util/List;Lexpo/modules/imagepicker/ImagePickerOptions;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "expo-image-picker_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class MediaHandler {
    private final AppContextProvider appContextProvider;

    /* compiled from: MediaHandler.kt */
    @Metadata(k = 3, mv = {1, 7, 1}, xi = 48)
    /* loaded from: classes3.dex */
    public /* synthetic */ class WhenMappings {
        public static final /* synthetic */ int[] $EnumSwitchMapping$0;

        static {
            int[] iArr = new int[MediaType.values().length];
            iArr[MediaType.VIDEO.ordinal()] = 1;
            iArr[MediaType.IMAGE.ordinal()] = 2;
            $EnumSwitchMapping$0 = iArr;
        }
    }

    public MediaHandler(AppContextProvider appContextProvider) {
        Intrinsics.checkNotNullParameter(appContextProvider, "appContextProvider");
        this.appContextProvider = appContextProvider;
    }

    private final Context getContext() {
        Context reactContext = this.appContextProvider.getAppContext().getReactContext();
        if (reactContext != null) {
            return reactContext;
        }
        throw new IllegalArgumentException("React Application Context is null".toString());
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Removed duplicated region for block: B:10:0x0025  */
    /* JADX WARN: Removed duplicated region for block: B:16:0x0063  */
    /* JADX WARN: Removed duplicated region for block: B:19:0x0084  */
    /* JADX WARN: Removed duplicated region for block: B:35:0x00df  */
    /* JADX WARN: Type inference failed for: r10v12, types: [java.util.Collection] */
    /* JADX WARN: Type inference failed for: r10v15, types: [java.util.Collection] */
    /* JADX WARN: Type inference failed for: r2v10 */
    /* JADX WARN: Type inference failed for: r2v12 */
    /* JADX WARN: Type inference failed for: r2v13 */
    /* JADX WARN: Type inference failed for: r2v14 */
    /* JADX WARN: Type inference failed for: r2v16, types: [java.util.Collection] */
    /* JADX WARN: Type inference failed for: r2v18, types: [java.util.Collection] */
    /* JADX WARN: Type inference failed for: r2v3 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:25:0x00b5 -> B:26:0x00b8). Please submit an issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:33:0x00d7 -> B:34:0x00d9). Please submit an issue!!! */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object readExtras$expo_image_picker_release(List<? extends Pair<? extends MediaType, ? extends Uri>> list, ImagePickerOptions imagePickerOptions, Continuation<? super ImagePickerResponse> continuation) {
        MediaHandler$readExtras$1 mediaHandler$readExtras$1;
        int i;
        MediaHandler mediaHandler;
        Iterator it;
        ArrayList arrayList;
        ImagePickerOptions imagePickerOptions2;
        ArrayList arrayList2;
        ImagePickerOptions imagePickerOptions3;
        ?? r2;
        ImagePickerAsset imagePickerAsset;
        ArrayList arrayList3;
        if (continuation instanceof MediaHandler$readExtras$1) {
            mediaHandler$readExtras$1 = (MediaHandler$readExtras$1) continuation;
            if ((mediaHandler$readExtras$1.label & Integer.MIN_VALUE) != 0) {
                mediaHandler$readExtras$1.label -= Integer.MIN_VALUE;
                Object obj = mediaHandler$readExtras$1.result;
                Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = mediaHandler$readExtras$1.label;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    List<? extends Pair<? extends MediaType, ? extends Uri>> list2 = list;
                    mediaHandler = this;
                    it = list2.iterator();
                    arrayList = new ArrayList(CollectionsKt.collectionSizeOrDefault(list2, 10));
                    imagePickerOptions2 = imagePickerOptions;
                    if (it.hasNext()) {
                    }
                } else if (i == 1) {
                    it = (Iterator) mediaHandler$readExtras$1.L$3;
                    r2 = (Collection) mediaHandler$readExtras$1.L$2;
                    imagePickerOptions3 = (ImagePickerOptions) mediaHandler$readExtras$1.L$1;
                    mediaHandler = (MediaHandler) mediaHandler$readExtras$1.L$0;
                    ResultKt.throwOnFailure(obj);
                    arrayList2 = (Collection) mediaHandler$readExtras$1.L$4;
                    imagePickerAsset = (ImagePickerAsset) obj;
                    arrayList3 = arrayList2;
                    arrayList3.add(imagePickerAsset);
                    arrayList = r2;
                    imagePickerOptions2 = imagePickerOptions3;
                    if (it.hasNext()) {
                    }
                } else if (i == 2) {
                    it = (Iterator) mediaHandler$readExtras$1.L$3;
                    r2 = (Collection) mediaHandler$readExtras$1.L$2;
                    imagePickerOptions3 = (ImagePickerOptions) mediaHandler$readExtras$1.L$1;
                    mediaHandler = (MediaHandler) mediaHandler$readExtras$1.L$0;
                    ResultKt.throwOnFailure(obj);
                    ArrayList arrayList4 = (Collection) mediaHandler$readExtras$1.L$4;
                    imagePickerAsset = (ImagePickerAsset) obj;
                    arrayList3 = arrayList4;
                    arrayList3.add(imagePickerAsset);
                    arrayList = r2;
                    imagePickerOptions2 = imagePickerOptions3;
                    if (it.hasNext()) {
                        Pair pair = (Pair) it.next();
                        Uri uri = (Uri) pair.component2();
                        int i2 = WhenMappings.$EnumSwitchMapping$0[((MediaType) pair.component1()).ordinal()];
                        if (i2 == 1) {
                            mediaHandler$readExtras$1.L$0 = mediaHandler;
                            mediaHandler$readExtras$1.L$1 = imagePickerOptions2;
                            mediaHandler$readExtras$1.L$2 = arrayList;
                            mediaHandler$readExtras$1.L$3 = it;
                            mediaHandler$readExtras$1.L$4 = arrayList;
                            mediaHandler$readExtras$1.label = 1;
                            Object handleVideo = mediaHandler.handleVideo(uri, mediaHandler$readExtras$1);
                            if (handleVideo == coroutine_suspended) {
                                return coroutine_suspended;
                            }
                            imagePickerOptions3 = imagePickerOptions2;
                            obj = handleVideo;
                            r2 = arrayList;
                            arrayList2 = arrayList;
                            imagePickerAsset = (ImagePickerAsset) obj;
                            arrayList3 = arrayList2;
                            arrayList3.add(imagePickerAsset);
                            arrayList = r2;
                            imagePickerOptions2 = imagePickerOptions3;
                            if (it.hasNext()) {
                                return new ImagePickerResponse(false, arrayList);
                            }
                        } else if (i2 != 2) {
                            throw new NoWhenBranchMatchedException();
                        } else {
                            mediaHandler$readExtras$1.L$0 = mediaHandler;
                            mediaHandler$readExtras$1.L$1 = imagePickerOptions2;
                            mediaHandler$readExtras$1.L$2 = arrayList;
                            mediaHandler$readExtras$1.L$3 = it;
                            mediaHandler$readExtras$1.L$4 = arrayList;
                            mediaHandler$readExtras$1.label = 2;
                            Object handleImage = mediaHandler.handleImage(uri, imagePickerOptions2, mediaHandler$readExtras$1);
                            if (handleImage == coroutine_suspended) {
                                return coroutine_suspended;
                            }
                            imagePickerOptions3 = imagePickerOptions2;
                            obj = handleImage;
                            r2 = arrayList;
                            arrayList4 = arrayList;
                            imagePickerAsset = (ImagePickerAsset) obj;
                            arrayList3 = arrayList4;
                            arrayList3.add(imagePickerAsset);
                            arrayList = r2;
                            imagePickerOptions2 = imagePickerOptions3;
                            if (it.hasNext()) {
                            }
                        }
                    }
                } else {
                    throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                }
            }
        }
        mediaHandler$readExtras$1 = new MediaHandler$readExtras$1(this, continuation);
        Object obj2 = mediaHandler$readExtras$1.result;
        Object coroutine_suspended2 = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = mediaHandler$readExtras$1.label;
        if (i != 0) {
        }
    }

    private final File getCacheDirectory() {
        return this.appContextProvider.getAppContext().getCacheDirectory();
    }

    /* JADX INFO: Access modifiers changed from: private */
    /* JADX WARN: Removed duplicated region for block: B:10:0x002f  */
    /* JADX WARN: Removed duplicated region for block: B:18:0x0082  */
    /* JADX WARN: Removed duplicated region for block: B:32:0x00f4  */
    /* JADX WARN: Removed duplicated region for block: B:34:0x00f7  */
    /* JADX WARN: Removed duplicated region for block: B:40:0x0124  */
    /* JADX WARN: Removed duplicated region for block: B:41:0x0132  */
    /* JADX WARN: Removed duplicated region for block: B:46:0x0149  */
    /* JADX WARN: Removed duplicated region for block: B:48:0x014c  */
    /* JADX WARN: Removed duplicated region for block: B:54:0x017a  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object handleImage(Uri uri, ImagePickerOptions imagePickerOptions, Continuation<? super ImagePickerAsset> continuation) {
        MediaHandler$handleImage$1 mediaHandler$handleImage$1;
        int i;
        CompressionImageExporter compressionImageExporter;
        File createOutputFile;
        ImagePickerOptions imagePickerOptions2;
        MediaHandler mediaHandler;
        ImageExportResult imageExportResult;
        Boolean boxBoolean;
        Uri uri2;
        ImageExportResult imageExportResult2;
        ImagePickerOptions imagePickerOptions3;
        MediaHandler mediaHandler2;
        String str;
        Boolean boxBoolean2;
        String str2;
        ImageExportResult imageExportResult3;
        Uri uri3;
        ByteArrayOutputStream byteArrayOutputStream;
        Uri uri4 = uri;
        if (continuation instanceof MediaHandler$handleImage$1) {
            mediaHandler$handleImage$1 = (MediaHandler$handleImage$1) continuation;
            if ((mediaHandler$handleImage$1.label & Integer.MIN_VALUE) != 0) {
                mediaHandler$handleImage$1.label -= Integer.MIN_VALUE;
                Object obj = mediaHandler$handleImage$1.result;
                Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = mediaHandler$handleImage$1.label;
                Bundle bundle = null;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    if (imagePickerOptions.getQuality() == 1.0d) {
                        compressionImageExporter = new RawImageExporter();
                    } else {
                        compressionImageExporter = new CompressionImageExporter(this.appContextProvider, imagePickerOptions.getQuality());
                    }
                    File cacheDirectory = getCacheDirectory();
                    ContentResolver contentResolver = getContext().getContentResolver();
                    Intrinsics.checkNotNullExpressionValue(contentResolver, "context.contentResolver");
                    createOutputFile = ImagePickerUtilsKt.createOutputFile(cacheDirectory, ImagePickerUtilsKt.toImageFileExtension(ImagePickerUtilsKt.getType(contentResolver, uri4)));
                    ContentResolver contentResolver2 = getContext().getContentResolver();
                    Intrinsics.checkNotNullExpressionValue(contentResolver2, "context.contentResolver");
                    mediaHandler$handleImage$1.L$0 = this;
                    mediaHandler$handleImage$1.L$1 = uri4;
                    imagePickerOptions2 = imagePickerOptions;
                    mediaHandler$handleImage$1.L$2 = imagePickerOptions2;
                    mediaHandler$handleImage$1.L$3 = createOutputFile;
                    mediaHandler$handleImage$1.label = 1;
                    obj = compressionImageExporter.exportAsync(uri4, createOutputFile, contentResolver2, mediaHandler$handleImage$1);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                    mediaHandler = this;
                } else if (i == 1) {
                    mediaHandler = (MediaHandler) mediaHandler$handleImage$1.L$0;
                    ResultKt.throwOnFailure(obj);
                    imagePickerOptions2 = (ImagePickerOptions) mediaHandler$handleImage$1.L$2;
                    createOutputFile = (File) mediaHandler$handleImage$1.L$3;
                    uri4 = (Uri) mediaHandler$handleImage$1.L$1;
                } else if (i != 2) {
                    if (i != 3) {
                        throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                    }
                    str = (String) mediaHandler$handleImage$1.L$3;
                    imageExportResult3 = (ImageExportResult) mediaHandler$handleImage$1.L$2;
                    createOutputFile = (File) mediaHandler$handleImage$1.L$1;
                    uri3 = (Uri) mediaHandler$handleImage$1.L$0;
                    ResultKt.throwOnFailure(obj);
                    bundle = (Bundle) obj;
                    str2 = str;
                    uri2 = uri3;
                    imageExportResult = imageExportResult3;
                    Bundle bundle2 = bundle;
                    MediaType mediaType = MediaType.IMAGE;
                    String uri5 = Uri.fromFile(createOutputFile).toString();
                    int width = imageExportResult.getWidth();
                    int height = imageExportResult.getHeight();
                    String mediaStoreAssetId = ImagePickerUtilsKt.getMediaStoreAssetId(uri2);
                    Intrinsics.checkNotNullExpressionValue(uri5, "toString()");
                    return new ImagePickerAsset(mediaStoreAssetId, mediaType, uri5, width, height, str2, bundle2, null, null, BitmapCounterConfig.DEFAULT_MAX_BITMAP_COUNT, null);
                } else {
                    imageExportResult2 = (ImageExportResult) mediaHandler$handleImage$1.L$4;
                    createOutputFile = (File) mediaHandler$handleImage$1.L$3;
                    imagePickerOptions3 = (ImagePickerOptions) mediaHandler$handleImage$1.L$2;
                    uri2 = (Uri) mediaHandler$handleImage$1.L$1;
                    mediaHandler2 = (MediaHandler) mediaHandler$handleImage$1.L$0;
                    ResultKt.throwOnFailure(obj);
                    byteArrayOutputStream = (ByteArrayOutputStream) obj;
                    if (byteArrayOutputStream == null) {
                        String encodeToString = Base64.encodeToString(byteArrayOutputStream.toByteArray(), 2);
                        imageExportResult = imageExportResult2;
                        str = encodeToString;
                        boxBoolean2 = Boxing.boxBoolean(imagePickerOptions3.getExif());
                        if (!boxBoolean2.booleanValue()) {
                            boxBoolean2 = null;
                        }
                        if (boxBoolean2 == null) {
                            boxBoolean2.booleanValue();
                            ContentResolver contentResolver3 = mediaHandler2.getContext().getContentResolver();
                            Intrinsics.checkNotNullExpressionValue(contentResolver3, "context.contentResolver");
                            mediaHandler$handleImage$1.L$0 = uri2;
                            mediaHandler$handleImage$1.L$1 = createOutputFile;
                            mediaHandler$handleImage$1.L$2 = imageExportResult;
                            mediaHandler$handleImage$1.L$3 = str;
                            mediaHandler$handleImage$1.L$4 = null;
                            mediaHandler$handleImage$1.label = 3;
                            Object exif = imageExportResult.exif(contentResolver3, mediaHandler$handleImage$1);
                            if (exif == coroutine_suspended) {
                                return coroutine_suspended;
                            }
                            imageExportResult3 = imageExportResult;
                            obj = exif;
                            uri3 = uri2;
                            bundle = (Bundle) obj;
                            str2 = str;
                            uri2 = uri3;
                            imageExportResult = imageExportResult3;
                            Bundle bundle22 = bundle;
                            MediaType mediaType2 = MediaType.IMAGE;
                            String uri52 = Uri.fromFile(createOutputFile).toString();
                            int width2 = imageExportResult.getWidth();
                            int height2 = imageExportResult.getHeight();
                            String mediaStoreAssetId2 = ImagePickerUtilsKt.getMediaStoreAssetId(uri2);
                            Intrinsics.checkNotNullExpressionValue(uri52, "toString()");
                            return new ImagePickerAsset(mediaStoreAssetId2, mediaType2, uri52, width2, height2, str2, bundle22, null, null, BitmapCounterConfig.DEFAULT_MAX_BITMAP_COUNT, null);
                        }
                        str2 = str;
                        Bundle bundle222 = bundle;
                        MediaType mediaType22 = MediaType.IMAGE;
                        String uri522 = Uri.fromFile(createOutputFile).toString();
                        int width22 = imageExportResult.getWidth();
                        int height22 = imageExportResult.getHeight();
                        String mediaStoreAssetId22 = ImagePickerUtilsKt.getMediaStoreAssetId(uri2);
                        Intrinsics.checkNotNullExpressionValue(uri522, "toString()");
                        return new ImagePickerAsset(mediaStoreAssetId22, mediaType22, uri522, width22, height22, str2, bundle222, null, null, BitmapCounterConfig.DEFAULT_MAX_BITMAP_COUNT, null);
                    }
                    imageExportResult = imageExportResult2;
                    uri4 = uri2;
                    mediaHandler = mediaHandler2;
                    imagePickerOptions2 = imagePickerOptions3;
                    imagePickerOptions3 = imagePickerOptions2;
                    mediaHandler2 = mediaHandler;
                    uri2 = uri4;
                    str = null;
                    boxBoolean2 = Boxing.boxBoolean(imagePickerOptions3.getExif());
                    if (!boxBoolean2.booleanValue()) {
                    }
                    if (boxBoolean2 == null) {
                    }
                }
                imageExportResult = (ImageExportResult) obj;
                boxBoolean = Boxing.boxBoolean(imagePickerOptions2.getBase64());
                if (!boxBoolean.booleanValue()) {
                    boxBoolean = null;
                }
                if (boxBoolean != null) {
                    boxBoolean.booleanValue();
                    ContentResolver contentResolver4 = mediaHandler.getContext().getContentResolver();
                    Intrinsics.checkNotNullExpressionValue(contentResolver4, "context.contentResolver");
                    mediaHandler$handleImage$1.L$0 = mediaHandler;
                    mediaHandler$handleImage$1.L$1 = uri4;
                    mediaHandler$handleImage$1.L$2 = imagePickerOptions2;
                    mediaHandler$handleImage$1.L$3 = createOutputFile;
                    mediaHandler$handleImage$1.L$4 = imageExportResult;
                    mediaHandler$handleImage$1.label = 2;
                    Object data = imageExportResult.data(contentResolver4, mediaHandler$handleImage$1);
                    if (data == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                    MediaHandler mediaHandler3 = mediaHandler;
                    uri2 = uri4;
                    imageExportResult2 = imageExportResult;
                    obj = data;
                    imagePickerOptions3 = imagePickerOptions2;
                    mediaHandler2 = mediaHandler3;
                    byteArrayOutputStream = (ByteArrayOutputStream) obj;
                    if (byteArrayOutputStream == null) {
                    }
                }
                imagePickerOptions3 = imagePickerOptions2;
                mediaHandler2 = mediaHandler;
                uri2 = uri4;
                str = null;
                boxBoolean2 = Boxing.boxBoolean(imagePickerOptions3.getExif());
                if (!boxBoolean2.booleanValue()) {
                }
                if (boxBoolean2 == null) {
                }
            }
        }
        mediaHandler$handleImage$1 = new MediaHandler$handleImage$1(this, continuation);
        Object obj2 = mediaHandler$handleImage$1.result;
        Object coroutine_suspended2 = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = mediaHandler$handleImage$1.label;
        Bundle bundle3 = null;
        if (i != 0) {
        }
        imageExportResult = (ImageExportResult) obj2;
        boxBoolean = Boxing.boxBoolean(imagePickerOptions2.getBase64());
        if (!boxBoolean.booleanValue()) {
        }
        if (boxBoolean != null) {
        }
        imagePickerOptions3 = imagePickerOptions2;
        mediaHandler2 = mediaHandler;
        uri2 = uri4;
        str = null;
        boxBoolean2 = Boxing.boxBoolean(imagePickerOptions3.getExif());
        if (!boxBoolean2.booleanValue()) {
        }
        if (boxBoolean2 == null) {
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    /* JADX WARN: Removed duplicated region for block: B:10:0x002a  */
    /* JADX WARN: Removed duplicated region for block: B:14:0x0046  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object handleVideo(Uri uri, Continuation<? super ImagePickerAsset> continuation) {
        MediaHandler$handleVideo$1 mediaHandler$handleVideo$1;
        int i;
        File createOutputFile;
        MediaHandler mediaHandler;
        Uri uri2 = uri;
        try {
            if (continuation instanceof MediaHandler$handleVideo$1) {
                mediaHandler$handleVideo$1 = (MediaHandler$handleVideo$1) continuation;
                if ((mediaHandler$handleVideo$1.label & Integer.MIN_VALUE) != 0) {
                    mediaHandler$handleVideo$1.label -= Integer.MIN_VALUE;
                    Object obj = mediaHandler$handleVideo$1.result;
                    Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                    i = mediaHandler$handleVideo$1.label;
                    if (i != 0) {
                        ResultKt.throwOnFailure(obj);
                        createOutputFile = ImagePickerUtilsKt.createOutputFile(getCacheDirectory(), ".mp4");
                        ContentResolver contentResolver = getContext().getContentResolver();
                        Intrinsics.checkNotNullExpressionValue(contentResolver, "context.contentResolver");
                        mediaHandler$handleVideo$1.L$0 = this;
                        mediaHandler$handleVideo$1.L$1 = uri2;
                        mediaHandler$handleVideo$1.L$2 = createOutputFile;
                        mediaHandler$handleVideo$1.label = 1;
                        if (ImagePickerUtilsKt.copyFile(uri2, createOutputFile, contentResolver, mediaHandler$handleVideo$1) == coroutine_suspended) {
                            return coroutine_suspended;
                        }
                        mediaHandler = this;
                    } else if (i != 1) {
                        throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                    } else {
                        mediaHandler = (MediaHandler) mediaHandler$handleVideo$1.L$0;
                        ResultKt.throwOnFailure(obj);
                        createOutputFile = (File) mediaHandler$handleVideo$1.L$2;
                        uri2 = (Uri) mediaHandler$handleVideo$1.L$1;
                    }
                    Uri fromFile = Uri.fromFile(createOutputFile);
                    Intrinsics.checkNotNullExpressionValue(fromFile, "fromFile(this)");
                    MediaMetadataRetriever mediaMetadataRetriever = new MediaMetadataRetriever();
                    mediaMetadataRetriever.setDataSource(mediaHandler.getContext(), fromFile);
                    MediaType mediaType = MediaType.VIDEO;
                    String uri3 = fromFile.toString();
                    int extractInt = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever, 18);
                    int extractInt2 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever, 19);
                    int extractInt3 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever, 9);
                    int extractInt4 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever, 24);
                    String mediaStoreAssetId = ImagePickerUtilsKt.getMediaStoreAssetId(uri2);
                    Intrinsics.checkNotNullExpressionValue(uri3, "toString()");
                    return new ImagePickerAsset(mediaStoreAssetId, mediaType, uri3, extractInt, extractInt2, null, null, Boxing.boxInt(extractInt3), Boxing.boxInt(extractInt4), 96, null);
                }
            }
            MediaMetadataRetriever mediaMetadataRetriever2 = new MediaMetadataRetriever();
            mediaMetadataRetriever2.setDataSource(mediaHandler.getContext(), fromFile);
            MediaType mediaType2 = MediaType.VIDEO;
            String uri32 = fromFile.toString();
            int extractInt5 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever2, 18);
            int extractInt22 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever2, 19);
            int extractInt32 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever2, 9);
            int extractInt42 = ImagePickerUtilsKt.extractInt(mediaMetadataRetriever2, 24);
            String mediaStoreAssetId2 = ImagePickerUtilsKt.getMediaStoreAssetId(uri2);
            Intrinsics.checkNotNullExpressionValue(uri32, "toString()");
            return new ImagePickerAsset(mediaStoreAssetId2, mediaType2, uri32, extractInt5, extractInt22, null, null, Boxing.boxInt(extractInt32), Boxing.boxInt(extractInt42), 96, null);
        } catch (FailedToExtractVideoMetadataException e) {
            throw new FailedToExtractVideoMetadataException(createOutputFile, e);
        }
        mediaHandler$handleVideo$1 = new MediaHandler$handleVideo$1(this, continuation);
        Object obj2 = mediaHandler$handleVideo$1.result;
        Object coroutine_suspended2 = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = mediaHandler$handleVideo$1.label;
        if (i != 0) {
        }
        Uri fromFile2 = Uri.fromFile(createOutputFile);
        Intrinsics.checkNotNullExpressionValue(fromFile2, "fromFile(this)");
    }
}
