package expo.modules.imagepicker.exporters;

import android.content.ContentResolver;
import android.graphics.Bitmap;
import android.net.Uri;
import expo.modules.imagepicker.ImagePickerUtilsKt;
import expo.modules.kotlin.providers.AppContextProvider;
import java.io.ByteArrayOutputStream;
import java.io.File;
import kotlin.Metadata;
import kotlin.ResultKt;
import kotlin.coroutines.Continuation;
import kotlin.coroutines.intrinsics.IntrinsicsKt;
import kotlin.jvm.internal.Intrinsics;
import kotlinx.coroutines.InterruptibleKt;
/* compiled from: CompressionImageExporter.kt */
@Metadata(d1 = {"\u0000P\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0010\u0006\n\u0002\b\u0002\n\u0002\u0010\b\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\n\u0002\u0010\u000b\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0002\b\u0002\u0018\u00002\u00020\u0001B\u0017\u0012\u0006\u0010\u0002\u001a\u00020\u0003\u0012\b\b\u0001\u0010\u0004\u001a\u00020\u0005¢\u0006\u0002\u0010\u0006J)\u0010\t\u001a\u00020\n2\u0006\u0010\u000b\u001a\u00020\f2\u0006\u0010\r\u001a\u00020\u000e2\u0006\u0010\u000f\u001a\u00020\u0010H\u0096@ø\u0001\u0000¢\u0006\u0002\u0010\u0011J\u0019\u0010\u0012\u001a\u00020\u00132\u0006\u0010\u000b\u001a\u00020\fH\u0082@ø\u0001\u0000¢\u0006\u0002\u0010\u0014J)\u0010\u0015\u001a\u00020\u00162\u0006\u0010\u0017\u001a\u00020\u00132\u0006\u0010\r\u001a\u00020\u000e2\u0006\u0010\u0018\u001a\u00020\u0019H\u0082@ø\u0001\u0000¢\u0006\u0002\u0010\u001aR\u000e\u0010\u0002\u001a\u00020\u0003X\u0082\u0004¢\u0006\u0002\n\u0000R\u000e\u0010\u0007\u001a\u00020\bX\u0082\u0004¢\u0006\u0002\n\u0000\u0082\u0002\u0004\n\u0002\b\u0019¨\u0006\u001b"}, d2 = {"Lexpo/modules/imagepicker/exporters/CompressionImageExporter;", "Lexpo/modules/imagepicker/exporters/ImageExporter;", "appContextProvider", "Lexpo/modules/kotlin/providers/AppContextProvider;", "quality", "", "(Lexpo/modules/kotlin/providers/AppContextProvider;D)V", "compressQuality", "", "exportAsync", "Lexpo/modules/imagepicker/exporters/ImageExportResult;", "source", "Landroid/net/Uri;", "output", "Ljava/io/File;", "contentResolver", "Landroid/content/ContentResolver;", "(Landroid/net/Uri;Ljava/io/File;Landroid/content/ContentResolver;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "readBitmap", "Landroid/graphics/Bitmap;", "(Landroid/net/Uri;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "writeImage", "", "bitmap", "compressFormat", "Landroid/graphics/Bitmap$CompressFormat;", "(Landroid/graphics/Bitmap;Ljava/io/File;Landroid/graphics/Bitmap$CompressFormat;Lkotlin/coroutines/Continuation;)Ljava/lang/Object;", "expo-image-picker_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class CompressionImageExporter implements ImageExporter {
    private final AppContextProvider appContextProvider;
    private final int compressQuality;

    public CompressionImageExporter(AppContextProvider appContextProvider, double d) {
        Intrinsics.checkNotNullParameter(appContextProvider, "appContextProvider");
        this.appContextProvider = appContextProvider;
        this.compressQuality = (int) (d * 100);
    }

    /* JADX WARN: Removed duplicated region for block: B:10:0x0026  */
    /* JADX WARN: Removed duplicated region for block: B:18:0x007b  */
    /* JADX WARN: Removed duplicated region for block: B:24:0x00a8 A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:25:0x00a9  */
    /* JADX WARN: Removed duplicated region for block: B:28:0x00bf A[RETURN] */
    /* JADX WARN: Removed duplicated region for block: B:29:0x00c0  */
    @Override // expo.modules.imagepicker.exporters.ImageExporter
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public Object exportAsync(Uri uri, File file, ContentResolver contentResolver, Continuation<? super ImageExportResult> continuation) {
        CompressionImageExporter$exportAsync$1 compressionImageExporter$exportAsync$1;
        Object coroutine_suspended;
        int i;
        CompressionImageExporter compressionImageExporter;
        Bitmap bitmap;
        Bitmap.CompressFormat bitmapCompressFormat;
        Uri uri2;
        Bitmap bitmap2;
        final Bitmap bitmap3;
        final File file2;
        final CompressionImageExporter compressionImageExporter2;
        if (continuation instanceof CompressionImageExporter$exportAsync$1) {
            compressionImageExporter$exportAsync$1 = (CompressionImageExporter$exportAsync$1) continuation;
            if ((compressionImageExporter$exportAsync$1.label & Integer.MIN_VALUE) != 0) {
                compressionImageExporter$exportAsync$1.label -= Integer.MIN_VALUE;
                Object obj = compressionImageExporter$exportAsync$1.result;
                coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = compressionImageExporter$exportAsync$1.label;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    compressionImageExporter$exportAsync$1.L$0 = this;
                    compressionImageExporter$exportAsync$1.L$1 = uri;
                    compressionImageExporter$exportAsync$1.L$2 = file;
                    compressionImageExporter$exportAsync$1.L$3 = contentResolver;
                    compressionImageExporter$exportAsync$1.label = 1;
                    obj = readBitmap(uri, compressionImageExporter$exportAsync$1);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                    compressionImageExporter = this;
                } else if (i != 1) {
                    if (i != 2) {
                        if (i != 3) {
                            throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                        }
                        ResultKt.throwOnFailure(obj);
                        bitmap3 = (Bitmap) compressionImageExporter$exportAsync$1.L$2;
                        file2 = (File) compressionImageExporter$exportAsync$1.L$1;
                        compressionImageExporter2 = (CompressionImageExporter) compressionImageExporter$exportAsync$1.L$0;
                        final int width = bitmap3.getWidth();
                        final int height = bitmap3.getHeight();
                        return new ImageExportResult(file2, width, height) { // from class: expo.modules.imagepicker.exporters.CompressionImageExporter$exportAsync$2
                            @Override // expo.modules.imagepicker.exporters.ImageExportResult
                            public Object data(ContentResolver contentResolver2, Continuation<? super ByteArrayOutputStream> continuation2) {
                                int i2;
                                ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                                Bitmap bitmap4 = bitmap3;
                                Bitmap.CompressFormat compressFormat = Bitmap.CompressFormat.JPEG;
                                i2 = compressionImageExporter2.compressQuality;
                                bitmap4.compress(compressFormat, i2, byteArrayOutputStream);
                                return byteArrayOutputStream;
                            }
                        };
                    }
                    bitmap2 = (Bitmap) compressionImageExporter$exportAsync$1.L$4;
                    File file3 = (File) compressionImageExporter$exportAsync$1.L$2;
                    ResultKt.throwOnFailure(obj);
                    uri2 = (Uri) compressionImageExporter$exportAsync$1.L$1;
                    compressionImageExporter = (CompressionImageExporter) compressionImageExporter$exportAsync$1.L$0;
                    contentResolver = (ContentResolver) compressionImageExporter$exportAsync$1.L$3;
                    file = file3;
                    compressionImageExporter$exportAsync$1.L$0 = compressionImageExporter;
                    compressionImageExporter$exportAsync$1.L$1 = file;
                    compressionImageExporter$exportAsync$1.L$2 = bitmap2;
                    compressionImageExporter$exportAsync$1.L$3 = null;
                    compressionImageExporter$exportAsync$1.L$4 = null;
                    compressionImageExporter$exportAsync$1.label = 3;
                    if (ImagePickerUtilsKt.copyExifData(uri2, file, contentResolver, compressionImageExporter$exportAsync$1) != coroutine_suspended) {
                        return coroutine_suspended;
                    }
                    bitmap3 = bitmap2;
                    file2 = file;
                    compressionImageExporter2 = compressionImageExporter;
                    final int width2 = bitmap3.getWidth();
                    final int height2 = bitmap3.getHeight();
                    return new ImageExportResult(file2, width2, height2) { // from class: expo.modules.imagepicker.exporters.CompressionImageExporter$exportAsync$2
                        @Override // expo.modules.imagepicker.exporters.ImageExportResult
                        public Object data(ContentResolver contentResolver2, Continuation<? super ByteArrayOutputStream> continuation2) {
                            int i2;
                            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                            Bitmap bitmap4 = bitmap3;
                            Bitmap.CompressFormat compressFormat = Bitmap.CompressFormat.JPEG;
                            i2 = compressionImageExporter2.compressQuality;
                            bitmap4.compress(compressFormat, i2, byteArrayOutputStream);
                            return byteArrayOutputStream;
                        }
                    };
                } else {
                    contentResolver = (ContentResolver) compressionImageExporter$exportAsync$1.L$3;
                    file = (File) compressionImageExporter$exportAsync$1.L$2;
                    uri = (Uri) compressionImageExporter$exportAsync$1.L$1;
                    compressionImageExporter = (CompressionImageExporter) compressionImageExporter$exportAsync$1.L$0;
                    ResultKt.throwOnFailure(obj);
                }
                bitmap = (Bitmap) obj;
                bitmapCompressFormat = ImagePickerUtilsKt.toBitmapCompressFormat(file);
                compressionImageExporter$exportAsync$1.L$0 = compressionImageExporter;
                compressionImageExporter$exportAsync$1.L$1 = uri;
                compressionImageExporter$exportAsync$1.L$2 = file;
                compressionImageExporter$exportAsync$1.L$3 = contentResolver;
                compressionImageExporter$exportAsync$1.L$4 = bitmap;
                compressionImageExporter$exportAsync$1.label = 2;
                if (compressionImageExporter.writeImage(bitmap, file, bitmapCompressFormat, compressionImageExporter$exportAsync$1) != coroutine_suspended) {
                    return coroutine_suspended;
                }
                uri2 = uri;
                bitmap2 = bitmap;
                compressionImageExporter$exportAsync$1.L$0 = compressionImageExporter;
                compressionImageExporter$exportAsync$1.L$1 = file;
                compressionImageExporter$exportAsync$1.L$2 = bitmap2;
                compressionImageExporter$exportAsync$1.L$3 = null;
                compressionImageExporter$exportAsync$1.L$4 = null;
                compressionImageExporter$exportAsync$1.label = 3;
                if (ImagePickerUtilsKt.copyExifData(uri2, file, contentResolver, compressionImageExporter$exportAsync$1) != coroutine_suspended) {
                }
            }
        }
        compressionImageExporter$exportAsync$1 = new CompressionImageExporter$exportAsync$1(this, continuation);
        Object obj2 = compressionImageExporter$exportAsync$1.result;
        coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = compressionImageExporter$exportAsync$1.label;
        if (i != 0) {
        }
        bitmap = (Bitmap) obj2;
        bitmapCompressFormat = ImagePickerUtilsKt.toBitmapCompressFormat(file);
        compressionImageExporter$exportAsync$1.L$0 = compressionImageExporter;
        compressionImageExporter$exportAsync$1.L$1 = uri;
        compressionImageExporter$exportAsync$1.L$2 = file;
        compressionImageExporter$exportAsync$1.L$3 = contentResolver;
        compressionImageExporter$exportAsync$1.L$4 = bitmap;
        compressionImageExporter$exportAsync$1.label = 2;
        if (compressionImageExporter.writeImage(bitmap, file, bitmapCompressFormat, compressionImageExporter$exportAsync$1) != coroutine_suspended) {
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    /* JADX WARN: Removed duplicated region for block: B:10:0x0024  */
    /* JADX WARN: Removed duplicated region for block: B:14:0x0032  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final Object readBitmap(Uri uri, Continuation<? super Bitmap> continuation) {
        CompressionImageExporter$readBitmap$1 compressionImageExporter$readBitmap$1;
        int i;
        if (continuation instanceof CompressionImageExporter$readBitmap$1) {
            compressionImageExporter$readBitmap$1 = (CompressionImageExporter$readBitmap$1) continuation;
            if ((compressionImageExporter$readBitmap$1.label & Integer.MIN_VALUE) != 0) {
                compressionImageExporter$readBitmap$1.label -= Integer.MIN_VALUE;
                Object obj = compressionImageExporter$readBitmap$1.result;
                Object coroutine_suspended = IntrinsicsKt.getCOROUTINE_SUSPENDED();
                i = compressionImageExporter$readBitmap$1.label;
                if (i != 0) {
                    ResultKt.throwOnFailure(obj);
                    compressionImageExporter$readBitmap$1.label = 1;
                    obj = InterruptibleKt.runInterruptible$default(null, new CompressionImageExporter$readBitmap$2(this, uri), compressionImageExporter$readBitmap$1, 1, null);
                    if (obj == coroutine_suspended) {
                        return coroutine_suspended;
                    }
                } else if (i != 1) {
                    throw new IllegalStateException("call to 'resume' before 'invoke' with coroutine");
                } else {
                    ResultKt.throwOnFailure(obj);
                }
                Intrinsics.checkNotNullExpressionValue(obj, "private suspend fun read…oFile(), cause)\n    }\n  }");
                return obj;
            }
        }
        compressionImageExporter$readBitmap$1 = new CompressionImageExporter$readBitmap$1(this, continuation);
        Object obj2 = compressionImageExporter$readBitmap$1.result;
        Object coroutine_suspended2 = IntrinsicsKt.getCOROUTINE_SUSPENDED();
        i = compressionImageExporter$readBitmap$1.label;
        if (i != 0) {
        }
        Intrinsics.checkNotNullExpressionValue(obj2, "private suspend fun read…oFile(), cause)\n    }\n  }");
        return obj2;
    }

    /* JADX INFO: Access modifiers changed from: private */
    public final Object writeImage(Bitmap bitmap, File file, Bitmap.CompressFormat compressFormat, Continuation<? super Boolean> continuation) {
        return InterruptibleKt.runInterruptible$default(null, new CompressionImageExporter$writeImage$2(file, bitmap, compressFormat, this), continuation, 1, null);
    }
}
