package expo.modules.imagepicker.exporters;

import android.content.ContentResolver;
import android.net.Uri;
import android.os.Bundle;
import androidx.exifinterface.media.ExifInterface;
import expo.modules.imagepicker.FailedToReadFileException;
import expo.modules.imagepicker.ImagePickerConstants;
import java.io.File;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import kotlin.Metadata;
import kotlin.Pair;
import kotlin.io.CloseableKt;
import kotlin.jvm.functions.Function0;
import kotlin.jvm.internal.Intrinsics;
import kotlin.jvm.internal.Lambda;
/* JADX INFO: Access modifiers changed from: package-private */
/* compiled from: ImageExporter.kt */
@Metadata(d1 = {"\u0000\b\n\u0000\n\u0002\u0018\u0002\n\u0000\u0010\u0000\u001a\u00020\u0001H\n¢\u0006\u0002\b\u0002"}, d2 = {"<anonymous>", "Landroid/os/Bundle;", "invoke"}, k = 3, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class ImageExportResult$exif$2 extends Lambda implements Function0<Bundle> {
    final /* synthetic */ ContentResolver $contentResolver;
    final /* synthetic */ ImageExportResult this$0;

    /* JADX INFO: Access modifiers changed from: package-private */
    /* JADX WARN: 'super' call moved to the top of the method (can break code semantics) */
    public ImageExportResult$exif$2(ContentResolver contentResolver, ImageExportResult imageExportResult) {
        super(0);
        this.$contentResolver = contentResolver;
        this.this$0 = imageExportResult;
    }

    /* JADX WARN: Can't rename method to resolve collision */
    @Override // kotlin.jvm.functions.Function0
    public final Bundle invoke() {
        File file;
        File file2;
        ContentResolver contentResolver = this.$contentResolver;
        file = this.this$0.imageFile;
        Uri fromFile = Uri.fromFile(file);
        Intrinsics.checkNotNullExpressionValue(fromFile, "fromFile(this)");
        InputStream openInputStream = contentResolver.openInputStream(fromFile);
        if (openInputStream == null) {
            file2 = this.this$0.imageFile;
            throw new FailedToReadFileException(file2, null, 2, null);
        }
        InputStream inputStream = openInputStream;
        try {
            Bundle bundle = new Bundle();
            ExifInterface exifInterface = new ExifInterface(inputStream);
            Iterable<Pair<String, String>> exif_tags = ImagePickerConstants.INSTANCE.getEXIF_TAGS();
            ArrayList<Pair> arrayList = new ArrayList();
            Iterator<Pair<String, String>> it = exif_tags.iterator();
            while (true) {
                boolean z = true;
                if (!it.hasNext()) {
                    break;
                }
                Pair<String, String> next = it.next();
                if (exifInterface.getAttribute(next.component2()) == null) {
                    z = false;
                }
                if (z) {
                    arrayList.add(next);
                }
            }
            for (Pair pair : arrayList) {
                String str = (String) pair.component1();
                String str2 = (String) pair.component2();
                int hashCode = str.hashCode();
                if (hashCode != -1325958191) {
                    if (hashCode != -891985903) {
                        if (hashCode == 104431 && str.equals("int")) {
                            bundle.putInt(str2, exifInterface.getAttributeInt(str2, 0));
                        }
                    } else if (str.equals("string")) {
                        bundle.putString(str2, exifInterface.getAttribute(str2));
                    }
                } else if (str.equals("double")) {
                    bundle.putDouble(str2, exifInterface.getAttributeDouble(str2, 0.0d));
                }
            }
            double[] latLong = exifInterface.getLatLong();
            if (latLong != null) {
                bundle.putDouble(ExifInterface.TAG_GPS_LATITUDE, latLong[0]);
                bundle.putDouble(ExifInterface.TAG_GPS_LONGITUDE, latLong[1]);
                bundle.putDouble(ExifInterface.TAG_GPS_ALTITUDE, exifInterface.getAltitude(0.0d));
            }
            CloseableKt.closeFinally(inputStream, null);
            return bundle;
        } finally {
        }
    }
}
