package expo.modules.notifications.badge;

import android.content.Context;
import android.util.Log;
import expo.modules.core.interfaces.SingletonModule;
import expo.modules.notifications.badge.interfaces.BadgeManager;
import me.leolin.shortcutbadger.ShortcutBadgeException;
import me.leolin.shortcutbadger.ShortcutBadger;
/* loaded from: classes3.dex */
public class ExpoBadgeManager implements SingletonModule, BadgeManager {
    private static final String SINGLETON_NAME = "BadgeManager";
    private int mBadgeCount = 0;
    private Context mContext;

    @Override // expo.modules.core.interfaces.SingletonModule
    public String getName() {
        return SINGLETON_NAME;
    }

    public ExpoBadgeManager(Context context) {
        this.mContext = context;
    }

    @Override // expo.modules.notifications.badge.interfaces.BadgeManager
    public int getBadgeCount() {
        return this.mBadgeCount;
    }

    @Override // expo.modules.notifications.badge.interfaces.BadgeManager
    public boolean setBadgeCount(int i) {
        try {
            ShortcutBadger.applyCountOrThrow(this.mContext.getApplicationContext(), i);
            this.mBadgeCount = i;
            return true;
        } catch (ShortcutBadgeException e) {
            Log.d("expo-notifications", "Could not have set badge count: " + e.getMessage());
            e.printStackTrace();
            return false;
        }
    }
}
