package expo.modules.systemui.singletons;

import android.os.Build;
import androidx.appcompat.app.AppCompatDelegate;
import expo.modules.devlauncher.launcher.manifest.DevLauncherUserInterface;
import io.sentry.clientreport.DiscardedEvent;
import kotlin.Metadata;
import kotlin.Unit;
import kotlin.jvm.JvmStatic;
import kotlin.jvm.functions.Function0;
import kotlin.jvm.functions.Function1;
import kotlin.jvm.internal.Intrinsics;
/* compiled from: SystemUI.kt */
@Metadata(d1 = {"\u0000,\n\u0002\u0018\u0002\n\u0002\u0010\u0000\n\u0002\b\u0002\n\u0002\u0010\u000e\n\u0000\n\u0002\u0010\u0002\n\u0002\b\u0002\n\u0002\u0018\u0002\n\u0000\n\u0002\u0018\u0002\n\u0002\u0018\u0002\n\u0002\b\u0003\bÆ\u0002\u0018\u00002\u00020\u0001B\u0007\b\u0002¢\u0006\u0002\u0010\u0002J\u0010\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0007\u001a\u00020\u0004H\u0007J?\u0010\u0005\u001a\u00020\u00062\u0006\u0010\u0007\u001a\u00020\u00042\f\u0010\b\u001a\b\u0012\u0004\u0012\u00020\u00060\t2!\u0010\n\u001a\u001d\u0012\u0013\u0012\u00110\u0004¢\u0006\f\b\f\u0012\b\b\r\u0012\u0004\b\b(\u000e\u0012\u0004\u0012\u00020\u00060\u000bR\u000e\u0010\u0003\u001a\u00020\u0004X\u0082T¢\u0006\u0002\n\u0000¨\u0006\u000f"}, d2 = {"Lexpo/modules/systemui/singletons/SystemUI;", "", "()V", "TAG", "", "setUserInterfaceStyle", "", "style", "successCallback", "Lkotlin/Function0;", "failureCallback", "Lkotlin/Function1;", "Lkotlin/ParameterName;", "name", DiscardedEvent.JsonKeys.REASON, "expo-system-ui_release"}, k = 1, mv = {1, 7, 1}, xi = 48)
/* loaded from: classes3.dex */
public final class SystemUI {
    public static final SystemUI INSTANCE = new SystemUI();
    private static final String TAG = "SystemUI";

    private SystemUI() {
    }

    /* JADX WARN: Code restructure failed: missing block: B:18:0x003d, code lost:
        if (r3.equals(expo.modules.devlauncher.launcher.manifest.DevLauncherUserInterface.LIGHT) == false) goto L18;
     */
    /* JADX WARN: Code restructure failed: missing block: B:25:0x0051, code lost:
        if (r3.equals("") == false) goto L18;
     */
    /* JADX WARN: Code restructure failed: missing block: B:28:0x006a, code lost:
        r3 = 1;
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final void setUserInterfaceStyle(String style, Function0<Unit> successCallback, Function1<? super String, Unit> failureCallback) {
        int i;
        Intrinsics.checkNotNullParameter(style, "style");
        Intrinsics.checkNotNullParameter(successCallback, "successCallback");
        Intrinsics.checkNotNullParameter(failureCallback, "failureCallback");
        int hashCode = style.hashCode();
        if (hashCode != 0) {
            if (hashCode != 3075958) {
                if (hashCode != 102970646) {
                    if (hashCode == 1673671211 && style.equals(DevLauncherUserInterface.AUTOMATIC)) {
                        i = Build.VERSION.SDK_INT < 28 ? 3 : -1;
                    }
                }
                failureCallback.invoke("Invalid user interface style: \"" + style + "\"");
                return;
            }
            if (style.equals(DevLauncherUserInterface.DARK)) {
                i = 2;
            }
            failureCallback.invoke("Invalid user interface style: \"" + style + "\"");
            return;
        }
        AppCompatDelegate.setDefaultNightMode(i);
        successCallback.invoke();
    }

    @JvmStatic
    public static final void setUserInterfaceStyle(String style) {
        Intrinsics.checkNotNullParameter(style, "style");
        INSTANCE.setUserInterfaceStyle(style, SystemUI$setUserInterfaceStyle$1.INSTANCE, SystemUI$setUserInterfaceStyle$2.INSTANCE);
    }
}
