package io.sentry;

import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;
/* loaded from: classes3.dex */
public final class FullDisplayedReporter {
    private static final FullDisplayedReporter instance = new FullDisplayedReporter();
    private final List<FullDisplayedReporterListener> listeners = new CopyOnWriteArrayList();

    /* loaded from: classes3.dex */
    public interface FullDisplayedReporterListener {
        void onFullyDrawn();
    }

    private FullDisplayedReporter() {
    }

    public static FullDisplayedReporter getInstance() {
        return instance;
    }

    public void registerFullyDrawnListener(FullDisplayedReporterListener fullDisplayedReporterListener) {
        this.listeners.add(fullDisplayedReporterListener);
    }

    public void reportFullyDrawn() {
        this.listeners.clear();
        for (FullDisplayedReporterListener fullDisplayedReporterListener : this.listeners) {
            fullDisplayedReporterListener.onFullyDrawn();
        }
    }
}
